local songName= GAMESTATE:GetCurrentSong():GetSongDir()

local tileObjects = {}

P1 = nil;
P2 = nil;

local hstrips = 11
local vstrips = 9

local sw = SCREEN_WIDTH
local sh = SCREEN_HEIGHT
local tiles = {}
local tiles2d = {}

local tskm = 0.225;

local function ayaze_mod_internal(str, pn)
	local ps= GAMESTATE:GetPlayerState(pn)
	local pmods= ps:GetPlayerOptionsString('ModsLevel_Song')
	ps:SetPlayerOptions('ModsLevel_Song', pmods .. ', ' .. str)
	--GAMESTATE:ApplyGameCommand('mod,'..str, pn)
end

local function ayaze_mod(str)
	for i=1,2 do
		ayaze_mod_internal(str, 'PlayerNumber_P' .. i)
	end
end

local function get_speed_from_poptions(player_number)
	if GAMESTATE:IsPlayerEnabled(player_number) then
		local poptionsray= GAMESTATE:GetPlayerState(player_number):GetPlayerOptionsArray("ModsLevel_Song")
		local speed= nil
		local mode= nil
		for i, el in ipairs(poptionsray) do
			local fel= el:sub(1, 1)
			local lel= el:sub(-1)
			if fel == "m" or fel == "C" then
				speed= tonumber(el:sub(2))
				mode= fel
			elseif lel == "x" then
				speed= tonumber(el:sub(1, -2))
				mode= lel
			end
			if speed and mode then
				break
			end
		end
	end
	if not speed or not mode then
		speed= 2
		mode= "x"
	end
	return { speed= speed, mode= mode }
end

local function set_player_speed(player_number, speed_info)
	if not GAMESTATE:IsPlayerEnabled(player_number) then return end
	local mode_functions= {
		x= function(speed)
				 ayaze_mod_internal(("*1000 %.2f"):format(speed).."x", player_number)
			 end,
		C= function(speed)
				 ayaze_mod_internal("*1000 C"..("%.0f"):format(speed), player_number)
			 end,
		m= function(speed)
				 local max_bpm= GAMESTATE:GetCurrentSteps(pn):GetDisplayBpms()[2]
				 local real_speed= (speed / max_bpm)
				 -- Setting an mmod while on ScreenGameplay doesn't actually work, due to the way mmods are implemented in the engine. So set the equivalent xmod
				 ayaze_mod_internal(("*1000 %.2f"):format(real_speed).."x", player_number)
			 end
	}
	mode_functions[speed_info.mode](speed_info.speed)
end

function simple_m0d(beat,strength,mult,mod,pn)
	if not strength then strength = 400 end
	if not mult then mult = 1 end
	if not mod then mod = 'drunk' end
	
	local alive = math.max(2*mult*math.abs(strength)/100,0.25)
	
	table.insert(mods,{beat,'*100000 '..strength..' '..mod,pn});
	table.insert(mods,{beat+.1,'*'..((1/mult)*math.abs(strength)/100)..' no '..mod,pn});
end
			
--alternates a mod back and forth before resetting to 0
--beat,num,div,amt,mod,pn
function mod_wiggle(beat,num,div,amt,mod,pn,first)
	local fluct = 1
	for i=0,(num-1) do
		b = beat+(i/div)
		local m = 1
		if i==0 and not first then m = 0.5 end
		table.insert(mods,{b,'*'..math.abs(m*amt/10)..' '..(amt*fluct)..' '..mod..'',pn});
		fluct = fluct*-1;
	end
	table.insert(mods,{beat+(num/div),'*'..math.abs(amt/20)..' no '..mod..'',pn});
end

local function ayaze_init()
	checked = false;
	
	ayaze_diffP1 = -1;
	ayaze_diffP2 = -1;
	
	if GAMESTATE:IsPlayerEnabled(PLAYER_1) then
		ayaze_diffP1 = Difficulty:Reverse()[GAMESTATE:GetCurrentSteps(PLAYER_1):GetDifficulty()]
	end
	if GAMESTATE:IsPlayerEnabled(PLAYER_2) then
		ayaze_diffP2 = Difficulty:Reverse()[GAMESTATE:GetCurrentSteps(PLAYER_2):GetDifficulty()]
	end
	
	ayaze_speedmodP1 = get_speed_from_poptions(PLAYER_1)
	ayaze_speedmodP2 = get_speed_from_poptions(PLAYER_2)
	
	fgcurcommand = 1;
	checked = false;
	
	ayaze_finalEvent = false;
			
	mod_firstSeenBeat = GAMESTATE:GetSongBeat()
			
--how can I make simple m0d?
--this will instantly turn a mod on to max and then quickly turn it off with the specified parameters
--it's a simple mod

function simple_m0d(beat,strength,mult,mod,pn)
	if not strength then strength = 400 end
	if not mult then mult = 1 end
	if not mod then mod = 'drunk' end
	
	local alive = math.max(2*mult*math.abs(strength)/100,0.25)
	
	table.insert(mods,{beat,'*100000 '..strength..' '..mod,pn});
	table.insert(mods,{beat+.1,'*'..((1/mult)*math.abs(strength)/100)..' no '..mod,pn});
end
			
--alternates a mod back and forth before resetting to 0
--beat,num,div,amt,mod,pn
function mod_wiggle(beat,num,div,amt,mod,pn,first)
	local fluct = 1
	for i=0,(num-1) do
		b = beat+(i/div)
		local m = 1
		if i==0 and not first then m = 0.5 end
		table.insert(mods,{b,'*'..math.abs(m*amt/10)..' '..(amt*fluct)..' '..mod..'',pn});
		fluct = fluct*-1;
	end
	table.insert(mods,{beat+(num/div),'*'..math.abs(amt/20)..' no '..mod..'',pn});
end
			
--lua course :D
curmod = 1;
--{beat,mod,player}
mods = {

{132,'*1 drunk'},
{139,'*5 no drunk'},
{140,'*1 -100 drunk'},
{148,'*2 no drunk'},

{160,'*0.5 50 drunk'},
{192,'*0.5 100 drunk'},
{219,'*2 no drunk'},

{224,'*1 drunk'},
{231,'*5 no drunk'},
{232,'*1 -100 drunk'},
{240,'*2 no drunk'},

}

local s = char_ayaze;
--ayaze got tha moves
ayaze_curaction = 1;
--{beat,action,persist}
ayaze_actions = {
	
	{160,function() MESSAGEMAN:Broadcast('Spell1'); end},
	{192,function() MESSAGEMAN:Broadcast('Spell2'); end},
	{194,function() MESSAGEMAN:Broadcast('Spell3'); end},
	
	{1,function()	
		s:x(sw/2)
		s:y(sh/2)
		s:playcommand('Spawn');
	end},
	{16,function()
		s:playcommand('Attack');
	end},
	{51,function()
		AyaSound('spell');
	end},
	{51.5,function()
		s:playcommand('Cast');
	end},
	{66,function()
		s:playcommand('Hide');
	end},
	{100,function()
		s:playcommand('Hide');
	end},
	{130,function()
		s:playcommand('Spawn');
		s:playcommand('Idle');
	end},
	{132,function()
		s:playcommand('Attack');
	end},
	{150.5,function()
		AyaSound('spell');
	end},
	{151,function()
		s:playcommand('Cast');
	end},
	{160,function()
		s:playcommand('Attack');
	end},
	{176,function()
		s:playcommand('Idle');
	end},
	{192,function()
		s:playcommand('Attack');
	end},
	{208,function()
		s:playcommand('Idle');
	end},
	{224,function()
		s:playcommand('Attack');
	end},
	{242.5,function()
		AyaSound('spell');
	end},
	{243,function()
		s:playcommand('Cast');
	end},
	{248,function()
		s:playcommand('Attack');
	end},
	{218.5,function() AyaSound('hurt') end},
	{219,function()
		MESSAGEMAN:Broadcast('RedFlashQ');
		char_ayaze:playcommand('SpawnQ');
		char_ayaze:playcommand('Hurt');
		char_ayaze:decelerate(120/190);
		char_ayaze:rotationy(360);
		char_ayaze:sleep(0)
		char_ayaze:rotationy(0);
	end},
	{328,function()
		char_ayaze:playcommand('Hurt');
		char_ayaze:x(SCREEN_CENTER_X);
		char_ayaze:y(SCREEN_CENTER_Y);
		char_ayaze:sleep(0);
		char_ayaze:decelerate(480/190);
		char_ayaze:rotationy(5*360);
		char_ayaze:accelerate(240/190);
		char_ayaze:zoomy(0);
		char_ayaze:zoomx(2);
		char_ayaze:sleep(0);
		char_ayaze:rotationy(0);
	end},
	{275.5,function() AyaSound('hurt') end},
	{276,function()
		MESSAGEMAN:Broadcast('RedFlashQ');
		char_ayaze:playcommand('SpawnQ');
		char_ayaze:playcommand('Hurt');
		char_ayaze:decelerate(120/190);
		char_ayaze:rotationy(360);
		char_ayaze:sleep(0)
		char_ayaze:rotationy(0);
	end},
	{280,function()
		s:playcommand('Attack');
	end},
	{303.5,function()
		AyaSound('spell');
	end},
	{304,function()
		s:playcommand('Cast');
		s:playcommand('Attack');
	end},
}


curaction = 1;
--{beat,action,persist}
actions = {
	{1,function()
		if P1 then P1:visible(false) end
		if P2 then P2:visible(false) end
	end},
	{16,function()
		MESSAGEMAN:Broadcast('WhiteFlash');
		for j=1,table.getn(tiles2d) do
			for i=1,table.getn(tiles2d[j]) do
				if j%2 == 0 and i%2 == 1 or j%2 == 1 and i%2 == 0 then
					tiles2d[j][i]:linear(31.5*(60/190))
					--tiles2d[j][i]:rotationz(-7.875*360)
				else
					tiles2d[j][i]:linear(31.5*(60/190))
					--tiles2d[j][i]:rotationz(7.875*360)
				end
				tiles2d[j][i]:vibrate()
				tiles2d[j][i]:effectmagnitude(0,0,0)
			end
		end
		ayaze_vibquad:linear(31.5*(60/190))
		ayaze_vibquad:x(20);
	end},
	{47.5,function()
		MESSAGEMAN:Broadcast('WhiteFlash');
		for j=1,table.getn(tiles2d) do
			for i=1,table.getn(tiles2d[j]) do
				if j%2 == 0 and i%2 == 1 or j%2 == 1 and i%2 == 0 then
					tiles2d[j][i]:addrotationz(45)
				else
					tiles2d[j][i]:addrotationz(45)
				end
				tiles2d[j][i]:stopeffect()
			end
		end
	end},
	{48.5,function()
		for j=1,table.getn(tiles2d) do
			for i=1,table.getn(tiles2d[j]) do
				if j%2 == 0 and i%2 == 1 or j%2 == 1 and i%2 == 0 then
					tiles2d[j][i]:addrotationz(90)
				else
					tiles2d[j][i]:addrotationz(90)
				end
			end
		end
	end},
	{49.5,function()
		for j=1,table.getn(tiles2d) do
			for i=1,table.getn(tiles2d[j]) do
				if j%2 == 0 and i%2 == 1 or j%2 == 1 and i%2 == 0 then
					tiles2d[j][i]:addrotationz(90)
				else
					tiles2d[j][i]:addrotationz(90)
				end
			end
		end
	end},
	{50.5,function()
		for j=1,table.getn(tiles2d) do
			for i=1,table.getn(tiles2d[j]) do
				if j%2 == 0 and i%2 == 1 or j%2 == 1 and i%2 == 0 then
					tiles2d[j][i]:addrotationz(90)
				else
					tiles2d[j][i]:addrotationz(90)
				end
			end
		end
	end},
	{51.5,function()
		for j=1,table.getn(tiles2d) do
			for i=1,table.getn(tiles2d[j]) do
				tiles2d[j][i]:decelerate(2);
				if j%2 == 0 and i%2 == 1 or j%2 == 1 and i%2 == 0 then
					tiles2d[j][i]:addrotationz(45)
				else
					tiles2d[j][i]:addrotationz(45)
				end
				tiles2d[j][i]:sleep(0);
				tiles2d[j][i]:rotationz(0);
			end
		end
	end},
	{68,function()
		MESSAGEMAN:Broadcast('WhiteFlash');
		for j=1,table.getn(tiles2d) do
			for i=1,table.getn(tiles2d[j]) do
				tiles2d[j][i]:bob()
				tiles2d[j][i]:effectmagnitude(0,-30,0)
				tiles2d[j][i]:effectclock('bgm')
				tiles2d[j][i]:effectperiod(4)
				tiles2d[j][i]:effectoffset(i/(11/hstrips))
			end
		end
	end},
	{99,function()
		MESSAGEMAN:Broadcast('WhiteFlash');
		for i=1,table.getn(tiles) do
			tiles[i]:stopeffect()
		end
	end},
	{100,function()
		MESSAGEMAN:Broadcast('WhiteFlash');
		for j=1,table.getn(tiles2d) do
			for i=1,table.getn(tiles2d[j]) do
				tiles2d[j][i]:bob()
				tiles2d[j][i]:effectmagnitude(30,0,0)
				tiles2d[j][i]:effectclock('bgm')
				tiles2d[j][i]:effectperiod(4)
				tiles2d[j][i]:effectoffset(j/(9/vstrips))
			end
		end
	end},
	{131,function()
		MESSAGEMAN:Broadcast('WhiteFlash');
		for i=1,table.getn(tiles) do
			tiles[i]:stopeffect()
		end
	end},
	{132,function()
		for i=1,table.getn(tiles) do
			tiles[i]:accelerate(8*(60/190))
			--tiles[i]:addrotationz(math.random(0,90))
			--tiles[i]:addrotationy(math.random(0,90))
			--tiles[i]:addrotationx(math.random(0,90))
			tiles[i]:addx(0.5*(-(sw/16)+math.random(sw/8)))
			tiles[i]:addy(0.5*(-(sh/12)+math.random(sh/6)))
		end
	end},
	{140,function()
		for i=1,table.getn(tiles) do
			tiles[i]:accelerate(8*(60/190))
			--tiles[i]:addrotationz(math.random(0,90))
			--tiles[i]:addrotationy(math.random(0,90))
			--tiles[i]:addrotationx(math.random(0,90))
			tiles[i]:addx(0.5*(-(sw/16)+math.random(sw/8)))
			tiles[i]:addy(0.5*(-(sh/12)+math.random(sh/6)))
		end
	end},
	{148,function()
		for i=1,table.getn(tiles) do
			tiles[i]:decelerate(3*(60/190))
			--tiles[i]:rotationz(0)
			--tiles[i]:rotationy(0)
			--tiles[i]:rotationx(0)
			tiles[i]:x(tileObjects[i].OrigX)
			tiles[i]:y(tileObjects[i].OrigY)
		end
	end},
	{160,function()
		for j=1,table.getn(tiles2d) do
			for i=1,table.getn(tiles2d[j]) do
				tiles2d[j][i]:linear(1)
				if j%2 == 0 then
					tiles2d[j][i]:skewx(0.3)
					tiles2d[j][i]:addx((j-(vstrips/2))*-60*tskm)
				else
					tiles2d[j][i]:skewx(-0.3)
					tiles2d[j][i]:addx((j-(vstrips/2))*60*tskm)
				end
				tiles2d[j][i]:diffuse(.9,.6,.6,1);
			end
		end
	end},
	{192,function()
		for j=1,table.getn(tiles2d) do
			for i=1,table.getn(tiles2d[j]) do
				tiles2d[j][i]:linear(1)
				if j%2 == 0 then
					tiles2d[j][i]:skewx(.8)
					tiles2d[j][i]:addx((j-(vstrips/2))*-80*tskm)
				else
					tiles2d[j][i]:skewx(-.8)
					tiles2d[j][i]:addx((j-(vstrips/2))*80*tskm)
				end
				tiles2d[j][i]:diffuse(.8,.2,.2,1);
			end
		end
	end},
	{219,function()
		for i=1,table.getn(tiles) do
			tiles[i]:decelerate(5*(60/190))
			tiles[i]:skewx(0);
			tiles[i]:x(tileObjects[i].OrigX)
			tiles[i]:diffuse(1,1,1,1);
		end
	end},		
	{224,function()
		for i=1,table.getn(tiles) do
			tiles[i]:accelerate(8*(60/190))
			tiles[i]:addrotationz(-30+math.random(0,60))
			tiles[i]:addrotationy(-30+math.random(0,60))
			tiles[i]:addrotationx(-30+math.random(0,60))
			tiles[i]:addx(0.5*(-(sw/16)+math.random(sw/8)))
			tiles[i]:addy(0.5*(-(sh/12)+math.random(sh/6)))
		end
	end},
	{232,function()
		for i=1,table.getn(tiles) do
			tiles[i]:accelerate(8*(60/190))
			tiles[i]:addrotationz(-30+math.random(0,60))
			tiles[i]:addrotationy(-30+math.random(0,60))
			tiles[i]:addrotationx(-30+math.random(0,60))
			tiles[i]:addx(0.5*(-(sw/16)+math.random(sw/8)))
			tiles[i]:addy(0.5*(-(sh/12)+math.random(sh/6)))
		end
	end},
	{240,function()
		for i=1,table.getn(tiles) do
			tiles[i]:decelerate(3*(60/190))
			tiles[i]:rotationz(0)
			tiles[i]:rotationy(0)
			tiles[i]:rotationx(0)
			tiles[i]:x(tileObjects[i].OrigX)
			tiles[i]:y(tileObjects[i].OrigY)
		end
	end},
	{248,function()
		MESSAGEMAN:Broadcast('FUCK');
	end},
	{276,function()
		for j=1,table.getn(tiles2d) do
			for i=1,table.getn(tiles2d[j]) do
				if j%2 == 0 then
					tiles2d[j][i]:sleep((i/table.getn(tiles2d[j]))*(170/190))
					tiles2d[j][i]:linear(60/190)
					tiles2d[j][i]:rotationx(180)
				end
			end
		end
	end},
	{328,function()
		MESSAGEMAN:Broadcast('WhiteFlashLong');
		for i=1,table.getn(tiles) do
			tiles[i]:sleep((i/table.getn(tiles))*(170/190))
			tiles[i]:decelerate(9*(60/190))
			tiles[i]:x(tileObjects[i].OrigX)
			tiles[i]:y(tileObjects[i].OrigY)
			tiles[i]:rotationx(-360*3)
		end
	end},
}

--SCREAMING GUMBALL
curmessage = 1;
--{beat,message,{params},persist?}
messages = {
}


	function modtable_compare(a,b)
		return a[1] < b[1]
	end
	
	if table.getn(mods) > 1 then
		table.sort(mods, modtable_compare)
	end
	
	if table.getn(messages) > 1 then
		table.sort(messages, modtable_compare)
	end
	
	if table.getn(actions) > 1 then
		table.sort(actions, modtable_compare)
	end
	
	if table.getn(ayaze_actions) > 1 then
		table.sort(ayaze_actions, modtable_compare)
	end
	
end

local function ayaze_update(self, delta)

	if GAMESTATE:GetSongBeat()>=0.1 and not checked then
		
		P1 = SCREENMAN:GetTopScreen():GetChild('PlayerP1')
		P2 = SCREENMAN:GetTopScreen():GetChild('PlayerP2')
		
		if SCREENMAN:GetTopScreen():GetChild('ScoreP1') then
			SCREENMAN:GetTopScreen():GetChild('ScoreP1'):visible(false)
		end
		if SCREENMAN:GetTopScreen():GetChild('ScoreP2') then
			SCREENMAN:GetTopScreen():GetChild('ScoreP2'):visible(false)
		end
		
		if SCREENMAN:GetTopScreen():GetChild('Debug') then
			SCREENMAN:GetTopScreen():GetChild('Debug'):y(SCREEN_CENTER_Y-60)
		end

		screen = SCREENMAN:GetTopScreen();
		screen:SetDrawByZPosition(true);
		
		if SCREENMAN:GetTopScreen():GetChild('SongForeground') then
			SCREENMAN:GetTopScreen():GetChild('SongForeground'):z(2)
		end
		
		if P1 then P1:z(1) end
		if P2 then P2:z(1) end
		
		checked = true;
		
	end
	
	local beat = GAMESTATE:GetSongBeat()
	
	local spd = 6;
			
	if beat>304 then spd = 12 end
	
	if beat > 248 and beat<275.5 or beat>280 and beat<328 then
		for j=1,table.getn(tiles2d) do
			for i=1,table.getn(tiles2d[j]) do
				if j%2 == 0 and beat<279 or j%2 == 1 and beat>279 then
					if tiles2d[j][i]:GetX() >= sw then
						tiles2d[j][i]:addx(-sw)
					else
						tiles2d[j][i]:addx(spd*delta*10)
					end
				else
					if tiles2d[j][i]:GetX() <= 0 then
						tiles2d[j][i]:addx(sw)
					else
						tiles2d[j][i]:addx(-spd*delta*10)
					end
				end
			end
		end
	end
	
	if beat>16 and beat<47.5 then
		local vm = ayaze_vibquad:GetX();
		for i=1,table.getn(tiles) do
			tiles[i]:effectmagnitude(vm,vm,vm)
		end
	end
	
	-- Collect all the mods that will be applied in this frame into one string.
	-- Mod tweening doesn't work correctly if the mods are in seperate commands.
	local mods_this_frame= {}
	local function add_mod(mod_str)
		mods_this_frame[#mods_this_frame+1]= mod_str
	end
	local function execute_mods()
		if #mods_this_frame <= 0 then return end
		local total_mod_str= ""
		for i, ms in ipairs(mods_this_frame) do
			if #total_mod_str > 0 then
				total_mod_str= total_mod_str .. ", "
			end
			total_mod_str= total_mod_str .. ms
		end
		ayaze_mod(total_mod_str)
	end
	
	if beat>7 and fgcurcommand==0 then
		if P1 then P1:linear(0.1) P1:x(SCREEN_WIDTH*0.25) end
		if P2 then P2:linear(0.1) P2:x(SCREEN_WIDTH*0.75) end
		fgcurcommand = fgcurcommand+1;
	end
	
	while curmod<= #mods and GAMESTATE:GetSongBeat()>=mods[curmod][1] do
		if table.getn(mods[curmod]) < 3 then
			add_mod(mods[curmod][2])
		else
			ayaze_mod_internal(mods[curmod][2], 'PlayerNumber_P' .. mods[curmod][3])
		end
		curmod = curmod+1
	end

	execute_mods()
	
	
	
	
	
	
	--SCREAMING GUMBALL
	while curmessage<= #messages and GAMESTATE:GetSongBeat()>=messages[curmessage][1] do
		if messages[curmessage][4] and GAMESTATE:GetSongBeat()>=messages[curmessage][1]+5 then
			curmessage = curmessage+1;
		else
			MESSAGEMAN:Broadcast(messages[curmessage][2],messages[curmessage][3])
			curmessage = curmessage+1;
		end
	end
	
	while curaction<= #actions and GAMESTATE:GetSongBeat()>=actions[curaction][1] do
		if actions[curaction][3] and GAMESTATE:GetSongBeat()>=actions[curaction][1]+5 then
			curaction = curaction+1;
		else
			actions[curaction][2]()
			curaction = curaction+1;
		end
	end
	
	while ayaze_curaction<= #ayaze_actions and GAMESTATE:GetSongBeat()>=ayaze_actions[ayaze_curaction][1] do
		if ayaze_actions[ayaze_curaction][3] or GAMESTATE:GetSongBeat() < ayaze_actions[ayaze_curaction][1]+2 then
			ayaze_actions[ayaze_curaction][2]()
		end
		ayaze_curaction = ayaze_curaction+1;
	end
	
end

local t = Def.ActorFrame{
	OnCommand= function(self)
							 ayaze_init()
							 self:SetUpdateFunction(ayaze_update)
							 self:fov(90);
						 end,
	Def.Quad{
		Name= "I may be sleeping, but I preserve the world.",
		InitCommand= cmd(visible,false),
		OnCommand= cmd(sleep,1000),
	},
	Def.Quad{
		InitCommand=function(self) ayaze_vibquad = self end,
		OnCommand= cmd(x,0),
	},
	
}

t[#t+1] = Def.Quad{
	OnCommand=cmd(x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;zoomto,SCREEN_WIDTH,SCREEN_HEIGHT;diffuse,0,0,0,1),
}

t[#t+1] = Def.ActorFrameTexture{
	Name = "ScreenTex";
	InitCommand=function(self)
		self:SetTextureName( "ScreenTex" )
		self:SetWidth(sw);
		self:SetHeight(sh);
		self:EnableAlphaBuffer(true);
		self:Create();
	end;
	OnCommand=function(self)
		self:visible(true);
		self:Draw();
	end;
	Def.Quad{ OnCommand=cmd(x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;zoomto,SCREEN_WIDTH,SCREEN_HEIGHT;diffuse,0,0,0,1), },
	LoadActor("../bg.png")..{
		OnCommand=cmd(x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;zoomto,SCREEN_WIDTH,SCREEN_HEIGHT;diffuse,1,1,1,PREFSMAN:GetPreference('BGBrightness')),
	},
	Def.ActorProxy{ Name = "ProxyUL"; OnCommand=function(self) self:x(0); self:y(0) self:SetTarget(SCREENMAN:GetTopScreen():GetChild('Underlay')); end },
	Def.ActorProxy{ Name = "ProxyP1"; OnCommand=function(self) self:x(0); self:y(0)
		if SCREENMAN:GetTopScreen():GetChild('PlayerP1') then
			self:SetTarget(SCREENMAN:GetTopScreen():GetChild('PlayerP1'));
		else
			self:SetTarget(SCREENMAN:GetTopScreen():GetChild('PlayerP2'));
			SCREENMAN:GetTopScreen():GetChild('PlayerP2'):x(SCREEN_WIDTH*0.25);
			self:addx(SCREEN_WIDTH*0.5);
		end
	end },
	Def.ActorProxy{ Name = "ProxyP2"; OnCommand=function(self) self:x(0); self:y(0)
		if SCREENMAN:GetTopScreen():GetChild('PlayerP2') then
			self:SetTarget(SCREENMAN:GetTopScreen():GetChild('PlayerP2'));
		else
			self:SetTarget(SCREENMAN:GetTopScreen():GetChild('PlayerP1'));
			SCREENMAN:GetTopScreen():GetChild('PlayerP1'):x(SCREEN_WIDTH*0.25);
			self:addx(SCREEN_WIDTH*0.5);
		end
	end },
	Def.ActorProxy{ Name = "ProxyOL"; OnCommand=function(self) self:x(0); self:y(0) self:SetTarget(SCREENMAN:GetTopScreen():GetChild('Overlay')); end },
};

for j = 0,vstrips-1 do
	tiles2d[j+1] = {}
	for i = 0,hstrips-1 do
		t[#t+1] = Def.Sprite{
			Name = "ScreenCopyx"..i.."y"..j;
			Texture = "ScreenTex";
			InitCommand=function(self)
				table.insert(tiles,self);
				table.insert(tiles2d[j+1],self);
				table.insert(tileObjects,{OrigX=(sw*((i+0.5)/hstrips)),OrigY=(sh*((j+0.5)/vstrips))});
			end,
			OnCommand=function(self)
				self:x(sw*((i+0.5)/hstrips));
				self:y(sh*((j+0.5)/vstrips));
				self:cropleft(i/hstrips)
				self:cropright(((hstrips-1)-i)/hstrips)
				self:croptop(j/vstrips)
				self:cropbottom(((vstrips-1)-j)/vstrips)
				self:align((i+0.5)/hstrips,(j+0.5)/vstrips)
			end,
		};
	end
end

t[#t+1] = LoadActor( "chara" )..{
	ZTopMessageCommand=cmd(z,10),
}

t[#t+1] = Def.Quad{
	OnCommand=cmd(x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;zoomto,SCREEN_WIDTH,SCREEN_HEIGHT;diffuse,0,0,0,0),
	WhiteFlashMessageCommand=cmd(finishtweening;diffuse,1,1,1,1;linear,0.6;diffusealpha,0),
	WhiteFlashLongMessageCommand=cmd(finishtweening;diffuse,1,1,1,1;linear,2;diffusealpha,0),
	RedFlashQMessageCommand=cmd(finishtweening;diffuse,1,0,0,0.6;linear,0.6;diffusealpha,0),
	RedFlashMessageCommand=cmd(finishtweening;diffuse,1,0,0,1;linear,1;diffusealpha,0),
}

return t