g_crying = false;
g_crytimer = 0;
g_sadness = 1;
g_sad_aux = 1;
g_sad_delay = 0.2;
g_tears = {}
g_tptr = 1;

g_fallspd1 = 0.15;
g_maxfall1 = 6;
g_fallspd2 = 0.25;
g_maxfall2 = 5;

l_scoreP1 = 0;
l_scoreP2 = 0;
l_yes = {false,false}

l_playing = {false,false}

local function nap_mod_internal(str, pn)
	local ps= GAMESTATE:GetPlayerState(pn)
	local pmods= ps:GetPlayerOptionsString('ModsLevel_Song')
	ps:SetPlayerOptions('ModsLevel_Song', pmods .. ', ' .. str)
	--GAMESTATE:ApplyGameCommand('mod,'..str, pn)
end

local function nap_mod(str)
	for i=1,2 do
		nap_mod_internal(str, 'PlayerNumber_P' .. i)
	end
end

-- Collect all the mods that will be applied in this frame into one string.
-- Mod tweening doesn't work correctly if the mods are in seperate commands.
mods_this_frame= {}
function add_mod(mod_str)
	mods_this_frame[#mods_this_frame+1]= mod_str
end

function execute_mods()
	if #mods_this_frame <= 0 then return end
	local total_mod_str= ""
	for i, ms in ipairs(mods_this_frame) do
		if #total_mod_str > 0 then
			total_mod_str= total_mod_str .. ", "
		end
		total_mod_str= total_mod_str .. ms
	end
	nap_mod(total_mod_str)
end

checked = true;

m_bl = 60/225;

g_counter = 0;

songName = GAMESTATE:GetCurrentSong():GetSongDir();

--[[
ITG SAVEDATA	
nap_profile = PROFILEMAN:GetMachineProfile():GetSaved()
if not nap_profile.nap_ini then
	nap_profile.nap_ini = {rude = 0}
end

if nap_profile and nap_profile.nap_ini and not nap_profile.nap_ini.last then
	nap_profile.nap_ini.rude = 0; --0=spare,1=kill
end

if nap_profile.nap_ini.rude == 1 then
	nap_remembers_sad = true
end
]]

function nap_saveFileExists()
	local path=GAMESTATE:GetCurrentSong():GetSongDir();
	if FILEMAN:DoesFileExist(path.."lua/save/savefile.lua") then
		return true
	end
	return false
end

function nap_writeSaveFile()
	local file = RageFileUtil.CreateRageFile()
	local path=GAMESTATE:GetCurrentSong():GetSongDir();
	file:Open( path.."lua/save/savefile.lua", 2 ) --2 = write
	file:PutLine("blooky_rude = "..blooky_rude)
	file:Close();
end

if nap_saveFileExists() then
	--SCREENMAN:SystemMessage('Save File exists, loading');
	LoadActor("save/savefile")
	if blooky_rude == 1 then
		nap_remembers_sad = true;
	end
else
	--SCREENMAN:SystemMessage('Save File does not exist, creating new');
	blooky_rude = 0;
	nap_writeSaveFile()
end

function g_spawntear(x,y,xspd,yspd,aux,dir)
	local a = g_tears[g_tptr]
	
	if a then
		local b = a.actor;
		if b then
			if dir then
				a.dir = dir
			end
			b:x(x);
			b:y(y);
			b:rotationz(math.deg(math.atan2(yspd,xspd))-90)
			b:zoom(1.5);
			a.xspd = xspd;
			a.yspd = yspd;
			b:aux(aux);
			b:visible(true);
		end
	end
	
	g_tptr = g_tptr+1;
	if g_tptr > table.getn(g_tears) then
		g_tptr = 1;
	end
end

return Def.ActorFrame{
InitCommand=function(self)
	
end,

	Def.Quad{
		InitCommand=cmd(visible,false;),
		OnCommand=cmd(sleep,1000;),
	},
	
	Def.Quad{
		OnCommand=cmd(visible,false;),
		InitCommand=function(self)
			checked = false;
			self:queuecommand('Update');
			
			mod_firstSeenBeat = GAMESTATE:GetSongBeat()
			
--how can I make simple m0d?
--this will instantly turn a mod on to max and then quickly turn it off with the specified parameters
--it's a simple mod

function simple_m0d(beat,strength,mult,mod,pn)
	if not strength then strength = 400 end
	if not mult then mult = 1 end
	if not mod then mod = 'drunk' end
	
	local alive = math.max(2*mult*math.abs(strength)/100,0.25)
	
	table.insert(mods,{beat,'*100000 '..strength..' '..mod,pn});
	table.insert(mods,{beat+.1,'*'..((1/mult)*math.abs(strength)/100)..' no '..mod,pn});
end

function simple_m0d2(beat,strength,mult,mod,pn)
	if not strength then strength = 400 end
	if not mult then mult = 1 end
	if not mod then mod = 'drunk' end
	
	table.insert(mods,{beat,'*'..math.abs(strength/10)..' '..strength..' '..mod,pn});
	table.insert(mods,{beat+.3,'*'..((1/mult)*math.abs(strength)/100)..' no '..mod,pn});
end
			
--alternates a mod back and forth before resetting to 0
--beat,num,div,amt,mod,pn
function mod_wiggle(beat,num,div,amt,mod,pn,first)
	local fluct = 1
	for i=0,(num-1) do
		b = beat+(i/div)
		local m = 1
		if i==0 and not first then m = 0.5 end
		table.insert(mods,{b,'*'..math.abs(m*amt/10)..' '..(amt*fluct)..' '..mod..'',pn});
		fluct = fluct*-1;
	end
	table.insert(mods,{beat+(num/div),'*'..math.abs(amt/20)..' no '..mod..'',pn});
end
			
--lua course :D
curmod = 1;
--{beat,mod,player}
mods = {
	{0,'-100 cover, overhead, no reverse, no mini, 2x'},

	{15.5,'*1000 120 beat'},
	{31.5,'*1000 no beat'},
	{32,'blind, 1.5x'},
	{62,'no blind'},
	
	{62.667-.05,'*10 100 drunk'},
	{63.000-.05,'*20 -100 drunk'},
	{63.667-.05,'*20 100 drunk'},
	{64.000-.05,'*10 no drunk'},
	{63.5,'*100 beat'},
	{67.5,'*100 no beat'},
	{68-.05,'*3 30 centered'},
	{69-.05,'*6 -30 centered'},
	{69.667-.05,'*3 no centered'},
	
	{70.667-.05,'*10 100 drunk'},
	{71.000-.05,'*20 -100 drunk'},
	{71.667-.05,'*20 100 drunk'},
	{72.000-.05,'*10 no drunk'},
	{71.5,'*100 beat'},
	{75.5,'*100 no beat'},
	{76-.05,'*3 30 centered'},
	{77-.05,'*6 -30 centered'},
	{77.667-.05,'*3 no centered'},
	
	{78.667-.05,'*10 100 drunk'},
	{79.000-.05,'*20 -100 drunk'},
	{79.667-.05,'*20 100 drunk'},
	{80.000-.05,'*10 no drunk'},
	{79.5,'*100 beat'},
	{83.5,'*100 no beat'},
	
	{84.000-.05,'*10 100 drunk'},
	{84.667-.05,'*20 -100 drunk'},
	{85.667-.05,'*20 100 drunk'},
	{86-.05,'*2 no drunk'},
	
	{87,'*2 -100 tornado, *2 bumpy'},
	{88.667,'*2 no tornado, *2 no bumpy'},
	{92-.05,'*20 70 distant'},
	{92.667-.05,'*20 140 distant'},
	{93.667-.05,'*20 210 distant'},
	{93.8,'*3 no distant'},
	
	{104,'*1000 2512 dizzy'},
	{105,'*1000 no dizzy'},
	
	{190.667-.05,'*10 100 drunk'},
	{191.000-.05,'*20 -100 drunk'},
	{191.667-.05,'*20 100 drunk'},
	{192.000-.05,'*10 no drunk'},
	{191.5,'*100 beat'},
	{195.5,'*100 no beat'},
	{196-.05,'*3 30 centered'},
	{197-.05,'*6 -30 centered'},
	{197.667-.05,'*3 no centered'},
		
	{198.667-.05,'*10 100 drunk'},
	{199.000-.05,'*20 -100 drunk'},
	{199.667-.05,'*20 100 drunk'},
	{200.000-.05,'*10 no drunk'},
	{199.5,'*100 beat'},
	{203.5,'*100 no beat'},
	{204-.05,'*3 30 centered'},
	{205-.05,'*6 -30 centered'},
	{205.667-.05,'*3 no centered'},
		
	{206.667-.05,'*10 100 drunk'},
	{207.000-.05,'*20 -100 drunk'},
	{207.667-.05,'*20 100 drunk'},
	{208.000-.05,'*10 no drunk'},
	{207.5,'*100 beat'},
	{211.5,'*100 no beat'},
		
	{212.000-.05,'*10 100 drunk'},
	{212.667-.05,'*20 -100 drunk'},
	{213.667-.05,'*20 100 drunk'},
	{214-.05,'*2 no drunk'},
		
	{215,'*2 -100 tornado, *2 bumpy'},
	{216.667,'*2 no tornado, *2 no bumpy'},
	{220-.05,'*20 70 distant'},
	{220.667-.05,'*20 140 distant'},
	{221.667-.05,'*20 210 distant'},
	{221.8,'*3 no distant'},
		
	{232,'*1000 2512 dizzy'},
	{233,'*1000 no dizzy'},
	
	{288,'blind, 1x'},
	
}

simple_m0d2(3.5-.2,-50,0.4,'reverse')
simple_m0d2(7.5-.2,-50,0.4,'reverse')
simple_m0d2(11.5-.2,-50,0.4,'reverse')

simple_m0d2(19.5-.2,-50,0.4,'reverse')
simple_m0d2(23.5-.2,-50,0.4,'reverse')
simple_m0d2(27.5-.2,-50,0.4,'reverse')

simple_m0d2(31-.2,-50,0.4,'reverse')

local d = {-1,1}

function g_drop()
	for pn=1,2 do
		local a = _G['P'..pn]
		if a then
			a:linear(m_bl);
			a:addy(96)
			a:sleep(0);
			a:addy(-96);
			a:linear(m_bl);
			a:addy(96)
			a:sleep(0);
			a:addy(-96);
			a:linear(m_bl);
			a:addy(96)
			a:sleep(0);
			a:addy(-96);
			a:linear(m_bl*0.9);
			a:addy(96*0.9)
			a:linear(0.1);
			a:addy(-96*0.9);
		end
	end
end

--SCREAMING GUMBALL / timed action broadcaster
curaction = 1;
--{beat,action,persist}
mod_actions = {

{64,function() g_drop() end},
{72,function() g_drop() end},
{80,function() g_drop() end},
{192,function() g_drop() end},
{200,function() g_drop() end},
{208,function() g_drop() end},

{176,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:decelerate(m_bl*1.5);
	a:rotationz(-7);
end end end},
{178,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:decelerate(m_bl*1.5);
	a:rotationz(14);
end end end},
{180,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:decelerate(m_bl*1.5);
	a:rotationz(-21);
end end end},
{182,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:decelerate(m_bl*1.5);
	a:rotationz(28);
end end end},
{184-.1,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(0.1)
	a:rotationz(-15);
end end end},
{185-.1,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(0.1)
	a:rotationz(0);
end end end},
{186-.1,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(0.1)
	a:rotationz(15);
end end end},
{187-.1,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(0.1)
	a:rotationz(0);
end end end},
{188-.1,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(0.1)
	a:rotationx(-60);
end end end},
{188.667-.1,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(0.1)
	a:rotationx(-40);
end end end},
{189.667,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:decelerate(m_bl)
	a:rotationx(0);
end end end},

{16,'UIOn'},
{16.3,'Text1'},
{18,'BlookOn',true},
{28,'UIOff'},

{64,function()
	g_textbox:x(SCREEN_CENTER_X);
	g_textbox:y(SCREEN_CENTER_Y-100);
	setBubble(1,9,16);
		   --|                 |                 |                 |                 |
	sayThis('                  am i in           the way?',0.06,'generic.ogg',1);
	setTalkSpeeds(1,18,0)
	setTalkSpeeds(24,35,0)
	
	for i=1,72 do
		_G['let'..i]:bob();
		_G['let'..i]:effectmagnitude(0,2,0)
		_G['let'..i]:effectperiod(4)
		_G['let'..i]:effectoffset(i/4.5)
		_G['let'..i]:effectclock('bgm');
	end
end},

{80,function()
	setBubble(1,9,16);
		   --|                 |                 |                 |                 |
	sayThis('                  oh no......',0.06,'generic.ogg',1);
	setTalkSpeeds(1,18,0)
end},

{96,function()
	setBubble(1,9,16);
		   --|                 |                 |                 |                 |
	sayThis('                  i feel bad...',0.06,'generic.ogg',1);
	setTalkSpeeds(1,18,0)
end},

{112,function()
	setBubble(1,9,16);
		   --|                 |                 |                 |                 |
	sayThis('                  this is           probably really   distracting...',0.06,'generic.ogg',1);
	setTalkSpeeds(1,18,0)
	setTalkSpeeds(26,36,0)
	setTalkSpeeds(50,54,0)
	
	for i=1,72 do
		_G['let'..i]:addx(-6);
		_G['let'..i]:addy(-6);
	end
	
end},

{128,function()
	for i=1,72 do
		_G['let'..i]:addx(6);
		_G['let'..i]:addy(6);
	end
	clearThis()
	hideBubble()
end},

{128,'UIOn2'},
{128.3,'Text2'},
{144,'UIOff'},

	{144,function()
		g_textbox:x(SCREEN_CENTER_X);
		g_textbox:y(SCREEN_CENTER_Y-100);
		setBubble(1,9,16);
			  --|                  |    \             |                  |                  |
		sayThis('                  oh, i\'m REAL      funny.',0.06,'generic.ogg',1);
		setTalkSpeeds(1,18,0)
		setTalkSpeeds(32,35,0)
		
		for i=1,72 do
			_G['let'..i]:bob();
			_G['let'..i]:effectmagnitude(0,3,0)
			_G['let'..i]:effectperiod(4)
			_G['let'..i]:effectoffset(i/4.5)
			_G['let'..i]:effectclock('bgm');
		end
	end},
	
	{160,function()
		clearThis()
		hideBubble()
	end},
	
	{96,function()
		g_crying = true;
		g_sadness = 1;
		g_sad_delay = 0.8;
	end},
	{128,function() g_crying = false end},
	{160,function()
		g_crying = true;
		g_sadness = 1;
		g_sad_delay = 0.2;
	end},
	
	{224,function() g_crying = false end},
	{224,'UIOn3'},
	{224.3,'Text3'},
	
	{240,'UIOff'},
	{240.1,function()
		setBubble(1,9,16);
			   --|                 |                 |                 |                 |
		sayThis('                  oh.... let me     try this...',0.06,'generic.ogg',1);
		setTalkSpeeds(1,18,0)
		setTalkSpeeds(32,35,0)
	end},
	
	{256,function()
		clearThis()
		hideBubble()
	end},
	
	{256,function()
		g_crying = true;
		g_sadness = 2;
		g_sad_delay = 0.5;
		g_sad_aux = 2;
		MESSAGEMAN:Broadcast('Hat');
	end},
	
	{280,function() g_crying = false end},
	
	{288,'UIOn3'},
	{288.3,'Text4'},
	
	{304,'UIOff'},
	
	{312,'FinalYes'},
	
	{324,function()
		nap_state = 0;
		nap_expects = 0;
		
		for pn=1,2 do
			if l_playing[pn] then nap_expects = nap_expects+1 end
			if l_yes[pn] then nap_state = nap_state+1 end
		end
	end},
	{324.1,function()
		
		g_textbox:x(SCREEN_CENTER_X+150);
		g_textbox:y(SCREEN_CENTER_Y-30);
		setBubble(0,9,16);
		
		if nap_state > 0 and nap_remembers_sad then
				   --|                 |  \               |                 |                 |
			sayThis('                  you\'re just       saying that...',0.06,'generic.ogg',1);
			setTalkSpeeds(1,18,0)
			setTalkSpeeds(30,36,0)
			
			g_sadness = 1;
			g_sad_delay = 0.8;
			g_sad_aux = 1;
			
		elseif nap_state == 0 then
				   --|                 |                 |                 |                 |
			sayThis('                  oh............',0.06,'generic.ogg',1);
			setTalkSpeeds(1,18,0)
			
			g_sadness = 1;
			g_sad_delay = 0.8;
			g_sad_aux = 1;
			
			blooky_rude = 1;
			nap_writeSaveFile()
			nap_remembers_sad = false;
			
			MESSAGEMAN:Broadcast('GhostFade');
		elseif nap_state < nap_expects then
				   --|                 |                 |                 |                 |
			sayThis('                  oh... well        at least...',0.06,'generic.ogg',1);
			setTalkSpeeds(1,18,0)
			setTalkSpeeds(29,36,0)
			
		else
				   --|                 |                 |                 |                 |
			sayThis('                  oh...',0.06,'generic.ogg',1);
			setTalkSpeeds(1,18,0)
			
		end
		
	end},
	{340,function()
		if nap_state > 0 and nap_remembers_sad then
			setBubble(0,9,16);
				   --|                 |  \               |                 |                 |
			sayThis('                  you don\'t         really mean it...',0.06,'generic.ogg',1);
			setTalkSpeeds(1,18,0)
			setTalkSpeeds(30,36,0)
			for i=1,72 do
				_G['let'..i]:addx(-6);
			end
			
			blooky_rude = 0;
			nap_writeSaveFile()
			nap_remembers_sad = false;
			
			MESSAGEMAN:Broadcast('GhostFade');
		elseif nap_state == 0 then
			g_crying = false;
			clearThis()
			hideBubble()
		elseif nap_state < nap_expects then
			setBubble(0,9,16);
				   --|                 |                 |                 |                 |
			sayThis('                  one of you        liked it...',0.06,'generic.ogg',1);
			setTalkSpeeds(1,18,0)
			setTalkSpeeds(29,36,0)
			
			blooky_rude = 0;
			nap_writeSaveFile()
			nap_remembers_sad = false;
			
		elseif nap_state == 1 and nap_expects == 1 then
			setBubble(0,9,16);
				   --|                 |                 |                 |                 |
			sayThis('                  today, i met      someone nice...',0.06,'generic.ogg',1);
			setTalkSpeeds(1,18,0)
			setTalkSpeeds(32,35,0)
			
			blooky_rude = 0;
			nap_writeSaveFile()
			nap_remembers_sad = false;
			
		elseif nap_state == 2 then
			setBubble(0,9,16);
				   --|                 |                 |                 |                 |
			sayThis('                  today, i met      some nice         people...',0.06,'generic.ogg',1);
			setTalkSpeeds(1,18,0)
			setTalkSpeeds(32,35,0)
			for i=1,72 do
				_G['let'..i]:addy(-6);
			end
			
			blooky_rude = 0;
			nap_writeSaveFile()
			nap_remembers_sad = false;
			
		end
	end},
	
	{356,function() g_crying = false end},
	
{31,'NotFeelin'},
{96-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(100);
end end end},
{97-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(-25); a:skewx(0.3*d[pn]);
end end end},
{97.667-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(-25); a:skewx(-0.3*d[pn]);
end end end},
{98.667-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(-25); a:skewx(0.3*d[pn]);
end end end},
{99-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(-25); a:skewx(0);
end end end},
{100-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(100);
end end end},
{101-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(-25); a:skewx(0.3*d[pn]);
end end end},
{101.667-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(-25); a:skewx(-0.3*d[pn]);
end end end},
{102.667-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(-25); a:skewx(0.3*d[pn]);
end end end},
{103-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:y(SCREEN_CENTER_Y); a:skewx(0);
end end end},
{104-.1,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:decelerate(m_bl*1.9) a:rotationy(360); a:sleep(0); a:rotationy(0);
end end end},
{106-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(50); a:skewx(-0.3*d[pn]);
end end end},
{106.667-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(50); a:skewx(0.3*d[pn]);
end end end},
{107.667-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:decelerate(m_bl*4) a:y(SCREEN_CENTER_Y); a:skewx(0);
end end end},
{112-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(100);
end end end},
{113-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(-25); a:skewx(0.3*d[pn]);
end end end},
{113.667-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(-25); a:skewx(-0.3*d[pn]);
end end end},
{114.667-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(-25); a:skewx(0.3*d[pn]);
end end end},
{115-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(-25); a:skewx(0);
end end end},
{116-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(100);
end end end},
{117-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(-25); a:skewx(0.3*d[pn]);
end end end},
{117.667-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(-25); a:skewx(-0.3*d[pn]);
end end end},
{118.667-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(-25); a:skewx(0.3*d[pn]);
end end end},
{119-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:y(SCREEN_CENTER_Y); a:skewx(0);
end end end},
{120-.1,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:rotationz(10);
end end end},
{121-.1,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:rotationz(20);
end end end},
{122-.1,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:rotationz(30);
end end end},
{122.667-.1,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:rotationz(36);
end end end},
{123.333-.1,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:rotationz(42);
end end end},
{124-.1,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:spring(m_bl*3.9) a:rotationz(0);
end end end},

{128-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(100);
end end end},
{129-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(-25); a:skewx(0.3*d[pn]);
end end end},
{129.667-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(-25); a:skewx(-0.3*d[pn]);
end end end},
{130.667-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(-25); a:skewx(0.3*d[pn]);
end end end},
{131-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(-25); a:skewx(0);
end end end},
{132-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(100);
end end end},
{133-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(-25); a:skewx(0.3*d[pn]);
end end end},
{133.667-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(-25); a:skewx(-0.3*d[pn]);
end end end},
{134.667-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(-25); a:skewx(0.3*d[pn]);
end end end},
{135-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:y(SCREEN_CENTER_Y); a:skewx(0);
end end end},
{136-.1,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:decelerate(m_bl*1.9) a:rotationy(360); a:sleep(0); a:rotationy(0);
end end end},
{138-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(50); a:skewx(-0.3*d[pn]);
end end end},
{138.667-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(50); a:skewx(0.3*d[pn]);
end end end},
{139.667-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:decelerate(m_bl*4) a:y(SCREEN_CENTER_Y); a:skewx(0);
end end end},
{144-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(100);
end end end},
{145-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(-25); a:skewx(0.3*d[pn]);
end end end},
{145.667-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(-25); a:skewx(-0.3*d[pn]);
end end end},
{146.667-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(-25); a:skewx(0.3*d[pn]);
end end end},
{147-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(-25); a:skewx(0);
end end end},
{148-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(100);
end end end},
{149-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(-25); a:skewx(0.3*d[pn]);
end end end},
{149.667-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(-25); a:skewx(-0.3*d[pn]);
end end end},
{150.667-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(-25); a:skewx(0.3*d[pn]);
end end end},
{151-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:y(SCREEN_CENTER_Y); a:skewx(0);
end end end},
{152-.1,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:rotationz(-10);
end end end},
{153-.1,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:rotationz(-20);
end end end},
{154-.1,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:rotationz(-30);
end end end},
{154.667-.1,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:rotationz(-36);
end end end},
{155.333-.1,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:rotationz(-42);
end end end},
{156-.1,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:spring(m_bl*3.9) a:rotationz(0);
end end end},



--parte 2
{224-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(100);
end end end},
{225-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(-25); a:skewx(0.3*d[pn]);
end end end},
{225.667-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(-25); a:skewx(-0.3*d[pn]);
end end end},
{226.667-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(-25); a:skewx(0.3*d[pn]);
end end end},
{227-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(-25); a:skewx(0);
end end end},
{228-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(100);
end end end},
{229-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(-25); a:skewx(0.3*d[pn]);
end end end},
{229.667-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(-25); a:skewx(-0.3*d[pn]);
end end end},
{230.667-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(-25); a:skewx(0.3*d[pn]);
end end end},
{231-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:y(SCREEN_CENTER_Y); a:skewx(0);
end end end},
{232-.1,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:decelerate(m_bl*1.9) a:rotationy(360); a:sleep(0); a:rotationy(0);
end end end},
{234-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(50); a:skewx(-0.3*d[pn]);
end end end},
{234.667-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(50); a:skewx(0.3*d[pn]);
end end end},
{235.667-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:decelerate(m_bl*4) a:y(SCREEN_CENTER_Y); a:skewx(0);
end end end},
{240-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(100);
end end end},
{241-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(-25); a:skewx(0.3*d[pn]);
end end end},
{241.667-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(-25); a:skewx(-0.3*d[pn]);
end end end},
{242.667-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(-25); a:skewx(0.3*d[pn]);
end end end},
{243-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(-25); a:skewx(0);
end end end},
{244-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(100);
end end end},
{245-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(-25); a:skewx(0.3*d[pn]);
end end end},
{245.667-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(-25); a:skewx(-0.3*d[pn]);
end end end},
{246.667-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(-25); a:skewx(0.3*d[pn]);
end end end},
{247-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:y(SCREEN_CENTER_Y); a:skewx(0);
end end end},
{248-.1,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:rotationz(10); a:rotationx(-10);
end end end},
{249-.1,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:rotationz(20); a:rotationx(-20);
end end end},
{250-.1,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:rotationz(30); a:rotationx(-30);
end end end},
{250.667-.1,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:rotationz(36); a:rotationx(-36);
end end end},
{251.333-.1,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:rotationz(42); a:rotationx(-42);
end end end},
{252-.1,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:spring(m_bl*3.9) a:rotationz(0); a:rotationx(0);
end end end},

{256-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(100);
end end end},
{257-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(-25); a:skewx(0.3*d[pn]);
end end end},
{257.667-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(-25); a:skewx(-0.3*d[pn]);
end end end},
{258.667-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(-25); a:skewx(0.3*d[pn]);
end end end},
{259-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(-25); a:skewx(0);
end end end},
{260-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(100);
end end end},
{261-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(-25); a:skewx(0.3*d[pn]);
end end end},
{261.667-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(-25); a:skewx(-0.3*d[pn]);
end end end},
{262.667-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(-25); a:skewx(0.3*d[pn]);
end end end},
{263-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:y(SCREEN_CENTER_Y); a:skewx(0);
end end end},
{264-.1,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:decelerate(m_bl*1.9) a:rotationy(360); a:sleep(0); a:rotationy(0);
end end end},
{266-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(50); a:skewx(-0.3*d[pn]);
end end end},
{266.667-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(50); a:skewx(0.3*d[pn]);
end end end},
{267.667-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:decelerate(m_bl*4) a:y(SCREEN_CENTER_Y); a:skewx(0);
end end end},
{272-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(100);
end end end},
{273-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(-25); a:skewx(0.3*d[pn]);
end end end},
{273.667-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(-25); a:skewx(-0.3*d[pn]);
end end end},
{274.667-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(-25); a:skewx(0.3*d[pn]);
end end end},
{275-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(-25); a:skewx(0);
end end end},
{276-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(100);
end end end},
{277-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(-25); a:skewx(0.3*d[pn]);
end end end},
{277.667-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(-25); a:skewx(-0.3*d[pn]);
end end end},
{278.667-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:addy(-25); a:skewx(0.3*d[pn]);
end end end},
{279-.2,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:linear(.1) a:y(SCREEN_CENTER_Y); a:skewx(0);
end end end},
{280-.1,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:rotationz(-10); a:rotationx(-10);
end end end},
{281-.1,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:rotationz(-20); a:rotationx(-20);
end end end},
{282-.1,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:rotationz(-30); a:rotationx(-30);
end end end},
{282.667-.1,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:rotationz(-36); a:rotationx(-36);
end end end},
{283.333-.1,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:rotationz(-42); a:rotationx(-42);
end end end},
{284-.1,function() for pn=1,2 do local a = _G['P'..pn] if a then
	a:spring(m_bl*3.9) a:rotationz(0); a:rotationx(0);
end end end},

}

--SCREAMING GUMBALL
curmessage = 1;
--{beat,message}
messages = {
}

			function modtable_compare(a,b)
				return a[1] < b[1]
			end
			
			if table.getn(mods) > 1 then
				table.sort(mods, modtable_compare)
			end
			
			if table.getn(mod_actions) > 1 then
				table.sort(mod_actions, modtable_compare)
			end
			
		end,
		
		UpdateCommand=function(self)

			if GAMESTATE:GetSongBeat()>=0.1 and not checked then
				if SCREENMAN:GetTopScreen():GetChild('PlayerP1') then p1on = true; else p1on = false; end
				if SCREENMAN:GetTopScreen():GetChild('PlayerP2') then p2on = true; else p2on = false; end
				
				P1 = SCREENMAN:GetTopScreen():GetChild('PlayerP1');
				P2 = SCREENMAN:GetTopScreen():GetChild('PlayerP2');
				
				--[[
				if SCREENMAN:GetTopScreen():GetChild('ScoreP1') then
					SCREENMAN:GetTopScreen():GetChild('ScoreP1'):visible(false)
				end
				if SCREENMAN:GetTopScreen():GetChild('ScoreP2') then
					SCREENMAN:GetTopScreen():GetChild('ScoreP2'):visible(false)
				end
				]]
				
				screen = SCREENMAN:GetTopScreen();
				screen:SetDrawByZPosition(true);
				
				if SCREENMAN:GetTopScreen():GetChild('SongForeground') then
					SCREENMAN:GetTopScreen():GetChild('SongForeground'):z(2)
				end
				
				if P1 then P1:z(1) end
				if P2 then P2:z(1) end
				
			end
			
			local beat = GAMESTATE:GetSongBeat()
			
			if beat > mod_firstSeenBeat+0.1 then
				g_blook:y(math.floor(4*math.sin(math.pi*g_counter)));
				g_counter = g_counter+0.02
				
				for i=1,table.getn(g_tears) do
					local a = g_tears[i]
					local b = a.actor;
					if b:getaux() ~= 0 then
						if b:getaux() == 1 then
							
							b:addx(a.xspd);
							b:addy(a.yspd);
							
							b:rotationz(math.deg(math.atan2(a.yspd,a.xspd))-90)
							
							if a.yspd < g_maxfall1 then
								a.yspd = a.yspd+g_fallspd1
							end
							
						else
							b:addx(a.xspd);
							b:addy(a.yspd);
							
							b:rotationz(math.deg(math.atan2(a.yspd,a.xspd))-90)
							
							if a.dir then
								if a.dir < 0 and a.xspd < g_maxfall2 or a.dir > 0 and a.xspd > -g_maxfall2 then
									a.xspd = a.xspd+g_fallspd2*-a.dir
								end
							end
						end
						
						if b:GetX() < -80 or b:GetX() > SCREEN_WIDTH + 80 or b:GetY() > SCREEN_HEIGHT + 80 then
							b:aux(0);
							b:queuecommand('Hide');
						end
						
					end
				end
				
				if g_crying then
					if g_crytimer <= 0 then
						for i=1,g_sadness do
							if g_sad_aux == 1 then
								g_spawntear(SCREEN_CENTER_X-5,SCREEN_CENTER_Y-20+g_blook:GetY(),(math.random()*1.5+2)*-1,(math.random()*4+3)*-1,g_sad_aux);
								g_spawntear(SCREEN_CENTER_X+30,SCREEN_CENTER_Y-5+g_blook:GetY(),(math.random()*1.5+2)*1,(math.random()*4+3)*-1,g_sad_aux);
							else
								g_spawntear(SCREEN_CENTER_X-5,SCREEN_CENTER_Y-20+g_blook:GetY(),(math.random()*5+5)*-1,(math.random()*-1)-0.8,g_sad_aux,-1);
								g_spawntear(SCREEN_CENTER_X+30,SCREEN_CENTER_Y-5+g_blook:GetY(),(math.random()*5+5)*1,(math.random()*-1)-0.8,g_sad_aux,1);
							end
						end
						g_crytimer = g_sad_delay;
					else
						g_crytimer = g_crytimer-0.02;
					end
				end
				
			end
			
			
---------------------------------------------------------------------------------------
----------------------DON'T TOUCH IT KIDDO---------------------------------------------
---------------------------------------------------------------------------------------
			
			while curmod<= #mods and GAMESTATE:GetSongBeat()>=mods[curmod][1] do
				if table.getn(mods[curmod]) < 3 then
					add_mod(mods[curmod][2])
				else
					nap_mod_internal(mods[curmod][2], 'PlayerNumber_P' .. mods[curmod][3])
				end
				curmod = curmod+1
			end

			execute_mods()
			
			---------------------------------------
			-- ACTION RPGS AINT GOT SHIT ON THIS --
			---------------------------------------
			if beat > mod_firstSeenBeat+0.1 then -- performance coding!! --
				
				while curaction<=table.getn(mod_actions) and GAMESTATE:GetSongBeat()>=mod_actions[curaction][1] do
					if mod_actions[curaction][3] or GAMESTATE:GetSongBeat() < mod_actions[curaction][1]+2 then
						if type(mod_actions[curaction][2]) == 'function' then
							mod_actions[curaction][2]()
						elseif type(mod_actions[curaction][2]) == 'string' then
							MESSAGEMAN:Broadcast(mod_actions[curaction][2]);
						end
					end
					curaction = curaction+1;
				end
				
			end
			
			self:queuecommand('Update2');

---------------------------------------------------------------------------------------
----------------------END DON'T TOUCH IT KIDDO-----------------------------------------
---------------------------------------------------------------------------------------
			
		end,
  
		Update2Command=function(self)
			self:sleep(0.02);
			self:queuecommand('Update');
		end,
		
	},
	
	LoadActor("text")..{ InitCommand=function(self) g_textbox = self end, },
	
	Def.ActorFrame{ InitCommand=function(self) g_blook = self end,
		LoadActor("blook")..{
			OnCommand=cmd(croptop,1;fadetop,0.1;x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y+20;),
			BlookOnMessageCommand=cmd(linear,2;croptop,-.1;),
			GhostFadeMessageCommand=cmd(sleep,m_bl*8;linear,m_bl*8;diffusealpha,0;),
		},
		LoadActor("hat")..{
			OnCommand=cmd(x,SCREEN_CENTER_X+22;y,SCREEN_CENTER_Y-70;croptop,1;fadetop,0.1;),
			HatMessageCommand=cmd(linear,m_bl*32;croptop,-.1;),
			GhostFadeMessageCommand=cmd(sleep,m_bl*8;linear,m_bl*8;diffusealpha,0;),
		},
	},
	
	LoadActor("yesbox")..{ OnCommand=cmd(y,SCREEN_CENTER_Y-128+(64*8);animate,0;setstate,0;),
	FinalYesMessageCommand=function(self)
		if P1 then
			self:x(P1:GetX()+32+64);
			self:y(P1:GetY()-128+(64*8));
			self:linear(m_bl*8);
			self:y(P1:GetY()-128);
			self:linear(m_bl*8);
			self:addy(-64*8);
		end
	end,
	P1YesMessageCommand=cmd(stoptweening;setstate,1;sleep,1;linear,0.5;diffusealpha,0;),
	},
	
	LoadActor("yesbox")..{ OnCommand=cmd(y,SCREEN_CENTER_Y-128+(64*8);animate,0;setstate,0;),
	FinalYesMessageCommand=function(self)
		if P2 then
			self:x(P2:GetX()+32+64);
			self:y(P2:GetY()-128+(64*8));
			self:linear(m_bl*8);
			self:y(P2:GetY()-128);
			self:linear(m_bl*8);
			self:addy(-64*8);
		end
	end,
	P2YesMessageCommand=cmd(stoptweening;setstate,1;sleep,1;linear,0.5;diffusealpha,0;),
	},
	
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	LoadActor("tear")..{ OnCommand=cmd(visible,false;aux,0;sleep,0.02;queuecommand,"SetMe"),
	SetMeCommand=function(self) table.insert(g_tears,{actor = self, xspd = 0, yspd = 0}) end, HideCommand=cmd(aux,0;visible,false) },
	
	LoadActor("notfeelin")..{
	OnCommand=cmd(y,SCREEN_BOTTOM+296;zoom,1.3;vibrate;effectmagnitude,1,1,1;),
	NotFeelinMessageCommand=function(self)
		if P1 then
			self:x(P1:GetX()+10);
			self:linear(2*m_bl);
			self:y(SCREEN_CENTER_Y);
			self:sleep(26*m_bl);
			self:linear(4*m_bl);
			self:diffusealpha(0);
		end
	end,
	},
	
	LoadActor("notfeelin")..{
	OnCommand=cmd(y,SCREEN_BOTTOM+296;zoom,1.3;vibrate;effectmagnitude,1,1,1;),
	NotFeelinMessageCommand=function(self)
		if P2 then
			self:x(P2:GetX()+10);
			self:linear(2*m_bl);
			self:y(SCREEN_CENTER_Y);
			self:sleep(26*m_bl);
			self:linear(4*m_bl);
			self:diffusealpha(0);
		end
	end,
	},
	
	Def.Quad{
		OnCommand=cmd(visible,false;),
		StepMessageCommand=function(self,params)
			for pn=1,2 do
				if GAMESTATE:GetSongBeat() > 16 and params.PlayerNumber == 'PlayerNumber_P'..pn and not l_playing[pn] then
					l_playing[pn] = true
				end
			end
		end,
		JudgmentMessageCommand=function(self,params)
			if params.TapNoteScore ~= 'TapNoteScore_None' and GAMESTATE:GetSongBeat() > 318 then
				if params.Player == PLAYER_1 then
					local tns = params.TapNoteScore
					if tns == 'TapNoteScore_W1' or tns == 'TapNoteScore_W2' or tns == 'TapNoteScore_W3' or tns == 'TapNoteScore_W4' then
						MESSAGEMAN:Broadcast('P1Yes');
						l_yes[1] = true;
					end
				elseif params.Player == PLAYER_2 then
					local tns = params.TapNoteScore
					if tns == 'TapNoteScore_W1' or tns == 'TapNoteScore_W2' or tns == 'TapNoteScore_W3' or tns == 'TapNoteScore_W4' then
						MESSAGEMAN:Broadcast('P2Yes');
						l_yes[2] = true;
					end
				end
			end
		end,
	},
	
	Def.Quad{ OnCommand=cmd(zoomto,SCREEN_WIDTH,0;x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y+150;diffuse,0,0,0,1;),
	UIOnMessageCommand=cmd(decelerate,0.3;zoomy,64;), UIOn2MessageCommand=cmd(addy,64;decelerate,0.3;zoomy,64;), UIOn3MessageCommand=cmd(addy,-64;decelerate,0.3;zoomy,64;),
	UIOffMessageCommand=cmd(sleep,0.2;accelerate,0.3;zoomy,0;), },
	
	LoadActor("ui")..{ OnCommand=cmd(cropright,1;animate,0;setstate,0;x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y+150;),
	Text1MessageCommand=cmd(setstate,0;cropright,1;diffusealpha,1;linear,1;cropright,0;),
	Text2MessageCommand=cmd(addy,64;setstate,1;cropright,1;diffusealpha,1;linear,1;cropright,0;),
	Text3MessageCommand=cmd(addy,-64;setstate,2;cropright,1;diffusealpha,1;linear,1;cropright,0;),
	Text4MessageCommand=cmd(addy,-64;setstate,3;cropright,1;diffusealpha,1;linear,1;cropright,0;),
	UIOffMessageCommand=cmd(linear,0.3;diffusealpha,0;), },
	
}