char_sans_gptr = 1;
char_sans_gasters = {}
function GetNewGaster()
	local a = char_sans_gasters[char_sans_gptr]
	
	char_sans_gptr = char_sans_gptr+1
	if char_sans_gptr > table.getn(char_sans_gasters) then
		char_sans_gptr = 1;
	end
	
	if a then
		a:visible(true);
		a:playcommand('Reset');
		return a
	else
		char_sans_missing:visible(true)
		return char_sans_missing
	end
end

function GetGaster(n)
	local a = char_sans_gasters[n]
	
	if a then
		a:visible(true);
		a:playcommand('Reset');
		return a
	else
		char_sans_missing:visible(true)
		return char_sans_missing
	end
end

function GasterSound(str)
	local songName = GAMESTATE:GetCurrentSong():GetSongDir();
	SOUND:PlayOnce(songName..'lua/chara/sans/'..str..'.ogg');
end

local characters = Def.ActorFrame{

	InitCommand=function(self)
		af = self
		TimeAtInit = GetTimeSinceStart()
		self:queuecommand("SetUpdate")
			:sleep(9999)
	end,
	SetUpdateCommand=function(self)
		
	end,

	
	Def.Quad{
		OnCommand=cmd(visible,false),
		InitCommand=function(self)
		
			char_sans_gaster_snd = self
		
		end,
		SpawnCommand=function(self) GasterSound('gaster_spawn') end,
		FireCommand=function(self) GasterSound('gaster_fire') end,
	},
	
	Def.Quad{
		InitCommand=function(self) char_sans_missing = self end,
		OnCommand=cmd(visible,false;diffuse,1,0,1,1;zoomto,64,64),
		DoneCommand=cmd(visible,false),
	}
	
}

local gasters = Def.ActorFrame{

}

for i=1,20 do
	gasters[#gasters+1] = Def.ActorFrame{
		OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
		SetMeCommand=function(self)
			table.insert(char_sans_gasters,self)
		end,
		DoneCommand=cmd(visible,false),
		Def.Quad{
			InitCommand=function (self)
				self:SetTextureFiltering(false);
			end,
			OnCommand=cmd(vertalign,top;y,24;zoomx,0;zoomy,10000;diffusealpha,1;),
			FireCommand=cmd(diffusealpha,1;zoomx,0;spring,0.4;zoomx,64;linear,0.6;zoomx,56;accelerate,0.6;zoomx,0;diffusealpha,-0.2)
		},
		LoadActor( "sans/gaster 2x1.png" )..{
			InitCommand=function (self)
				self:SetTextureFiltering(false);
			end,
			OnCommand=cmd(animate,0;setstate,0),
			FireCommand=cmd(setstate,1;zoom,1.3;decelerate,0.2;addy,-10;zoom,1;),
			ResetCommand=cmd(y,0;setstate,0)
		},
	}
end

characters[#characters+1] = gasters;

characters[#characters+1] = Def.ActorFrame{
	InitCommand=function (self) char_sans=self; self:zoomx(3); self:zoomy(0); end,
	HideQCommand=cmd(zoomy,0;zoomx,3;),
	HideCommand=cmd(bouncebegin,0.2;zoomy,0;zoomx,3;),
	SpawnCommand=cmd(z,0;bounceend,0.3;zoom,1;),
	SpawnQCommand=cmd(z,0;zoom,1;),
	SpawnQZCommand=cmd(z,1;zoom,1;),
	
	Def.ActorFrame{
		InitCommand=function (self)
			self:SetTextureFiltering(false);
		end,
		OnCommand=cmd(zoom,1.6;spin;effectmagnitude,0,0,90;),
		LoadActor( "casting" )..{
			OnCommand=cmd(blend,1;diffusealpha,0),
			CastCommand=function (self)
				self:zoom(1.1);
				self:linear(0.8);
				self:diffusealpha(1);
				self:zoom(0.9);
				self:linear(1);
				self:zoom(0.7);
				self:linear(0.8);
				self:diffusealpha(0);
				self:zoom(0.5);
			end
		},
	},

	LoadActor( "sans/legs" )..{
		InitCommand=function (self)
			self:SetTextureFiltering(false);
		end,
		OnCommand=cmd(animate,0;setstate,0;y,70),
		IdleCommand=cmd(setstate,0),
		HurtCommand=cmd(setstate,1),
	},
	
	Def.ActorFrame{	
		OnCommand=cmd(bob;effectmagnitude,2,0,0;effectperiod,8;effectclock,"bgm";effectoffset,0),
		SlamLeftCommand=cmd(finishtweening;playcommand,"Left";decelerate,0.1;x,5;sleep,0;x,-10;linear,0.25;x,0),
		SlamRightCommand=cmd(finishtweening;playcommand,"Right";decelerate,0.1;x,-5;sleep,0;x,10;linear,0.25;x,0),
		SlamUpCommand=cmd(finishtweening;playcommand,"Up";decelerate,0.1;y,5;sleep,0;y,-10;linear,0.25;y,0),
		SlamDownCommand=cmd(finishtweening;playcommand,"Down";decelerate,0.1;y,-5;sleep,0;y,10;linear,0.25;y,0),
		CastCommand=cmd(finishtweening;playcommand,"Up";decelerate,0.1;y,5;sleep,0;y,-10;linear,0.25;y,0),
		Cast2Command=cmd(finishtweening;playcommand,"Up";decelerate,0.1;y,5;sleep,0;y,-10;linear,0.25;y,0),
		StopCommand=cmd(playcommand,"Stop2";stopeffect;),
		HurtCommand=cmd(effectperiod,16;playcommand,"Hurt2";),

		LoadActor( "sans/body" )..{
			InitCommand=function (self)
				self:SetTextureFiltering(false);
			end,
			OnCommand=cmd(bob;effectmagnitude,0,3,0;effectperiod,4;effectclock,"bgm";animate,0;setstate,0;x,20;y,-30;),
			IdleCommand=cmd(setstate,0),
			ShrugCommand=cmd(setstate,1),
			LeftCommand=cmd(setstate,3;sleep,0.1;queuecommand,"Left2";),
			Left2Command=cmd(setstate,2;sleep,0.066;queuecommand,"Left3";),
			Left3Command=cmd(setstate,0;),
			DownCommand=cmd(setstate,7;sleep,0.1;queuecommand,"Down2";),
			Down2Command=cmd(setstate,4;sleep,0.066;queuecommand,"Down3";),
			Down3Command=cmd(setstate,5;),
			UpCommand=cmd(setstate,5;sleep,0.1;queuecommand,"Up2";),
			Up2Command=cmd(setstate,6;sleep,0.066;queuecommand,"Up3";),
			Up3Command=cmd(setstate,7;),
			RightCommand=cmd(setstate,0;sleep,0.1;queuecommand,"Right2";),
			Right2Command=cmd(setstate,8;sleep,0.066;queuecommand,"Right3";),
			Right3Command=cmd(setstate,9;),
			Hurt2Command=cmd(setstate,10;effectperiod,8;),
			Stop2Command=cmd(stopeffect),
		},
		LoadActor( "sans/head" )..{
			InitCommand=function (self)
				self:SetTextureFiltering(false);
			end,
			OnCommand=cmd(bob;effectmagnitude,0,3,0;effectperiod,4;effectclock,"bgm";effectoffset,-0.3;animate,0;setstate,0;y,-76),
			HeadIdleCommand=cmd(setstate,0),
			BlinkCommand=cmd(setstate,1),
			WinkCommand=cmd(setstate,2),
			SadCommand=cmd(setstate,3),
			HappyCommand=cmd(setstate,4),
			NoEyeCommand=cmd(setstate,5),
			CastCommand=function(self)
				sans_casttime = 0;
				sans_eyecol = 1;
				self:setstate(7);
				self:sleep(0.066);
				self:queuecommand('Eye');
			end,
			Cast2Command=function(self)
				sans_casttime = 0;
				sans_eyecol = 1;
				self:setstate(7);
				self:sleep(0.066);
				self:queuecommand('Eye');
			end,
			EyeCommand=function(self)
				sans_casttime = sans_casttime+0.066;
				if sans_eyecol == 1 then
					self:setstate(6);
					sans_eyecol = 2;
				else
					self:setstate(7);
					sans_eyecol = 1;
				end
				self:sleep(0.066);
				if sans_casttime<2 then
					self:queuecommand('Eye');
				else
					self:queuecommand('HeadIdle');
				end
			end,
			Hurt2Command=cmd(setstate,8;effectperiod,8),
			Stop2Command=cmd(stopeffect;setstate,1;),
		},
		LoadActor( "sans/sweat" )..{
			InitCommand=function (self)
				self:SetTextureFiltering(false);
			end,
			OnCommand=cmd(visible,false;bob;effectmagnitude,0,3,0;effectperiod,4;effectclock,"bgm";effectoffset,-0.3;animate,0;setstate,0;y,-76),
			SweatCommand=cmd(visible,true),
			NoSweatCommand=cmd(visible,false),
			Hurt2Command=cmd(effectperiod,8),
			Stop2Command=cmd(stopeffect;visible,false),
		},
	},
	
}

return characters