local songName= GAMESTATE:GetCurrentSong():GetSongDir()

P1 = nil;
P2 = nil;

local so = GAMESTATE:GetSongOptionsObject("ModsLevel_Song")

sans_defeated = false;

sans_playerfailed = {0,0}

local function sans_mod_internal(str, pn)
	local ps= GAMESTATE:GetPlayerState(pn)
	local pmods= ps:GetPlayerOptionsString('ModsLevel_Song')
	ps:SetPlayerOptions('ModsLevel_Song', pmods .. ', ' .. str)
	--GAMESTATE:ApplyGameCommand('mod,'..str, pn)
end

local function sans_mod(str)
	for i=1,2 do
		sans_mod_internal(str, 'PlayerNumber_P' .. i)
	end
end

local function get_speed_from_poptions(player_number)
	if GAMESTATE:IsPlayerEnabled(player_number) then
		local poptionsray= GAMESTATE:GetPlayerState(player_number):GetPlayerOptionsArray("ModsLevel_Song")
		local speed= nil
		local mode= nil
		for i, el in ipairs(poptionsray) do
			local fel= el:sub(1, 1)
			local lel= el:sub(-1)
			if fel == "m" or fel == "C" then
				speed= tonumber(el:sub(2))
				mode= fel
			elseif lel == "x" then
				speed= tonumber(el:sub(1, -2))
				mode= lel
			end
			if speed and mode then
				break
			end
		end
	end
	if not speed or not mode then
		speed= 2
		mode= "x"
	end
	return { speed= speed, mode= mode }
end

local function set_player_speed(player_number, speed_info)
	if not GAMESTATE:IsPlayerEnabled(player_number) then return end
	local mode_functions= {
		x= function(speed)
				 sans_mod_internal(("*1000 %.2f"):format(speed).."x", player_number)
			 end,
		C= function(speed)
				 sans_mod_internal("*1000 C"..("%.0f"):format(speed), player_number)
			 end,
		m= function(speed)
				 local max_bpm= GAMESTATE:GetCurrentSteps(pn):GetDisplayBpms()[2]
				 local real_speed= (speed / max_bpm)
				 -- Setting an mmod while on ScreenGameplay doesn't actually work, due to the way mmods are implemented in the engine. So set the equivalent xmod
				 sans_mod_internal(("*1000 %.2f"):format(real_speed).."x", player_number)
			 end
	}
	mode_functions[speed_info.mode](speed_info.speed)
end

function simple_m0d(beat,strength,mult,mod,pn)
	if not strength then strength = 400 end
	if not mult then mult = 1 end
	if not mod then mod = 'drunk' end
	
	local alive = math.max(2*mult*math.abs(strength)/100,0.25)
	
	table.insert(mods,{beat,'*100000 '..strength..' '..mod,pn});
	table.insert(mods,{beat+.1,'*'..((1/mult)*math.abs(strength)/100)..' no '..mod,pn});
end
			
--alternates a mod back and forth before resetting to 0
--beat,num,div,amt,mod,pn
function mod_wiggle(beat,num,div,amt,mod,pn,first)
	local fluct = 1
	for i=0,(num-1) do
		b = beat+(i/div)
		local m = 1
		if i==0 and not first then m = 0.5 end
		table.insert(mods,{b,'*'..math.abs(m*amt/10)..' '..(amt*fluct)..' '..mod..'',pn});
		fluct = fluct*-1;
	end
	table.insert(mods,{beat+(num/div),'*'..math.abs(amt/20)..' no '..mod..'',pn});
end

-- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
-- INPUT handler provided by a very generous man mr guzek, verrry generous
-- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

local tpaused = false;
local songEndable = false;

local InputHandler = function( event )

	-- if (somehow) there's no event, bail
	if not event then return end

	-- pause or unpause with the start button
	if event.type == "InputEventType_FirstPress" and event.button == "Start" then
		
		local screen = SCREENMAN:GetTopScreen()
		-- interfere with going back, in a very dumb way.
		
		if GAMESTATE:GetSongBeat() > 544 and not songEndable then
			tpaused = not tpaused
			screen:PauseGame(tpaused)
			tpaused = not tpaused
			screen:PauseGame(tpaused)
			
			if GAMESTATE:GetSongBeat() < 735 then
				so:MusicRate( 0.2 );
				MESSAGEMAN:Broadcast('StartPressed');
			end
			
		end
		
		if GAMESTATE:GetSongBeat() > 735 then
			tpaused = not tpaused
			screen:PauseGame(tpaused)
			tpaused = not tpaused
			screen:PauseGame(tpaused)
		end
		
	end

end

local function sans_init()
	checked = false;
	
	sans_diffP1 = -1;
	sans_diffP2 = -1;
	
	if GAMESTATE:IsPlayerEnabled(PLAYER_1) then
		sans_diffP1 = Difficulty:Reverse()[GAMESTATE:GetCurrentSteps(PLAYER_1):GetDifficulty()]
	end
	if GAMESTATE:IsPlayerEnabled(PLAYER_2) then
		sans_diffP2 = Difficulty:Reverse()[GAMESTATE:GetCurrentSteps(PLAYER_2):GetDifficulty()]
	end
	
	sans_speedmodP1 = get_speed_from_poptions(PLAYER_1)
	sans_speedmodP2 = get_speed_from_poptions(PLAYER_2)
	
	fgcurcommand = 1;
	checked = false;
	
	sans_finalEvent = false;
			
	mod_firstSeenBeat = GAMESTATE:GetSongBeat()
	
	sans_bonetrousle = 96;
	sans_bonetrousle2 = 356;
			
			
--how can I make simple m0d?
--this will instantly turn a mod on to max and then quickly turn it off with the specified parameters
--it's a simple mod

function simple_m0d(beat,strength,mult,mod,pn)
	if not strength then strength = 400 end
	if not mult then mult = 1 end
	if not mod then mod = 'drunk' end
	
	local alive = math.max(2*mult*math.abs(strength)/100,0.25)
	
	table.insert(mods,{beat,'*100000 '..strength..' '..mod,pn});
	table.insert(mods,{beat+.1,'*'..((1/mult)*math.abs(strength)/100)..' no '..mod,pn});
end

function mod_bamBaBamBaBam(beat,amt,mult,mod)
	simple_m0d(beat,amt,mult,mod);
	--simple_m0d(beat+1,amt,mult,mod);
	simple_m0d(beat+1.5,amt,mult,mod);
	--simple_m0d(beat+2.5,amt,mult,mod);
	simple_m0d(beat+3,amt,mult,mod);
end

function mod_baBamBaBam(beat,amt,mult,mod)
	simple_m0d(beat,amt,mult,mod);
	simple_m0d(beat+0.5,amt,mult,mod);
	simple_m0d(beat+1.5,amt,mult,mod);
	simple_m0d(beat+2,amt,mult,mod);
end

function mod_boneBam(beat,dir)
	local early = 0.2
	if dir and dir == 1 then
		early = 0.3
	end
	
	table.insert(actions,{beat-early,function()
		
		if dir and dir == 1 then
			local a = GetNewBone()
			if a then
				a:rotationz(0);
				a:zoom(3);
				a:y(SCREEN_CENTER_Y);
				a:x(SCREEN_WIDTH+50)
				a:decelerate(0.3);
				a:x(SCREEN_CENTER_X);
				a:accelerate(0.3);
				a:x(SCREEN_WIDTH+50)
				a:queuecommand('Hide');
			end
			
			local a = GetNewBone()
			if a then
				a:rotationz(180);
				a:zoom(3);
				a:y(SCREEN_CENTER_Y);
				a:x(-50)
				a:sleep(1.5/4);
				a:decelerate(0.3);
				a:x(SCREEN_CENTER_X);
				a:accelerate(0.3);
				a:x(-50)
				a:queuecommand('Hide');
			end
			
			local a = GetNewBone()
			if a then
				a:rotationz(0);
				a:zoom(3);
				a:y(SCREEN_CENTER_Y);
				a:x(SCREEN_WIDTH+50);
				a:sleep(3/4);
				a:decelerate(0.3);
				a:x(SCREEN_CENTER_X);
				a:accelerate(0.3);
				a:x(SCREEN_WIDTH+50)
				a:queuecommand('Hide');
			end
		else
			local a = GetNewBone()
			if a then
				a:rotationz(90);
				a:zoom(3);
				a:x(SCREEN_CENTER_X);
				a:y(SCREEN_BOTTOM+50)
				a:decelerate(0.2);
				a:y(SCREEN_CENTER_Y);
				a:accelerate(0.2);
				a:y(SCREEN_BOTTOM+50)
				a:queuecommand('Hide');
			end
			
			local a = GetNewBone()
			if a then
				a:rotationz(-90);
				a:zoom(3);
				a:x(SCREEN_CENTER_X);
				a:y(-50)
				a:sleep(1.5/4)
				a:decelerate(0.2);
				a:y(SCREEN_CENTER_Y);
				a:accelerate(0.2);
				a:y(-50)
				a:queuecommand('Hide');
			end
			
			local a = GetNewBone()
			if a then
				a:rotationz(90);
				a:zoom(3);
				a:x(SCREEN_CENTER_X);
				a:y(SCREEN_BOTTOM+50)
				a:sleep(3/4)
				a:decelerate(0.2);
				a:y(SCREEN_CENTER_Y);
				a:accelerate(0.2);
				a:y(SCREEN_BOTTOM+50)
				a:queuecommand('Hide');
			end
		end
	
	end})
end

function mod_hallDist(beat,amt,mult)
	simple_m0d(beat,amt,mult,'hallway');
	simple_m0d(beat+1.5,amt,mult,'distant');
	simple_m0d(beat+3,amt,mult,'hallway');
end
			
--alternates a mod back and forth before resetting to 0
--beat,num,div,amt,mod,pn
function mod_wiggle(beat,num,div,amt,mod,pn,first)
	local fluct = 1
	for i=0,(num-1) do
		b = beat+(i/div)
		local m = 1
		if i==0 and not first then m = 0.5 end
		table.insert(mods,{b,'*'..math.abs(m*amt/10)..' '..(amt*fluct)..' '..mod..'',pn});
		fluct = fluct*-1;
	end
	table.insert(mods,{beat+(num/div),'*'..math.abs(amt/20)..' no '..mod..'',pn});
end
			
--lua course :D
curmod = 1;
--{beat,mod,player}
mods = {
{0,'clearall'},
{1,'*10 1.75x'},
{1,'*1 sudden, *100000 100 suddenoffset'},

{31.5,'*10000 150 beat'},
{59.5,'*10000 no beat'},
{63.5,'*10000 150 beat'},
{91.5,'*10000 no beat'},

{159.5,'*10000 150 beat'},
{163.5,'*10000 no beat'},
{175.5,'*10000 150 beat'},
{187.5,'*10000 no beat'},

{159.5+64,'*10000 150 beat'},
{163.5+64,'*10000 no beat'},
{175.5+64,'*10000 150 beat'},
{187.5+64,'*10000 no beat'},

{95.8,'*10 100 drunk'},
{95.8+8,'*20 -100 drunk'},
{95.8+16,'*20 100 drunk'},
{95.8+24,'*10 no drunk'},

{127.8,'*10 100 drunk'},
{127.8+8,'*20 -100 drunk'},
{127.8+16,'*10 no drunk'},

{96,'100 wave'},
{144,'no wave'},

{125,'*2 reverse'},
{135,'*4 no reverse'},

{151.8,'*10 100 mini'},
{152.9,'*5 75 mini'},
{153.4,'*5 50 mini'},
{154.4,'*5 25 mini'},
{155.4,'*5 0 mini'},

{169,'*2 50 reverse'},
{170,'*100000 centered, *100000 1.25x, *100000 split, *0.5 no reverse, *10000 wave'},
{170.05,'*1.25 1.25x'},

{184,'*1 no split, *1 no centered, *0.5 1.75x, *1 no wave'},

{192-.2,'*30 300 drunk',1},
{193-.2,'*30 no drunk',1},
{194-.2,'*30 300 tipsy',1},
{195-.2,'*30 no tipsy',1},
{192-.2,'*30 -300 drunk',2},
{193-.2,'*30 no drunk',2},
{194-.2,'*30 -300 tipsy',2},
{195-.2,'*30 no tipsy',2},

{212,'*0.4 50 reverse'},
{216,'*0.4 100 reverse'},

{233,'*2 50 reverse'},
{234,'*100000 centered, *100000 1.25x, *100000 alternate, *0.5 no reverse, *10000 wave'},
{234.05,'*1.25 1.25x'},

{248,'*1 no split, *1 no alternate, *1 no centered, *0.5 1.75x, *1 no wave'},

{256-.2,'*30 300 drunk',1},
{257-.2,'*30 no drunk',1},
{258-.2,'*30 300 tipsy',1},
{259-.2,'*30 no tipsy',1},
{256-.2,'*30 -300 drunk',2},
{257-.2,'*30 no drunk',2},
{258-.2,'*30 -300 tipsy',2},
{259-.2,'*30 no tipsy',2},

{276,'*0.4 50 reverse'},
{280,'*0.4 no reverse'},

{480,'*0.025 50 reverse'},
{544-.1,'*5 no reverse'},

{549,'*100000 1000x'},
{736,'*100000 10x'},

}

for i=0,3 do
	table.insert(mods,{144+i*2,'*4 reverse'})
	table.insert(mods,{145+i*2,'*4 no reverse'})
end

--mod_wiggle(beat,num,div,amt,mod,pn)
--mod_wiggle(144-.1,17,2,200,'drunk');

mod_wiggle(164-.1,4,2,300,'tipsy');
mod_wiggle(166-.1,4,2,300,'drunk');
mod_wiggle(212-.1,9,2,300,'drunk');

mod_wiggle(164-.1+64,4,2,300,'tipsy');
mod_wiggle(166-.1+64,4,2,300,'drunk');
mod_wiggle(212-.1+64,9,2,300,'drunk');

--simple_m0d(beat,amt,mult,mod)
simple_m0d(155.5,100,1,'tornado');
simple_m0d(216,100,1,'tornado');
simple_m0d(280,100,1,'tornado');

--mod_bamBaBamBaBam(beat,amt,mult,mod)
mod_bamBaBamBaBam(60-.1,-100,0.25,'mini');
mod_bamBaBamBaBam(60-.1,15,0.25,'flip');
mod_hallDist(60-.1,250,0.25)
mod_bamBaBamBaBam(92-.1,-100,0.25,'mini');
mod_bamBaBamBaBam(92-.1,15,0.25,'flip');
mod_hallDist(92-.1,250,0.25)
mod_bamBaBamBaBam(124-.1,-50,0.25,'mini');
mod_bamBaBamBaBam(124-.1,5,0.25,'flip');
mod_baBamBaBam(157-.1,-100,0.25,'mini');
mod_bamBaBamBaBam(188-.1,-100,0.25,'mini');
mod_bamBaBamBaBam(188-.1,15,0.25,'flip');
mod_hallDist(188-.1,250,0.25)
mod_bamBaBamBaBam(220-.1,-100,0.25,'mini');
mod_bamBaBamBaBam(220-.1,15,0.25,'flip');
mod_hallDist(220-.1,250,0.25)
mod_bamBaBamBaBam(188-.1+64,-100,0.25,'mini');
mod_bamBaBamBaBam(188-.1+64,15,0.25,'flip');
mod_hallDist(188-.1+64,250,0.25)
mod_bamBaBamBaBam(220-.1+64,-100,0.25,'mini');
mod_bamBaBamBaBam(220-.1+64,15,0.25,'flip');
mod_hallDist(220-.1+64,250,0.25)

table.insert(mods,{289.6,'*20 200 drunk'});
table.insert(mods,{290.4,'*10 no drunk'});
table.insert(mods,{297.4,'*15 150 drunk'});
table.insert(mods,{299.4,'*7.5 no drunk'});
table.insert(mods,{305.6,'*20 200 drunk'});
table.insert(mods,{306.4,'*10 no drunk'});
table.insert(mods,{313.6,'*20 200 drunk, *10 -100 flip, *10 100 invert'});
table.insert(mods,{314.4,'*10 no drunk'});
table.insert(mods,{320,'*4 no flip, *4 no invert'});
table.insert(mods,{321.6,'*20 200 tipsy, *2 20 reverse, *10 -100 centered'});
table.insert(mods,{322.4,'*10 no tipsy'});
table.insert(mods,{329.6,'*20 200 tipsy, *2 20 reverse, *10 100 centered'});
table.insert(mods,{330.4,'*10 no tipsy'});
table.insert(mods,{337.6,'*20 200 tipsy, *20 200 drunk, *2 20 reverse, *20 100 centered'});
table.insert(mods,{338.4,'*10 no tipsy, *10 no drunk'});
table.insert(mods,{345.6,'*20 200 tipsy, *20 200 drunk, *2 20 reverse, *20 -100 centered'});
table.insert(mods,{346.4,'*10 no tipsy, *10 no drunk'});
table.insert(mods,{353.6,'*20 200 tipsy, *20 200 drunk, *2 20 reverse, *20 -100 centered'});
table.insert(mods,{354.4,'*10 no tipsy, *10 no drunk'});
table.insert(mods,{361.6,'*20 200 tipsy, *20 200 drunk, *2 20 reverse, *20 100 centered'});
table.insert(mods,{362.4,'*10 no tipsy, *10 no drunk'});
table.insert(mods,{369.6,'*10 no centered, *2 20 flip, *2 no reverse, *20 200 drunk'});
table.insert(mods,{370.4,'*10 no drunk'});
table.insert(mods,{377.6,'*10 no centered, *2 20 flip, *2 20 reverse, *20 200 drunk'});
table.insert(mods,{378.4,'*10 no drunk'});
table.insert(mods,{385.6,'*10 no centered, *0.5 25 flip, *1 30 reverse, *20 200 drunk'});
table.insert(mods,{386.4,'*10 no drunk'});
table.insert(mods,{393.6,'*20 200 drunk, *15 -125 flip, *3 no reverse'});
table.insert(mods,{394.4,'*10 no drunk'});
table.insert(mods,{401.6,'*20 200 drunk, *6.25 -62.5 flip, *6.25 -62.5 invert, *3 no reverse'});
table.insert(mods,{402.4,'*10 no drunk'});
table.insert(mods,{409.6,'*20 200 drunk, *6.25 -125 flip, *6.25 no invert, *3 no reverse'});
table.insert(mods,{410.4,'*10 no drunk'});

mod_bamBaBamBaBam(412-.1,-40,0.25,'mini');
--mod_hallDist(412-.1,250,0.25);

local s = char_sans;
local t1 = sans_introtext
local t2 = sans_misctext1
local t3 = sans_endingtext
sans_introset = 0;

local sans_ending_faces = {
	'IdleHead',
	'Wink',
	'Happy',
	'Wink',
	'Happy',
	'Blink',
	'Sad',
	'Sad',
	'Happy',
	'IdleHead',
	'NoEye',
	'Wink',
}

function sans_saveFileExists()
	local path=GAMESTATE:GetCurrentSong():GetSongDir();
	if FILEMAN:DoesFileExist(path.."lua/chara/sans/savefile.lua") then
		return true
	end
	return false
end

function sans_writeSaveFile()
	local file = RageFileUtil.CreateRageFile()
	local path=GAMESTATE:GetCurrentSong():GetSongDir();
	file:Open( path.."lua/chara/sans/savefile.lua", 2 ) --2 = write
	file:PutLine("sans_played = "..sans_played)
	file:PutLine("sans_failed = "..sans_failed)
	file:Close();
end

if sans_saveFileExists() then
	--SCREENMAN:SystemMessage('Save File exists, loading');
	LoadActor("chara/sans/savefile")
else
	--SCREENMAN:SystemMessage('Save File does not exist, creating new');
	sans_played = 0
	sans_failed = 0
	sans_writeSaveFile()
end

if sans_played == 0 then
	sans_introset = 0;
else
	if sans_failed == 0 then
		sans_introset = 8;
	else
		sans_introset = math.min(sans_failed,7)
	end
end

sans_played = sans_played+1;
sans_failed = sans_failed+1;

sans_writeSaveFile()

sans_char_pause_actions = {
	function()
		s:x(SCREEN_WIDTH*0.85);
		s:playcommand('Idle');
		s:playcommand('Wink');
	end,
	function()
		s:x(SCREEN_WIDTH*0.15);
		s:playcommand('Idle');
		s:playcommand('Happy');
	end,
	function()
		s:x(SCREEN_CENTER_X-280);
		s:y(SCREEN_CENTER_Y);
		s:rotationz(90);
		s:playcommand('Shrug');
		s:playcommand('Wink');
	end,
	function()
		s:rotationz(0);
		s:zoom(0)
		s:x(SCREEN_WIDTH*0.85);
		s:y(SCREEN_HEIGHT+100);
		s:playcommand('Idle');
		s:playcommand('HeadIdle');
	end,
	function()
		s:rotationz(180);
		s:zoom(1)
		s:x(SCREEN_WIDTH*0.85);
		s:y(100);
		s:playcommand('Down3');
		s:playcommand('Happy');
	end,
	function()
		MESSAGEMAN:Broadcast('Bones3');
		s:rotationz(0);
		s:zoom(1)
		s:x(SCREEN_WIDTH*0.5);
		s:y(SCREEN_BOTTOM-30);
		s:playcommand('Right3');
		s:playcommand('Wink');
	end,
	function()
		MESSAGEMAN:Broadcast('Bones3Away');
		s:x(SCREEN_WIDTH*0.85);
		s:playcommand('Up3');
		s:playcommand('NoEye');
	end,
	function()
		s:x(SCREEN_WIDTH*0.5);
		s:y(SCREEN_CENTER_Y+100);
		s:playcommand('Idle');
		s:playcommand('Happy');
	end,
}

--sans got tha moves
sans_curaction = 1;
--{beat,action,persist}
sans_actions = {
	{1,function()
		s:x(SCREEN_CENTER_X);
		s:y(SCREEN_CENTER_Y+100);
		s:queuecommand('Spawn');
	end},
	{1,function() MESSAGEMAN:Broadcast('SpeechBubA'); end},
	{2,function()
		GasterSound('talk');
		t1:visible(true);
		t1:setstate((sans_introset*4)+0);
		t1:cropbottom(1);
		t1:linear(0.2)
		t1:cropbottom(0);
	end},
	{6,function()
		GasterSound('talk');
		t1:visible(true);
		t1:setstate((sans_introset*4)+1);
		t1:cropbottom(1);
		t1:linear(0.2)
		t1:cropbottom(0);
	end},
	{12,function()
		GasterSound('talk');
		t1:visible(true);
		t1:setstate((sans_introset*4)+2);
		t1:cropbottom(1);
		t1:linear(0.2)
		t1:cropbottom(0);
	end},
	{18,function()
		GasterSound('talk');
		t1:visible(true);
		t1:setstate((sans_introset*4)+3);
		t1:cropbottom(1);
		t1:linear(0.2)
		t1:cropbottom(0);
	end},
	{24,function()
		GasterSound('talk');
	end},
	{24,function() MESSAGEMAN:Broadcast('TextBadTime'); end},
	{27.6,function()
		GasterSound('cast');
		s:playcommand('Blink');
	end},
	{28,function()
		s:playcommand('Cast');
	end},
	{32-.05,function()
		MESSAGEMAN:Broadcast('SpeechBubAAway');
		MESSAGEMAN:Broadcast('TextBadTimeAway');
		s:queuecommand('HideQ');
	end},
	
	{94,function()
		s:playcommand('Idle');
		s:playcommand('SpawnQ');
		s:x(-100);
		s:y(SCREEN_CENTER_Y+100);
		s:linear(0.5);
		s:x(SCREEN_WIDTH*0.15);
	end,true},
	{96,function() MESSAGEMAN:Broadcast('SpeechBubB'); end},
	{96,function()
		GasterSound('talk');
		t2:visible(true);
		t2:setstate(0);
		t2:cropbottom(1);
		t2:linear(0.2)
		t2:cropbottom(0);
	end},
	{106,function()
		s:playcommand('Happy');
		GasterSound('talk');

		t2:visible(true);
		t2:setstate(1);
		t2:cropbottom(1);
		t2:linear(0.2)
		t2:cropbottom(0);
	end},
	{116,function()
		s:playcommand('HeadIdle');
		MESSAGEMAN:Broadcast('SpeechBubBAway');
		t2:visible(false);
	end},
	
	{128,function() MESSAGEMAN:Broadcast('SpeechBubB'); end},
	{128,function()
		GasterSound('talk');
		t2:visible(true);
		t2:setstate(2);
		t2:cropbottom(1);
		t2:linear(0.2)
		t2:cropbottom(0);
	end},
	{136,function()
		s:playcommand('Wink');
		GasterSound('talk');
		t2:visible(true);
		t2:setstate(3);
		t2:cropbottom(1);
		t2:linear(0.2)
		t2:cropbottom(0);
	end},
	
	{144,function()
		s:playcommand('HeadIdle');
		MESSAGEMAN:Broadcast('SpeechBubBAway');
		t2:visible(false);
	end},
	
	{284,function()
		s:linear(0.5);
		s:x(-100);
	end,true},
	
	{300-4,function() MESSAGEMAN:Broadcast('SpeechBubE'); end},
	{300-4,function()
		GasterSound('talk');
		t2:visible(true);
		t2:zoom(1);
		t2:x(130);
		t2:y(SCREEN_CENTER_Y+30);
		t2:setstate(4);
		t2:cropbottom(1);
		t2:linear(0.2)
		t2:cropbottom(0);
	end},
	{308-4,function()
		GasterSound('talk');
		t2:visible(true);
		t2:setstate(5);
		t2:cropbottom(1);
		t2:linear(0.2)
		t2:cropbottom(0);
	end},
	{316-4,function()
		t2:visible(false);
		MESSAGEMAN:Broadcast('SpeechBubCAway');
	end},
	
	
	{128-.6,function() s:playcommand('SlamDown'); end},
	{136-.6,function() s:playcommand('SlamUp'); end},
	{152-.6,function() s:playcommand('Idle'); end},
	{155.5-.6,function() s:playcommand('SlamRight'); end},
	
	{160,function() s:playcommand('Idle'); end},
	
	{192-.6,function() s:playcommand('SlamRight'); end},
	{194-.6,function() s:playcommand('SlamUp'); end},
	{196-.6,function() s:playcommand('SlamLeft'); end},
	{198-.6,function() s:playcommand('SlamUp'); end},
	{200-.6,function() s:playcommand('SlamRight'); end},
	{202-.6,function() s:playcommand('SlamDown'); end},
	{204-.6,function() s:playcommand('SlamLeft'); end},
	{206-.6,function() s:playcommand('SlamRight'); end},
	{208-.6,function() s:playcommand('SlamUp'); end},
	{216-.6,function() s:playcommand('SlamDown'); end},
	{220,function() s:playcommand('Shrug'); end},
	{224,function() s:playcommand('Idle'); end},
	
	{256-.6,function() s:playcommand('SlamRight'); end},
	{258-.6,function() s:playcommand('SlamUp'); end},
	{260-.6,function() s:playcommand('SlamLeft'); end},
	{262-.6,function() s:playcommand('SlamUp'); end},
	{264-.6,function() s:playcommand('SlamLeft'); end},
	{266-.6,function() s:playcommand('SlamDown'); end},
	{268-.6,function() s:playcommand('SlamRight'); end},
	{270-.6,function() s:playcommand('SlamLeft'); end},
	{272-.6,function() s:playcommand('SlamUp'); end},
	{276-.6,function() s:playcommand('SlamDown'); end},
	{280-.6,function() s:playcommand('SlamUp'); end},
	{284,function() s:playcommand('Shrug'); end},
	{288,function() s:playcommand('Idle'); end},
	
	{480-.6,function() s:playcommand('SlamRight'); end},
	
	{544,function() s:playcommand('HeadIdle'); end},
	{544,function() s:playcommand('Idle'); end},
	{544,function() s:playcommand('Sweat'); end},
	
	{736,function()
		if not sans_defeated then
			if sans_playerfailed[1] == 0 or sans_playerfailed[2] == 0 then
				sans_pldead2 = 0
			else
				sans_pldead2 = 4
			end
			MESSAGEMAN:Broadcast('TextTimeUp');
		end
	end},
	{736,function() if not sans_defeated then MESSAGEMAN:Broadcast('SpeechBubA'); end end},
	{736,function() if not sans_defeated then s:playcommand('HeadIdle'); GasterSound('talk'); end end},
	{751,function()
		if not sans_defeated then
			if sans_pldead2 < 4 then
				s:playcommand('Wink');
			else
				s:playcommand('HeadIdle');
			end
			GasterSound('talk');
		end
	end},
	{765,function()
		if not sans_defeated then
			if sans_pldead2 < 4 then
				s:playcommand('Blink');
			else
				s:playcommand('Wink');
			end
			GasterSound('talk');
		end
	end},
	{779,function()
		if not sans_defeated then
			s:playcommand('NoEye');
			s:playcommand('SlamUp');
			GasterSound('talk');
			GasterSound('spam');
			if SCREENMAN:GetTopScreen():GetChild("Overlay") then
				SCREENMAN:GetTopScreen():GetChild("Overlay"):sleep(0.25);
				SCREENMAN:GetTopScreen():GetChild("Overlay"):linear(6*5);
				SCREENMAN:GetTopScreen():GetChild("Overlay"):addy(-2000*5);
			end
		end
	end},
	{779.5,function()
		if not sans_defeated then
			GasterSound('manydamage');
		end
	end},
	{788,function()
		if not sans_defeated then
			if GAMESTATE:IsPlayerEnabled(PLAYER_1) then
				local pss = STATSMAN:GetCurStageStats():GetPlayerStageStats(PLAYER_1);
				if pss then
					pss:FailPlayer()
				end
			end
			if GAMESTATE:IsPlayerEnabled(PLAYER_2) then
				local pss = STATSMAN:GetCurStageStats():GetPlayerStageStats(PLAYER_2);
				if pss then
					pss:FailPlayer()
				end
			end
		end
	end},
	
	{560,function() if not sans_defeated then MESSAGEMAN:Broadcast('SpeechBubA'); end end},
	
	{560+(12*0),function()
		if not sans_defeated then
			if sans_playerfailed[1] == 0 or sans_playerfailed[2] == 0 then sans_pldead = 0 else sans_pldead = 12 end
			GasterSound('talk');
			char_sans:playcommand(sans_ending_faces[0+1]); t3:setstate(sans_pldead+0);
			t3:visible(true); t3:cropbottom(1); t3:linear(0.6); t3:cropbottom(0);
		end
	end},
	{560+(12*1),function()
		if not sans_defeated then
			GasterSound('talk');
			char_sans:playcommand(sans_ending_faces[1+1]); t3:setstate(sans_pldead+1);
			t3:visible(true); t3:cropbottom(1); t3:linear(0.6); t3:cropbottom(0);
		end
	end},
	{560+(12*2),function()
		if not sans_defeated then
			GasterSound('talk');
			char_sans:playcommand(sans_ending_faces[2+1]); t3:setstate(sans_pldead+2);
			t3:visible(true); t3:cropbottom(1); t3:linear(0.6); t3:cropbottom(0);
		end
	end},
	{560+(12*3),function()
		if not sans_defeated then
			GasterSound('talk');
			char_sans:playcommand(sans_ending_faces[3+1]); t3:setstate(sans_pldead+3);
			t3:visible(true); t3:cropbottom(1); t3:linear(0.6); t3:cropbottom(0);
		end
	end},
	{560+(12*4),function()
		if not sans_defeated then
			GasterSound('talk');
			char_sans:playcommand(sans_ending_faces[4+1]); t3:setstate(sans_pldead+4);
			t3:visible(true); t3:cropbottom(1); t3:linear(0.6); t3:cropbottom(0);
		end
	end},
	{560+(12*5),function()
		if not sans_defeated then
			GasterSound('talk');
			char_sans:playcommand(sans_ending_faces[5+1]); t3:setstate(sans_pldead+5);
			t3:visible(true); t3:cropbottom(1); t3:linear(0.6); t3:cropbottom(0);
		end
	end},
	{560+(12*6),function()
		if not sans_defeated then
			GasterSound('talk');
			char_sans:playcommand(sans_ending_faces[6+1]); t3:setstate(sans_pldead+6);
			t3:visible(true); t3:cropbottom(1); t3:linear(0.6); t3:cropbottom(0);
		end
	end},
	{560+(12*7),function()
		if not sans_defeated then
			GasterSound('talk');
			char_sans:playcommand(sans_ending_faces[7+1]); t3:setstate(sans_pldead+7);
			t3:visible(true); t3:cropbottom(1); t3:linear(0.6); t3:cropbottom(0);
		end
	end},
	{560+(12*8),function()
		if not sans_defeated then
			GasterSound('talk');
			char_sans:playcommand(sans_ending_faces[8+1]); t3:setstate(sans_pldead+8);
			t3:visible(true); t3:cropbottom(1); t3:linear(0.6); t3:cropbottom(0);
		end
	end},
	{560+(12*9),function()
		if not sans_defeated then
			GasterSound('talk');
			char_sans:playcommand(sans_ending_faces[9+1]); t3:setstate(sans_pldead+9);
			t3:visible(true); t3:cropbottom(1); t3:linear(0.6); t3:cropbottom(0);
		end
	end},
	{560+(12*10),function()
		if not sans_defeated then
			GasterSound('talk');
			char_sans:playcommand(sans_ending_faces[10+1]); t3:setstate(sans_pldead+10);
			t3:visible(true); t3:cropbottom(1); t3:linear(0.6); t3:cropbottom(0);
		end
	end},
	{560+(12*11),function()
		if not sans_defeated then
			GasterSound('talk');
			char_sans:playcommand(sans_ending_faces[11+1]); t3:setstate(sans_pldead+11);
			t3:visible(true); t3:cropbottom(1); t3:linear(0.6); t3:cropbottom(0);
		end
	end},
	{560+(12*12),function()
		if not sans_defeated then
			t3:visible(false);
			MESSAGEMAN:Broadcast('SpeechBubCAway');
		end
	end},
	
}

for i=0,3 do
	table.insert(sans_actions,{(144-.6)+(i*2),function() s:playcommand('SlamDown'); end})
	table.insert(sans_actions,{(145-.6)+(i*2),function() s:playcommand('SlamUp'); end})
end

curaction = 1;
--{beat,action,persist}
actions = {
	{32-.05,function()
		MESSAGEMAN:Broadcast('WhiteFlash');
		MESSAGEMAN:Broadcast('BoneZone');
		
		for pn=1,2 do
			local a = _G['P'..pn]
			if a then
				a:x(SCREEN_CENTER_X);
				a:y(SCREEN_CENTER_Y);
				a:bob();
				a:zoom(0.9)
				a:effectclock('bgm');
				a:effectmagnitude(0,-64,0);
				a:effectperiod(4);
			end
		end
		if P1 and P2 then
			local jud1 = P1:GetChild('Judgment')
			local com1 = P1:GetChild('Combo')
			local jud2 = P2:GetChild('Judgment')
			local com2 = P2:GetChild('Combo')
			--[[
			jud1:x(-60);
			com1:x(-60);
			jud2:x(60);
			com2:x(60);
			]]
			
			--retarded
			jud1:bob()
			jud1:effectmagnitude(-60,0,0)
			jud1:effectperiod(1000000)
			jud1:effectoffset(250000)
			com1:bob()
			com1:effectmagnitude(-60,0,0)
			com1:effectperiod(1000000)
			com1:effectoffset(250000)
			jud2:bob()
			jud2:effectmagnitude(60,0,0)
			jud2:effectperiod(1000000)
			jud2:effectoffset(250000)
			com2:bob()
			com2:effectmagnitude(60,0,0)
			com2:effectperiod(1000000)
			com2:effectoffset(250000)
			
			jud1:basezoomx(0.80);
			jud1:basezoomy(0.80);
			com1:basezoomx(0.80);
			com1:basezoomy(0.80);
			jud2:basezoomx(0.80);
			jud2:basezoomy(0.80);
			com2:basezoomx(0.80);
			com2:basezoomy(0.80);
		end
	end, true},
	{92,function()
		MESSAGEMAN:Broadcast('BonesAway');
	end,true},
	{96,function()
		
		for pn=1,2 do
			local a = _G['P'..pn]
			if a then
				a:stopeffect()
				a:decelerate(0.5);
				a:x(SCREEN_CENTER_X);
				a:y(SCREEN_CENTER_Y);
				a:zoom(1)
			end
		end
		
	end,true},
	{155.3,function()
		for pn=1,2 do
			local a = _G['P'..pn]
			if a then
				a:decelerate(0.1)
				a:rotationz(-90);
				a:x(SCREEN_CENTER_X);
				a:y(SCREEN_CENTER_Y);
			end
		end
	end},
	{160,function()
		for pn=1,2 do
			local a = _G['P'..pn]
			if a then
				a:bounceend(0.25)
				a:rotationz(0);
			end
		end
	end},
	{168,function()
		for pn=1,2 do
			local a = _G['P'..pn]
			if a then
				a:decelerate(0.25)
				a:rotationz(360);
				a:sleep(0);
				a:rotationz(0);
			end
		end
	end},
	{196-.2,function()
		for pn=1,2 do
			local a = _G['P'..pn]
			if a then
				a:linear(0.1);
				a:rotationz(-90);
				a:sleep(0.4);
				a:linear(0.1);
				a:rotationz(0);
				a:sleep(0.4);
				a:linear(0.1);
				a:rotationz(90);
				a:sleep(0.4);
				a:linear(0.1);
				a:rotationz(180);
				a:sleep(0.4);
				a:linear(0.1);
				a:rotationz(270);
				a:sleep(0.4);
				a:linear(0.1);
				a:rotationz(90);
				a:sleep(0.4);
				a:linear(0.1);
				a:rotationz(0);
			end
		end
	end},
	{168+64,function()
		for pn=1,2 do
			local a = _G['P'..pn]
			if a then
				a:decelerate(0.25)
				a:rotationz(-360);
				a:sleep(0);
				a:rotationz(0);
			end
		end
	end},
	{196-.2+64,function()
		for pn=1,2 do
			local a = _G['P'..pn]
			if a then
				a:linear(0.1);
				a:rotationz(90);
				a:sleep(0.4);
				a:linear(0.1);
				a:rotationz(0);
				a:sleep(0.4);
				a:linear(0.1);
				a:rotationz(-90);
				a:sleep(0.4);
				a:linear(0.1);
				a:rotationz(-180);
				a:sleep(0.4);
				a:linear(0.1);
				a:rotationz(-270);
				a:sleep(0.4);
				a:linear(0.1);
				a:rotationz(-90);
				a:sleep(0.4);
				a:linear(0.1);
				a:rotationz(0);
			end
		end
	end},
	{284,function()
		for pn=1,2 do
			local a = _G['P'..pn]
			if a then
				a:linear(1);
				a:zoom(0.8);
			end
		end
	end},
	
	{287.5,function() GasterSound('gaster_spawn') end},
	{291.5,function() GasterSound('gaster_fire') end},
	{295.5,function() GasterSound('gaster_spawn') end},
	{299.5,function() GasterSound('gaster_fire') end},
	{303.5,function() GasterSound('gaster_spawn') end},
	{307.5,function() GasterSound('gaster_fire') end},
	{311.5,function() GasterSound('gaster_spawn') end},
	{315.5,function() GasterSound('gaster_fire') end},
	{319.5,function() GasterSound('gaster_spawn') end},
	{323.5,function() GasterSound('gaster_fire') end},
	{327.5,function() GasterSound('gaster_spawn') end},
	{331.5,function() GasterSound('gaster_fire') end},
	{335.5,function() GasterSound('gaster_spawn') end},
	{339.5,function() GasterSound('gaster_fire') end},
	{343.5,function() GasterSound('gaster_spawn') end},
	{347.5,function() GasterSound('gaster_fire') end},
	{351.5,function() GasterSound('gaster_spawn') end},
	{355.5,function() GasterSound('gaster_fire') end},
	{359.5,function() GasterSound('gaster_spawn') end},
	{363.5,function() GasterSound('gaster_fire') end},
	{367.5,function() GasterSound('gaster_spawn') end},
	{371.5,function() GasterSound('gaster_fire') end},
	{375.5,function() GasterSound('gaster_spawn') end},
	{379.5,function() GasterSound('gaster_fire') end},
	{383.5,function() GasterSound('gaster_spawn') end},
	{387.5,function() GasterSound('gaster_fire') end},
	{391.5,function() GasterSound('gaster_spawn') end},
	{395.5,function() GasterSound('gaster_fire') end},
	{399.5,function() GasterSound('gaster_spawn') end},
	{403.5,function() GasterSound('gaster_fire') end},
	{407.5,function() GasterSound('gaster_spawn') end},
	{411.5,function() GasterSound('gaster_fire') end},
	
	{288,function()
		
		local a = GetNewGaster();
		a:rotationz(0);
		a:zoom(1.5);
		a:x(-100);
		a:y(100);
		a:decelerate(0.5);
		a:x(SCREEN_CENTER_X);
		a:rotationz(720);
		a:sleep(0.5);
		a:rotationz(0);
		a:queuecommand('Fire');
		a:sleep(0.5)
		a:accelerate(0.5)
		a:addy(-SCREEN_HEIGHT/2)
		a:sleep(2); a:queuecommand('Done');
		
		local a = GetNewGaster();
		a:rotationz(0);
		a:zoom(1.5);
		a:x(SCREEN_WIDTH+100);
		a:y(100);
		a:decelerate(0.5);
		a:x(SCREEN_CENTER_X+192);
		a:rotationz(-720);
		a:sleep(0.5);
		a:rotationz(0);
		a:queuecommand('Fire');
		a:sleep(0.5)
		a:accelerate(0.5)
		a:addy(-SCREEN_HEIGHT/2)
		a:sleep(2); a:queuecommand('Done');
		
		for pn=1,2 do
			local a = _G['P'..pn]
			if a then
				a:z(1);
				a:sleep(0.4);
				a:linear(0.1);
				a:addx(-96)
				a:rotationz(10)
				a:linear(0.1);
				a:addx(-96)
				a:rotationz(0)
			end
		end
		
	end},
	
	{296,function()
		
		local a = GetNewGaster();
		a:rotationz(0);
		a:zoom(1.5);
		a:x(-100);
		a:y(100);
		a:decelerate(0.5);
		a:x(SCREEN_CENTER_X-192);
		a:rotationz(720);
		a:sleep(0.5);
		a:rotationz(0);
		a:queuecommand('Fire');
		a:sleep(0.5)
		a:accelerate(0.5)
		a:addy(-SCREEN_HEIGHT/2)
		a:sleep(2); a:queuecommand('Done');
		
		local a = GetNewGaster();
		a:rotationz(0);
		a:zoom(1.5);
		a:x(SCREEN_WIDTH+100);
		a:y(100);
		a:decelerate(0.5);
		a:x(SCREEN_CENTER_X);
		a:rotationz(-720);
		a:sleep(0.5);
		a:rotationz(0);
		a:queuecommand('Fire');
		a:sleep(0.5)
		a:accelerate(0.5)
		a:addy(-SCREEN_HEIGHT/2)
		a:sleep(2); a:queuecommand('Done');
		
		for pn=1,2 do
			local a = _G['P'..pn]
			if a then
				a:z(1);
				a:sleep(0.35);
				a:accelerate(0.15);
				a:addx(192)
				a:rotationz(10)
				a:decelerate(0.15);
				a:addx(192)
				a:rotationz(0)
			end
		end
		
	end},
	
	{304,function()
		
		local a = GetNewGaster();
		a:rotationz(0);
		a:zoom(1.5);
		a:x(-100);
		a:y(100);
		a:decelerate(0.5);
		a:x(SCREEN_CENTER_X-192);
		a:rotationz(720);
		a:sleep(0.5);
		a:rotationz(0);
		a:queuecommand('Fire');
		a:sleep(0.5)
		a:accelerate(0.5)
		a:addy(-SCREEN_HEIGHT/2)
		a:sleep(2); a:queuecommand('Done');
		
		local a = GetNewGaster();
		a:rotationz(0);
		a:zoom(1.5);
		a:x(SCREEN_WIDTH+100);
		a:y(100);
		a:decelerate(0.5);
		a:x(SCREEN_CENTER_X+192);
		a:rotationz(-720);
		a:sleep(0.5);
		a:rotationz(0);
		a:queuecommand('Fire');
		a:sleep(0.5)
		a:accelerate(0.5)
		a:addy(-SCREEN_HEIGHT/2)
		a:sleep(2); a:queuecommand('Done');
		
		for pn=1,2 do
			local a = _G['P'..pn]
			if a then
				a:z(1);
				a:sleep(0.4);
				a:linear(0.1);
				a:addx(-96)
				a:rotationz(10)
				a:linear(0.1);
				a:addx(-96)
				a:rotationz(0)
			end
		end
		
	end},
	
	{312,function()
		
		local a = GetNewGaster();
		a:rotationz(0);
		a:zoom(1.5);
		a:x(-100);
		a:y(100);
		a:decelerate(0.5);
		a:x(SCREEN_CENTER_X);
		a:rotationz(720);
		a:sleep(0.5);
		a:rotationz(0);
		a:queuecommand('Fire');
		a:sleep(0.5)
		a:accelerate(0.5)
		a:addy(-SCREEN_HEIGHT/2)
		a:sleep(2); a:queuecommand('Done');
		
	end},
	
	{320,function()
		
		local a = GetNewGaster();
		a:rotationz(0);
		a:zoom(1.5);
		a:x(-100);
		a:y(SCREEN_HEIGHT*0.75);
		a:decelerate(0.5);
		a:x(100);
		a:rotationz(720-90);
		a:sleep(0.5);
		a:queuecommand('Fire');
		a:sleep(0.5)
		a:accelerate(0.5)
		a:addx(-200)
		a:sleep(2); a:queuecommand('Done');
		
	end},
	
	{328,function()
		
		local a = GetNewGaster();
		a:rotationz(0);
		a:zoom(1.5);
		a:x(SCREEN_WIDTH+100);
		a:y(SCREEN_HEIGHT*0.25);
		a:decelerate(0.5);
		a:x(SCREEN_WIDTH-100);
		a:rotationz(-720+90);
		a:sleep(0.5);
		a:queuecommand('Fire');
		a:sleep(0.5)
		a:accelerate(0.5)
		a:addx(200)
		a:sleep(2); a:queuecommand('Done');
		
	end},
	
	{336,function()
		
		local a = GetNewGaster();
		a:rotationz(0);
		a:zoom(1.5);
		a:x(-100);
		a:y(SCREEN_HEIGHT*0.25);
		a:decelerate(0.5);
		a:x(100);
		a:rotationz(-720-90);
		a:sleep(0.5);
		a:queuecommand('Fire');
		a:sleep(0.5)
		a:accelerate(0.5)
		a:addx(-200)
		a:sleep(2); a:queuecommand('Done');
		
		local a = GetNewGaster();
		a:rotationz(0);
		a:zoom(1.5);
		a:x(SCREEN_WIDTH*0.25);
		a:y(-100);
		a:decelerate(0.5);
		a:y(100);
		a:rotationz(720);
		a:sleep(0.5);
		a:rotationz(0);
		a:queuecommand('Fire');
		a:sleep(0.5)
		a:accelerate(0.5)
		a:addy(-200)
		a:sleep(2); a:queuecommand('Done');
		
		for pn=1,2 do
			local a = _G['P'..pn]
			if a then
				a:z(1);
				a:sleep(0.4);
				a:linear(0.1);
				a:addx(64)
				a:rotationz(20)
				a:linear(0.1);
				a:addx(64)
				a:rotationz(15)
			end
		end
		
	end},
	
	{344,function()
		
		local a = GetNewGaster();
		a:rotationz(0);
		a:zoom(1.5);
		a:x(SCREEN_WIDTH+100);
		a:y(SCREEN_HEIGHT*0.75);
		a:decelerate(0.5);
		a:x(SCREEN_WIDTH-100);
		a:rotationz(720+90);
		a:sleep(0.5);
		a:queuecommand('Fire');
		a:sleep(0.5)
		a:accelerate(0.5)
		a:addx(200)
		a:sleep(2); a:queuecommand('Done');
		
		local a = GetNewGaster();
		a:rotationz(0);
		a:zoom(1.5);
		a:x(SCREEN_WIDTH*0.75);
		a:y(SCREEN_HEIGHT+100);
		a:decelerate(0.5);
		a:y(SCREEN_HEIGHT-100);
		a:rotationz(-720+180);
		a:sleep(0.5);
		a:rotationz(180);
		a:queuecommand('Fire');
		a:sleep(0.5)
		a:accelerate(0.5)
		a:addy(200)
		a:sleep(2); a:queuecommand('Done');
		
		for pn=1,2 do
			local a = _G['P'..pn]
			if a then
				a:z(1);
				a:sleep(0.35);
				a:accelerate(0.15);
				a:addx(-128)
				a:rotationz(180-8)
				a:decelerate(0.15);
				a:addx(-128)
				a:rotationz(360-15)
				a:sleep(0)
				a:rotationz(-15)
			end
		end
		
	end},
	
	{352,function()
		
		local a = GetNewGaster();
		a:rotationz(0);
		a:zoom(1.5);
		a:x(-100);
		a:y(SCREEN_HEIGHT*0.75);
		a:decelerate(0.5);
		a:x(100);
		a:rotationz(720-90);
		a:sleep(0.5);
		a:queuecommand('Fire');
		a:sleep(0.5)
		a:accelerate(0.5)
		a:addx(-200)
		a:sleep(2); a:queuecommand('Done');
		
		local a = GetNewGaster();
		a:rotationz(0);
		a:zoom(1.5);
		a:x(SCREEN_WIDTH*0.25);
		a:y(SCREEN_HEIGHT+100);
		a:decelerate(0.5);
		a:y(SCREEN_HEIGHT-100);
		a:rotationz(-720-180);
		a:sleep(0.5);
		a:rotationz(-180);
		a:queuecommand('Fire');
		a:sleep(0.5)
		a:accelerate(0.5)
		a:addy(200)
		a:sleep(2); a:queuecommand('Done');
		
		for pn=1,2 do
			local a = _G['P'..pn]
			if a then
				a:z(1);
				a:sleep(0.35);
				a:accelerate(0.15);
				a:addx(128)
				a:rotationz(-180-8)
				a:decelerate(0.15);
				a:addx(128)
				a:rotationz(-360-15)
				a:sleep(0)
				a:rotationz(-15)
			end
		end
		
	end},
	
	{360,function()
		
		local a = GetNewGaster();
		a:rotationz(0);
		a:zoom(1.5);
		a:x(SCREEN_WIDTH+100);
		a:y(SCREEN_HEIGHT*0.25);
		a:decelerate(0.5);
		a:x(SCREEN_WIDTH-100);
		a:rotationz(-720+90);
		a:sleep(0.5);
		a:queuecommand('Fire');
		a:sleep(0.5)
		a:accelerate(0.5)
		a:addx(200)
		a:sleep(2); a:queuecommand('Done');
		
		local a = GetNewGaster();
		a:rotationz(0);
		a:zoom(1.5);
		a:x(SCREEN_WIDTH*0.75);
		a:y(-100);
		a:decelerate(0.5);
		a:y(100);
		a:rotationz(-720);
		a:sleep(0.5);
		a:rotationz(0);
		a:queuecommand('Fire');
		a:sleep(0.5)
		a:accelerate(0.5)
		a:addy(-200)
		a:sleep(2); a:queuecommand('Done');
		
		for pn=1,2 do
			local a = _G['P'..pn]
			if a then
				a:z(1);
				a:sleep(0.35);
				a:accelerate(0.15);
				a:addx(-128)
				a:rotationz(180+8)
				a:decelerate(0.15);
				a:addx(-128)
				a:rotationz(360+15)
				a:sleep(0)
				a:rotationz(15)
			end
		end
		
	end},
	
	{368,function()
		
		local a = GetNewGaster();
		a:rotationz(0);
		a:zoom(1.5);
		a:x(-100);
		a:y(100);
		a:decelerate(0.5);
		a:x(SCREEN_CENTER_X-128);
		a:rotationz(720);
		a:sleep(0.5);
		a:rotationz(0);
		a:queuecommand('Fire');
		a:sleep(0.5)
		a:accelerate(0.5)
		a:addy(-SCREEN_HEIGHT/2)
		a:sleep(2); a:queuecommand('Done');
		
		local a = GetNewGaster();
		a:rotationz(0);
		a:zoom(1.5);
		a:x(SCREEN_WIDTH+100);
		a:y(100);
		a:decelerate(0.5);
		a:x(SCREEN_CENTER_X+128);
		a:rotationz(-720);
		a:sleep(0.5);
		a:rotationz(0);
		a:queuecommand('Fire');
		a:sleep(0.5)
		a:accelerate(0.5)
		a:addy(-SCREEN_HEIGHT/2)
		a:sleep(2); a:queuecommand('Done');
		
		local a = GetNewGaster();
		a:rotationz(0);
		a:zoom(1.5);
		a:x(-100);
		a:y(SCREEN_BOTTOM-100);
		a:decelerate(0.5);
		a:x(SCREEN_CENTER_X-256);
		a:rotationz(720-180);
		a:sleep(0.5);
		a:rotationz(180);
		a:queuecommand('Fire');
		a:sleep(0.5)
		a:accelerate(0.5)
		a:addy(SCREEN_HEIGHT/2)
		a:sleep(2); a:queuecommand('Done');
		
		local a = GetNewGaster();
		a:rotationz(0);
		a:zoom(1.5);
		a:x(SCREEN_WIDTH+100);
		a:y(SCREEN_BOTTOM-100);
		a:decelerate(0.5);
		a:x(SCREEN_CENTER_X+256);
		a:rotationz(-720+180);
		a:sleep(0.5);
		a:rotationz(180);
		a:queuecommand('Fire');
		a:sleep(0.5)
		a:accelerate(0.5)
		a:addy(SCREEN_HEIGHT/2)
		a:sleep(2); a:queuecommand('Done');
		
		for pn=1,2 do
			local a = _G['P'..pn]
			if a then
				a:z(1);
				a:sleep(0.4);
				a:linear(0.1);
				a:addx(64)
				a:rotationz(8)
				a:linear(0.1);
				a:addx(64)
				a:rotationz(0)
			end
		end
		
	end},
	
	{376,function()
	
		local ang = math.deg(math.atan(SCREEN_WIDTH/SCREEN_HEIGHT))
		
		local a = GetNewGaster();
		a:rotationz(0);
		a:zoom(1.5);
		a:x(-100);
		a:y(75);
		a:decelerate(0.5);
		a:x(100);
		a:rotationz(720-ang);
		a:sleep(0.5);
		a:rotationz(-ang);
		a:queuecommand('Fire');
		a:sleep(0.5)
		a:accelerate(0.5)
		a:addx(-150*(SCREEN_WIDTH/SCREEN_HEIGHT))
		a:addy(-150)
		a:sleep(2); a:queuecommand('Done');
		
		local a = GetNewGaster();
		a:rotationz(0);
		a:zoom(1.5);
		a:x(SCREEN_WIDTH+100);
		a:y(75);
		a:decelerate(0.5);
		a:x(SCREEN_WIDTH-100);
		a:rotationz(-720+ang);
		a:sleep(0.5);
		a:rotationz(ang);
		a:queuecommand('Fire');
		a:sleep(0.5)
		a:accelerate(0.5)
		a:addx(150*(SCREEN_WIDTH/SCREEN_HEIGHT))
		a:addy(-150)
		a:sleep(2); a:queuecommand('Done');
		
		for pn=1,2 do
			local a = _G['P'..pn]
			local d = 1
			if pn == 2 then d = -1 end
			if a then
				a:z(1);
				a:sleep(0.4);
				a:linear(0.1);
				a:x(SCREEN_CENTER_X-(SCREEN_WIDTH*0.35*d)*0.5)
				a:rotationz(10*d)
				a:linear(0.1);
				a:x(SCREEN_CENTER_X-(SCREEN_WIDTH*0.35*d))
				a:rotationz(0)
			end
		end
		
	end},
	
	{384,function()
	
		local a = GetNewGaster();
		a:rotationz(0);
		a:zoom(1.5);
		a:x(-100);
		a:y(SCREEN_CENTER_Y-128);
		a:decelerate(0.5);
		a:x(SCREEN_CENTER_X-128-64);
		a:rotationz(720-90);
		a:sleep(0.5);
		a:queuecommand('Fire');
		a:sleep(0.5)
		a:accelerate(0.5)
		a:addx(-SCREEN_CENTER_X)
		a:sleep(2); a:queuecommand('Done');
		
		local a = GetNewGaster();
		a:rotationz(0);
		a:zoom(1.5);
		a:x(SCREEN_CENTER_X-128);
		a:y(-100);
		a:decelerate(0.5);
		a:y(SCREEN_CENTER_Y-128-64);
		a:rotationz(-720);
		a:sleep(0.5);
		a:rotationz(0);
		a:queuecommand('Fire');
		a:sleep(0.5)
		a:accelerate(0.5)
		a:addy(-SCREEN_CENTER_Y)
		a:sleep(2); a:queuecommand('Done');
		
		local a = GetNewGaster();
		a:rotationz(0);
		a:zoom(1.5);
		a:x(SCREEN_WIDTH+100);
		a:y(SCREEN_CENTER_Y+128);
		a:decelerate(0.5);
		a:x(SCREEN_CENTER_X+128+64);
		a:rotationz(-720+90);
		a:sleep(0.5);
		a:queuecommand('Fire');
		a:sleep(0.5)
		a:accelerate(0.5)
		a:addx(SCREEN_CENTER_X)
		a:sleep(2); a:queuecommand('Done');
		
		local a = GetNewGaster();
		a:rotationz(0);
		a:zoom(1.5);
		a:x(SCREEN_CENTER_X+128);
		a:y(SCREEN_HEIGHT+100);
		a:decelerate(0.5);
		a:y(SCREEN_CENTER_Y+128+64);
		a:rotationz(720-180);
		a:sleep(0.5);
		a:rotationz(180);
		a:queuecommand('Fire');
		a:sleep(0.5)
		a:accelerate(0.5)
		a:addy(SCREEN_CENTER_Y)
		a:sleep(2); a:queuecommand('Done');
		
		for pn=1,2 do
			local a = _G['P'..pn]
			local d = 1
			if pn == 2 then d = -1 end
			if a then
				a:z(1);
				a:sleep(0.4);
				a:linear(0.1);
				a:x(SCREEN_CENTER_X-(SCREEN_WIDTH*0.33*d)*0.5)
				a:rotationz(10*d)
				a:linear(0.1);
				a:x(SCREEN_CENTER_X)
				a:rotationz(0)
			end
		end
		
	end},
	
	{392,function()
		
		local a = GetNewGaster();
		a:rotationz(0);
		a:zoom(1);
		a:x(-100);
		a:y(100);
		a:decelerate(0.5);
		a:x(SCREEN_CENTER_X-192);
		a:rotationz(720);
		a:sleep(0.5);
		a:rotationz(0);
		a:queuecommand('Fire');
		a:sleep(0.5)
		a:accelerate(0.5)
		a:addy(-200)
		a:sleep(2); a:queuecommand('Done');
		
		local a = GetNewGaster();
		a:rotationz(0);
		a:zoom(1);
		a:x(SCREEN_WIDTH+100);
		a:y(100);
		a:decelerate(0.5);
		a:x(SCREEN_CENTER_X+192);
		a:rotationz(-720);
		a:sleep(0.5);
		a:rotationz(0);
		a:queuecommand('Fire');
		a:sleep(0.5)
		a:accelerate(0.5)
		a:addy(-200)
		a:sleep(2); a:queuecommand('Done');
		
		local a = GetNewGaster();
		a:rotationz(0);
		a:zoom(1);
		a:x(SCREEN_CENTER_X);
		a:y(-100);
		a:decelerate(0.5);
		a:y(100);
		a:rotationz(-720);
		a:sleep(0.5);
		a:rotationz(0);
		a:queuecommand('Fire');
		a:sleep(0.5)
		a:accelerate(0.5)
		a:addy(-200)
		a:sleep(2); a:queuecommand('Done');
		
	end},
	
	{400,function()
		
		local a = GetNewGaster();
		a:rotationz(0);
		a:zoom(1.25);
		a:x(-100);
		a:y(SCREEN_BOTTOM-100);
		a:decelerate(0.5);
		a:x(SCREEN_CENTER_X-112);
		a:rotationz(720-180);
		a:sleep(0.5);
		a:rotationz(180);
		a:queuecommand('Fire');
		a:sleep(0.5)
		a:accelerate(0.5)
		a:addy(200)
		a:sleep(2); a:queuecommand('Done');
		
		local a = GetNewGaster();
		a:rotationz(0);
		a:zoom(1.25);
		a:x(SCREEN_WIDTH+100);
		a:y(SCREEN_BOTTOM-100);
		a:decelerate(0.5);
		a:x(SCREEN_CENTER_X+112);
		a:rotationz(-720+180);
		a:sleep(0.5);
		a:rotationz(180);
		a:queuecommand('Fire');
		a:sleep(0.5)
		a:accelerate(0.5)
		a:addy(200)
		a:sleep(2); a:queuecommand('Done');
		
	end},
	
	{408,function()
		
		local a = GetNewGaster();
		a:rotationz(0);
		a:zoom(1);
		a:x(-100);
		a:y(100);
		a:decelerate(0.5);
		a:x(SCREEN_CENTER_X-192);
		a:rotationz(720);
		a:sleep(0.5);
		a:rotationz(0);
		a:queuecommand('Fire');
		a:sleep(0.5)
		a:accelerate(0.5)
		a:addy(-200)
		a:sleep(2); a:queuecommand('Done');
		
		local a = GetNewGaster();
		a:rotationz(0);
		a:zoom(1);
		a:x(SCREEN_WIDTH+100);
		a:y(100);
		a:decelerate(0.5);
		a:x(SCREEN_CENTER_X+192);
		a:rotationz(-720);
		a:sleep(0.5);
		a:rotationz(0);
		a:queuecommand('Fire');
		a:sleep(0.5)
		a:accelerate(0.5)
		a:addy(-200)
		a:sleep(2); a:queuecommand('Done');
		
		local a = GetNewGaster();
		a:rotationz(0);
		a:zoom(1);
		a:x(SCREEN_CENTER_X);
		a:y(-100);
		a:decelerate(0.5);
		a:y(100);
		a:rotationz(-720);
		a:sleep(0.5);
		a:rotationz(0);
		a:queuecommand('Fire');
		a:sleep(0.5)
		a:accelerate(0.5)
		a:addy(-200)
		a:sleep(2); a:queuecommand('Done');
		
	end},
	
	{412-.1,function()
		
		for pn=1,2 do
			local a = _G['P'..pn]
			if a then
				a:sleep(0);
				a:rotationy(80);
				a:linear(0.35);
				a:rotationy(0);
				a:sleep(0.025);
				a:rotationy(-80);
				a:linear(0.35);
				a:rotationy(0);
				a:sleep(0.025);
				a:rotationy(80);
				a:linear(0.35);
				a:rotationy(0);
				a:sleep(0.025);
			end
		end
		
	end},
	
	{479,function()
		if P1 then
			P1:decelerate(0.25);
			P1:z(3);
			P1:x(SCREEN_WIDTH*0.25-64)
		end
		if P2 then
			P2:decelerate(0.25);
			P2:z(3);
			P2:x(SCREEN_WIDTH*0.75+64)
		end
	end},
	
	{480,function()
		sans_mspd:linear(15);
		sans_mspd:x(100);
		sans_mspd:decelerate(1);
		sans_mspd:x(0);
	end},
	
	{544,function()
		
		for pn=1,2 do
			local a = _G['P'..pn]
			local d = 1;
			if pn==2 then d = -1 end
			if a then
				a:linear(0.125);
				a:x(SCREEN_CENTER_X-(SCREEN_WIDTH*0.25*d));
				a:zoom(1);
				a:z(1);
			end
		end
		
	end},
	
}

mod_boneBam(60)
mod_boneBam(92)
mod_boneBam(124,1)
mod_boneBam(156,1)
mod_boneBam(188)
mod_boneBam(220)
mod_boneBam(252)
mod_boneBam(284)
mod_boneBam(412,1)
	
--SCREAMING GUMBALL
curmessage = 1;
--{beat,message,{params},persist?}
messages = {
}

	sans_paused = false
	sans_lastunpausedtime = GetTimeSinceStart()
	sans_curstop = 1
	
	sans_pzoomer = false;
	sans_ptraverse = false;
	sans_pzoomz = -5;
	
	sans_pauses = {
		420.354-(math.random(0,100)/100),
		430.167-(math.random(0,100)/100),
		440.000-(math.random(0,100)/100),
		447.875-(math.random(0,100)/100),
		458.125-(math.random(0,100)/100),
		465.167-(math.random(0,100)/100),
		472.771-(math.random(0,200)/100),
		477.646-(math.random(0,100)/100),
		999,
	}
	
	sans_pause_lengths = {}
	
	for i=1,table.getn(sans_pauses)+1 do
		--table.insert(sans_pause_lengths,0.2+(math.random(100)/100));
		table.insert(sans_pause_lengths,0.25);
	end
	
	table.insert(mods,{sans_pauses[1],'*10000 drunk, *10000 bumpy, *10000 tipsy, *10000 distant, *10 no flip'});
	table.insert(mods,{sans_pauses[2],'*10000 no drunk, *10000 no tipsy'});
	
	table.insert(mods,{sans_pauses[2],'*10000 150 distant, *10000 500 sudden, *10000 50 mini'});
	table.insert(mods,{sans_pauses[3],'*10000 100 suddenoffset, *10000 sudden, *10000 no hallway, *10000 no distant'});
	
	table.insert(mods,{sans_pauses[3],'*10000 -300 reverse, *10000 88.8 centered, *10000 0.23x, *10000 1000 bumpy, *10000 30 mini, *10000 -10 flip'});
	table.insert(mods,{sans_pauses[4],'*10000 no reverse, *10000 no centered, *10000 1.75x, *10000 no centered, *10000 no bumpy, *10000 no mini, *10000 no mini'});
	
	table.insert(mods,{sans_pauses[4]+4,'*2.5 25 flip, *3 30 reverse'});
	table.insert(mods,{sans_pauses[5],'*10000 no flip, *10000 no reverse'});
	
	table.insert(mods,{sans_pauses[5],'*10000 50 stealth, *10000 -150 mini, *10000 bumpy, *10000 70 brake, *10000 20 tornado'});
	table.insert(mods,{sans_pauses[6],'*10000 no stealth, *10000 no mini, *10000 no bumpy, *10000 no brake, *10000 no tornado'});
	
	table.insert(mods,{sans_pauses[6],'*10000 space, *10000 30 mini'});
	table.insert(mods,{sans_pauses[7],'*10000 no space, *10000 no mini'});
	
	sans_pause_actions = {
	function()
		for pn=1,2 do
			local a = _G['P'..pn]
			if a then
				a:rotationz(30);
				a:zoom(1);
			end
		end
	end,
	function()
		MESSAGEMAN:Broadcast('Bones2B');
		for pn=1,2 do
			local a = _G['P'..pn]
			if a then
				a:rotationz(-10);
				a:zoom(2);
				a:addy(50);
			end
		end
	end,
	function()
		MESSAGEMAN:Broadcast('Bones2Away');
		for pn=1,2 do
			local a = _G['P'..pn]
			if a then
				a:rotationz(0);
				a:zoom(1);
				a:addy(-50);
			end
		end
	end,
	function()
		
		char_sans_gaster_snd:sleep((sans_pause_lengths[4]/2)+0.75);
		char_sans_gaster_snd:queuecommand('Fire');
	
		for pn=1,2 do
			local a = _G['P'..pn]
			if a then
				a:zoom(0.8);
			end
		end
	
		local a = GetNewGaster();
		a:rotationz(0);
		a:zoom(1.5);
		a:x(-100);
		a:y(SCREEN_CENTER_Y-128);
		a:sleep((sans_pause_lengths[4]/2));
		a:decelerate(0.5);
		a:x(SCREEN_CENTER_X-128-64);
		a:rotationz(720-90);
		a:sleep(0.5);
		a:queuecommand('Fire');
		a:sleep(0.5)
		a:accelerate(0.5)
		a:addx(-SCREEN_CENTER_X)
		a:sleep(2); a:queuecommand('Done');
		
		local a = GetNewGaster();
		a:rotationz(0);
		a:zoom(1.5);
		a:x(SCREEN_CENTER_X-128);
		a:y(-100);
		a:sleep((sans_pause_lengths[4]/2));
		a:decelerate(0.5);
		a:y(SCREEN_CENTER_Y-128-64);
		a:rotationz(-720);
		a:sleep(0.5);
		a:rotationz(0);
		a:queuecommand('Fire');
		a:sleep(0.5)
		a:accelerate(0.5)
		a:addy(-SCREEN_CENTER_Y)
		a:sleep(2); a:queuecommand('Done');
		
		local a = GetNewGaster();
		a:rotationz(0);
		a:zoom(1.5);
		a:x(SCREEN_WIDTH+100);
		a:y(SCREEN_CENTER_Y+128);
		a:sleep((sans_pause_lengths[4]/2));
		a:decelerate(0.5);
		a:x(SCREEN_CENTER_X+128+64);
		a:rotationz(-720+90);
		a:sleep(0.5);
		a:queuecommand('Fire');
		a:sleep(0.5)
		a:accelerate(0.5)
		a:addx(SCREEN_CENTER_X)
		a:sleep(2); a:queuecommand('Done');
		
		local a = GetNewGaster();
		a:rotationz(0);
		a:zoom(1.5);
		a:x(SCREEN_CENTER_X+128);
		a:y(SCREEN_HEIGHT+100);
		a:sleep((sans_pause_lengths[4]/2));
		a:decelerate(0.5);
		a:y(SCREEN_CENTER_Y+128+64);
		a:rotationz(720-180);
		a:sleep(0.5);
		a:rotationz(180);
		a:queuecommand('Fire');
		a:sleep(0.5)
		a:accelerate(0.5)
		a:addy(SCREEN_CENTER_Y)
		a:sleep(2); a:queuecommand('Done');
		
	end,
	function()
		MESSAGEMAN:Broadcast('Bones2A');
		for pn=1,2 do
			local a = _G['P'..pn]
			if a then
				a:rotationz(10);
				a:zoom(1);
			end
		end
	end,
	function()
		MESSAGEMAN:Broadcast('Bones2Away');
		sans_ptraverse = true;
		for pn=1,2 do
			local a = _G['P'..pn]
			if a then
				a:x(SCREEN_WIDTH*0.1)
				a:y(SCREEN_HEIGHT*0.4)
				a:rotationy(10)
				a:rotationz(-10)
				a:wag()
				a:effectclock('bgm');
				a:effectperiod(4);
				a:effectmagnitude(0,0,20);
				a:sleep(sans_pause_lengths[6]/2)
			end
		end
	end,
	function()
		sans_ptraverse = false;
		sans_pzoomer = true;
		for pn=1,2 do
			local a = _G['P'..pn]
			if a then
				a:rotationy(0);
				a:rotationz(0);
				a:zoom(1.4);
				a:zoomz(-5);
				a:stopeffect();
				a:x(SCREEN_CENTER_X);
				a:y(SCREEN_CENTER_Y);
			end
		end
	end,
	function()
		sans_pzoomer = false;
		for pn=1,2 do
			local a = _G['P'..pn]
			if a then
				a:zoom(0.8);
				a:zoomz(1);
				a:x(SCREEN_CENTER_X);
				a:y(SCREEN_CENTER_Y);
			end
		end
	end
	}
	
	for i=1,table.getn(sans_pauses) do
		table.insert(messages,{sans_pauses[i]-.35,'PauseSound'});
		table.insert(messages,{sans_pauses[i]-.05,'Dark',{sans_pause_lengths[i]}});
		table.insert(actions,{sans_pauses[i]-.05,sans_pause_actions[i]});
		table.insert(sans_actions,{sans_pauses[i]-.05,sans_char_pause_actions[i]});
	end

	function modtable_compare(a,b)
		return a[1] < b[1]
	end
	
	if table.getn(mods) > 1 then
		table.sort(mods, modtable_compare)
	end
	
	if table.getn(messages) > 1 then
		table.sort(messages, modtable_compare)
	end
	
	if table.getn(actions) > 1 then
		table.sort(actions, modtable_compare)
	end
	
	if table.getn(sans_actions) > 1 then
		table.sort(sans_actions, modtable_compare)
	end
	
end

updates = 0

local function sans_update(self, delta)

	if GAMESTATE:GetSongBeat()>=0.1 and not checked then
		
		P1 = SCREENMAN:GetTopScreen():GetChild('PlayerP1')
		P2 = SCREENMAN:GetTopScreen():GetChild('PlayerP2')
		
		for pn=1,2 do
			if not _G['P'..pn] then
				sans_playerfailed[pn] = 1
			end
		end
		
		--[[
		if SCREENMAN:GetTopScreen():GetChild('ScoreP1') then
			SCREENMAN:GetTopScreen():GetChild('ScoreP1'):visible(false)
		end
		if SCREENMAN:GetTopScreen():GetChild('ScoreP2') then
			SCREENMAN:GetTopScreen():GetChild('ScoreP2'):visible(false)
		end
		]]
		
		if SCREENMAN:GetTopScreen():GetChild('Debug') then
			SCREENMAN:GetTopScreen():GetChild('Debug'):y(SCREEN_CENTER_Y-60)
		end

		screen = SCREENMAN:GetTopScreen();
		screen:SetDrawByZPosition(true);
		
		screen:AddInputCallback( InputHandler )
		
		if SCREENMAN:GetTopScreen():GetChild('SongForeground') then
			SCREENMAN:GetTopScreen():GetChild('SongForeground'):z(2)
		end
		
		if P1 then P1:z(1) end
		if P2 then P2:z(1) end
		
		checked = true;
		
	end
	
	local beat = GAMESTATE:GetSongBeat()
	
	-- Collect all the mods that will be applied in this frame into one string.
	-- Mod tweening doesn't work correctly if the mods are in seperate commands.
	local mods_this_frame= {}
	local function add_mod(mod_str)
		mods_this_frame[#mods_this_frame+1]= mod_str
	end
	local function execute_mods()
		if #mods_this_frame <= 0 then return end
		local total_mod_str= ""
		for i, ms in ipairs(mods_this_frame) do
			if #total_mod_str > 0 then
				total_mod_str= total_mod_str .. ", "
			end
			total_mod_str= total_mod_str .. ms
		end
		sans_mod(total_mod_str)
	end
	
	if beat>7 and fgcurcommand==0 then
		if P1 then P1:linear(0.1) P1:x(SCREEN_WIDTH*0.25) end
		if P2 then P2:linear(0.1) P2:x(SCREEN_WIDTH*0.75) end
		fgcurcommand = fgcurcommand+1;
	end
	
	while curmod<= #mods and GAMESTATE:GetSongBeat()>=mods[curmod][1] do
		if table.getn(mods[curmod]) < 3 then
			add_mod(mods[curmod][2])
		else
			sans_mod_internal(mods[curmod][2], 'PlayerNumber_P' .. mods[curmod][3])
		end
		curmod = curmod+1
	end

	execute_mods()
	
	--based code based on #based #code by W I N D O O
	if not sans_paused then
		sans_lastunpausedtime = GetTimeSinceStart();
	elseif GetTimeSinceStart() - sans_lastunpausedtime > sans_pause_lengths[sans_curstop] then
		sans_paused = false;
		SCREENMAN:GetTopScreen():PauseGame(false);
		sans_curstop = sans_curstop + 1;
	end
	
	if GAMESTATE:GetCurMusicSeconds() > (sans_pauses[sans_curstop]+32)/4 and not sans_paused then
		sans_paused = true;
		SCREENMAN:GetTopScreen():PauseGame(true);
	end
	
	if beat > 32 and beat < 96 then
		for pn=1,2 do
			local a = _G['P'..pn]
			if a then
				a:x(SCREEN_CENTER_X+((SCREEN_WIDTH*0.25)*math.sin(beat*math.pi*0.25)))
				if beat>92 then
					a:zoom(0.9+((4-(96-beat))/40))
				end
			end
		end
	end
	
	if sans_ptraverse then
		for pn=1,2 do
			local a = _G['P'..pn]
			if a then
				a:addx(SCREEN_WIDTH*delta*0.4);
			end
		end
	end
	
	if sans_pzoomer then
		for pn=1,2 do
			local a = _G['P'..pn]
			if a then
				a:zoomz(sans_pzoomz)
			end
		end
		sans_pzoomz = sans_pzoomz+(120*delta)
	end
	
	if beat > sans_bonetrousle and beat < 148 then
				
		local a = GetNewBone()
		
		if a then
			local rng = math.random(1,100)
			local dir = 1
			if rng < 50 then
				a:y(-50);
			else
				a:y(SCREEN_BOTTOM+50);
				dir = -1
			end
			a:zoom(1.5+math.random(10)/10)
			a:rotationz(90*dir)
			a:x(SCREEN_CENTER_X-128+math.random(0,256));
			a:linear(0.5+math.random(10)/10)
			a:addy((SCREEN_HEIGHT+100)*dir)
			a:queuecommand('Hide');
		end
	
		sans_bonetrousle = sans_bonetrousle+1.4
	end
	
	if beat > sans_bonetrousle2-6 and beat < 396+4 then
		
		local a = GetNewBone()
		
		if a then
			local rng = math.random(1,100)
			local dir = 1
			if rng < 50 then
				a:x(-50);
			else
				a:x(SCREEN_WIDTH+50);
				dir = -1
			end
			a:zoom(1.5+math.random(10)/10)
			a:rotationz(90+(90*dir))
			a:y(SCREEN_CENTER_Y-128+math.random(0,256));
			a:linear(1+math.random(10)/10)
			a:addx((SCREEN_WIDTH+100)*dir)
			a:queuecommand('Hide');
		end
	
		sans_bonetrousle2 = sans_bonetrousle2+1.8
	end
	
	if beat > 480 and beat < 544 then
		for pn=1,2 do
			local a = _G['P'..pn]
			if a then
				a:addx(sans_mspd:GetX()*delta*50);
				if a:GetX() > SCREEN_WIDTH+128 then
					a:x(-128);
				end
			end
		end
	end
	
	--SCREAMING GUMBALL
	while curmessage<= #messages and GAMESTATE:GetSongBeat()>=messages[curmessage][1] do
		if messages[curmessage][4] and GAMESTATE:GetSongBeat()>=messages[curmessage][1]+5 then
			curmessage = curmessage+1;
		else
			MESSAGEMAN:Broadcast(messages[curmessage][2],messages[curmessage][3])
			curmessage = curmessage+1;
		end
	end
	
	while curaction<= #actions and GAMESTATE:GetSongBeat()>=actions[curaction][1] do
		if actions[curaction][3] and GAMESTATE:GetSongBeat()>=actions[curaction][1]+5 then
			curaction = curaction+1;
		else
			actions[curaction][2]()
			curaction = curaction+1;
		end
	end
	
	while sans_curaction<= #sans_actions and GAMESTATE:GetSongBeat()>=sans_actions[sans_curaction][1] do
		if sans_actions[sans_curaction][3] or GAMESTATE:GetSongBeat() < sans_actions[sans_curaction][1]+2 then
			sans_actions[sans_curaction][2]()
		end
		sans_curaction = sans_curaction+1;
	end
	
end

sans_boneFrame = Def.ActorFrame{
}

for i=1,64 do
	sans_boneFrame[#sans_boneFrame+1] = LoadActor( "bone.png" )..{
		InitCommand=function (self)
			self:visible(false);
			self:SetTextureFiltering(false);
		end,
		HideCommand=cmd(visible,false),
		OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"SetMe"),
		SetMeCommand=function(self) table.insert(sans_bones,self) end,
	}
end

return Def.ActorFrame{
	OnCommand= function(self)
							 sans_init()
							 self:SetUpdateFunction(sans_update)
							 
						 end,
	Def.Quad{
		Name= "I may be sleeping, but I preserve the world.",
		InitCommand= cmd(visible,false),
		OnCommand= cmd(sleep,1000),
	},
	
	Def.Quad{
		InitCommand= cmd(visible,false),
		HealthStateChangedMessageCommand=function(self,params)
			if params.HealthState == 'HealthState_Dead' then
				if params.PlayerNumber == PLAYER_1 then
					--SCREENMAN:SystemMessage('Player 1 died');
					sans_playerfailed[1] = 1
				elseif params.PlayerNumber == PLAYER_2 then
					--SCREENMAN:SystemMessage('Player 2 died');
					sans_playerfailed[2] = 1
				else
					SCREENMAN:SystemMessage('Someone died somewhere');
				end
			end
		end
	},
	
	LoadActor( "BONE_ZONE" )..{
		InitCommand=function (self)
			self:visible(false)
			self:SetTextureFiltering(false);
		end,
		OnCommand=cmd(x,SCREEN_CENTER_X;y,SCREEN_BOTTOM;bob;effectmagnitude,0,128,0;customtexturerect,0,0,8,1;zoomx,18;zoomy,2.2;texcoordvelocity,2,0;
		effectperiod,4;effectclock,"bgm";),
		BoneZoneMessageCommand=cmd(visible,true;y,SCREEN_BOTTOM;diffusealpha,1;),
		BonesAwayMessageCommand=cmd(linear,0.5;addy,256;sleep,0;diffusealpha,0;),
	},
	
	LoadActor( "BONE_ZONE" )..{
		InitCommand=function (self)
			self:visible(false)
			self:SetTextureFiltering(false);
		end,
		OnCommand=cmd(x,SCREEN_CENTER_X;y,0;bob;effectmagnitude,0,128,0;customtexturerect,0,0,8,1;zoomx,18;zoomy,2.2;texcoordvelocity,2,0;
		effectperiod,4;effectclock,"bgm";),
		BoneZoneMessageCommand=cmd(visible,true;y,0;diffusealpha,1;),
		BonesAwayMessageCommand=cmd(linear,0.5;addy,-256;sleep,0;diffusealpha,0;),
	},
	
	LoadActor( "BONE_ZONE" )..{
		InitCommand=function (self)
			self:visible(false)
			self:SetTextureFiltering(false);
		end,
		OnCommand=cmd(x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;bob;effectmagnitude,0,10,0;customtexturerect,0,0,8,1;zoomx,16;zoomy,2;texcoordvelocity,2,0;
		effectperiod,4;effectclock,"bgm";),
		Bones2AMessageCommand=cmd(visible,true;rotationz,90;),
		Bones2BMessageCommand=cmd(visible,true;rotationz,90;),
		Bones2AwayMessageCommand=cmd(visible,false;),
	},
	
	LoadActor( "BONE_ZONE" )..{
		InitCommand=function (self)
			self:visible(false)
			self:SetTextureFiltering(false);
		end,
		OnCommand=cmd(x,SCREEN_CENTER_X;y,SCREEN_HEIGHT*0.3;customtexturerect,0,0,8,1;zoomx,18;zoomy,2.2;texcoordvelocity,2,0;),
		Bones3MessageCommand=cmd(visible,true;),
		Bones3AwayMessageCommand=cmd(visible,false),
	},
	
	Def.Quad{
		OnCommand=cmd(visible,false),
		InitCommand=function(self)
		
			sans_bptr = 1;
			sans_bones = {}
			
			function GetNewBone()
			
				local a = sans_bones[sans_bptr]
				
				sans_bptr = sans_bptr+1;
				if sans_bptr > table.getn(sans_bones) then
					sans_bptr = 1;
				end
				
				if a then
					a:visible(true);
					a:playcommand('Reset');
					return a
				else
					char_sans_missing:visible(true)
					return char_sans_missing
				end
				
			end
		
		end,
	},
	
	sans_boneFrame,
	
	Def.Quad{
		OnCommand=cmd(visible,false),
		InitCommand=function(self) sans_mspd = self end,
	},
	
	Def.Quad{
		OnCommand=cmd(visible,false),
		StartPressedMessageCommand=function(self)
			if GAMESTATE:GetSongBeat()>544 and GAMESTATE:GetSongBeat()<736 and not sans_defeated then
				sans_defeated = true;
				GasterSound('fatal');
				sans_deadtext:sleep(0.2);
				sans_deadtext:queuecommand('Dead');
				
				MESSAGEMAN:Broadcast('SpeechBubAAway');
				sans_endingtext:finishtweening();
				sans_endingtext:visible(false);
				
				if sans_playerfailed[1] == 0 or sans_playerfailed[2] == 0 then
					sans_failed = 0;
					sans_writeSaveFile()
				end
			end
		end,
	},
	
	LoadActor( "chara" )..{
		ZTopMessageCommand=cmd(z,10),
	},
	
	LoadActor( "speech" )..{
		InitCommand=function (self)
			self:SetTextureFiltering(false);
		end,
		OnCommand=cmd(animate,0;setstate,1;x,SCREEN_CENTER_X+160;y,SCREEN_CENTER_Y+20;diffusealpha,0;),
		SpeechBubAMessageCommand=cmd(x,SCREEN_CENTER_X+160;y,SCREEN_CENTER_Y+20;zoom,1;linear,0.2;diffusealpha,1),
		SpeechBubDMessageCommand=cmd(x,SCREEN_CENTER_X+160;y,SCREEN_CENTER_Y+20;zoom,1;diffusealpha,1),
		SpeechBubAAwayMessageCommand=cmd(diffusealpha,0;),
		SpeechBubCMessageCommand=cmd(x,120;y,SCREEN_CENTER_Y+30;linear,0.2;diffusealpha,1),
		SpeechBubEMessageCommand=cmd(x,130;zoom,1;y,SCREEN_CENTER_Y+30;linear,0.2;diffusealpha,1),
		SpeechBubCAwayMessageCommand=cmd(linear,0.2;diffusealpha,0;),
	},
	LoadActor( "text_intro" )..{
		InitCommand=function(self) self:SetTextureFiltering(false); sans_introtext = self end,
		OnCommand=cmd(animate,0;setstate,0;x,SCREEN_CENTER_X+160;y,SCREEN_CENTER_Y+20;visible,false),
		TextBadTimeMessageCommand=cmd(visible,false),
	},
	LoadActor( "text_badtime" )..{
		InitCommand=function (self)
			self:SetTextureFiltering(false);
		end,
		OnCommand=cmd(animate,0;setstate,0;x,SCREEN_CENTER_X+160;y,SCREEN_CENTER_Y+20;visible,false),
		TextBadTimeMessageCommand=cmd(visible,true;setstate,math.random(0,15);cropbottom,1;linear,0.5;cropbottom,0),
		TextBadTime2MessageCommand=cmd(visible,true;diffusealpha,1;setstate,math.random(0,15);cropbottom,1;linear,0.5;cropbottom,0),
		TextBadTimeAwayMessageCommand=cmd(diffusealpha,0),
	},
	LoadActor( "text_ending" )..{
		InitCommand=function(self) self:SetTextureFiltering(false); sans_endingtext = self end,
		OnCommand=cmd(animate,0;setstate,0;x,SCREEN_CENTER_X+160;y,SCREEN_CENTER_Y+20;visible,false),
	},
	LoadActor( "text_dead" )..{
		InitCommand=function(self) self:SetTextureFiltering(false); sans_deadtext = self end,
		OnCommand=cmd(animate,0;setstate,0;x,SCREEN_CENTER_X+160;y,SCREEN_CENTER_Y+20;visible,false),
		DeadCommand=function(self)
			
			MESSAGEMAN:Broadcast('SpeechBubD');
			char_sans:playcommand('Sweat');
			char_sans:playcommand('Hurt');
			char_sans:addy(50);
			char_sans:sleep(0);
			char_sans:sleep(0.3);char_sans:x(SCREEN_CENTER_X-20);char_sans:sleep(0.3);char_sans:x(SCREEN_CENTER_X+20);
			char_sans:sleep(0.3);char_sans:x(SCREEN_CENTER_X-20);char_sans:sleep(0.3);char_sans:x(SCREEN_CENTER_X+20);
			char_sans:sleep(0.3);char_sans:x(SCREEN_CENTER_X-10);char_sans:sleep(0.3);char_sans:x(SCREEN_CENTER_X+10);
			char_sans:sleep(0.3);char_sans:x(SCREEN_CENTER_X-10);char_sans:sleep(0.3);char_sans:x(SCREEN_CENTER_X+10);
			char_sans:sleep(0.3);char_sans:x(SCREEN_CENTER_X-5);char_sans:sleep(0.3);char_sans:x(SCREEN_CENTER_X+5);
			char_sans:sleep(0.3);char_sans:x(SCREEN_CENTER_X-5);char_sans:sleep(0.3);char_sans:x(SCREEN_CENTER_X+5);
			char_sans:sleep(0.3);char_sans:x(SCREEN_CENTER_X-3);char_sans:sleep(0.3);char_sans:x(SCREEN_CENTER_X+3);
			char_sans:sleep(0.3);char_sans:x(SCREEN_CENTER_X-3);char_sans:sleep(0.3);char_sans:x(SCREEN_CENTER_X+3);
			char_sans:sleep(0.3);char_sans:x(SCREEN_CENTER_X+0);
			
			self:visible(true);
			self:setstate(0);
			self:cropbottom(1);
			self:linear(0.6);
			self:cropbottom(0);
			self:sleep(4)
			self:queuecommand('t1');
		end,
		t1Command=function(self)
			self:setstate(1);
			self:cropbottom(1);
			self:linear(0.6);
			self:cropbottom(0);
			self:sleep(4)
			self:queuecommand('t2');
		end,
		t2Command=function(self)
			char_sans:playcommand('Sad');
			GasterSound('talk');
			self:setstate(2);
			self:cropbottom(1);
			self:linear(0.6);
			self:cropbottom(0);
			self:sleep(4)
			self:queuecommand('t3');
		end,
		t3Command=function(self)
			GasterSound('talk');
			self:setstate(3);
			self:cropbottom(1);
			self:linear(0.6);
			self:cropbottom(0);
			self:sleep(4)
			self:queuecommand('t4');
		end,
		t4Command=function(self)
			GasterSound('talk');
			self:setstate(4);
			self:cropbottom(1);
			self:linear(0.6);
			self:cropbottom(0);
			self:sleep(6)
			self:queuecommand('t5');
		end,
		t5Command=function(self)
			GasterSound('talk');
			self:setstate(5);
			self:cropbottom(1);
			self:linear(0.6);
			self:cropbottom(0);
			self:sleep(6)
			self:queuecommand('t6');
		end,
		t6Command=function(self)
			char_sans:playcommand('Stop');		
			char_sans:linear(6);		
			char_sans:y(SCREEN_BOTTOM+120);		
			self:visible(false);
			if sans_playerfailed[1] == 0 or sans_playerfailed[2] == 0 then
				sans_failed = 0;
				sans_writeSaveFile()
			end
			songEndable = true
			MESSAGEMAN:Broadcast('SongEndable');
			MESSAGEMAN:Broadcast('SpeechBubCAway');
			self:sleep(10)
			self:queuecommand('EndItAll');
		end,
		EndItAllCommand=function(self)
			SCREENMAN:GetTopScreen():StartTransitioningScreen("SM_DoNextScreen")
		end
	},
	LoadActor( "speech" )..{
		InitCommand=function (self)
			self:SetTextureFiltering(false);
		end,
		OnCommand=cmd(zoom,0.8;animate,0;setstate,0;x,SCREEN_WIDTH*0.15;y,SCREEN_CENTER_Y-80;diffusealpha,0;),
		SpeechBubBMessageCommand=cmd(linear,0.2;diffusealpha,1),
		SpeechBubBAwayMessageCommand=cmd(linear,0.2;diffusealpha,0;),
	},
	LoadActor( "text_misc" )..{
		InitCommand=function(self) self:SetTextureFiltering(false); sans_misctext1 = self end,
		OnCommand=cmd(zoom,0.8;animate,0;setstate,0;x,SCREEN_WIDTH*0.15;y,SCREEN_CENTER_Y-80;visible,false),
		TextTimeUpMessageCommand=cmd(x,SCREEN_CENTER_X+160;y,SCREEN_CENTER_Y+20;zoom,1;visible,true;diffusealpha,1;cropbottom,1;queuecommand,"t8"),
		t8Command=cmd(setstate,8+sans_pldead2;cropbottom,1;linear,0.2;cropbottom,0;sleep,14/4;queuecommand,"t9"),
		t9Command=cmd(setstate,9+sans_pldead2;cropbottom,1;linear,0.2;cropbottom,0;sleep,14/4;queuecommand,"t10"),
		t10Command=cmd(setstate,10+sans_pldead2;cropbottom,1;linear,0.2;cropbottom,0;sleep,14/4;queuecommand,"Final"),
		FinalCommand=cmd(setstate,11+sans_pldead2;cropbottom,1;linear,0.2;cropbottom,0;),
	},
	LoadActor( "endsong" )..{
		InitCommand=cmd(visible,false;diffusealpha,0;x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;),
		SongEndableMessageCommand=cmd(visible,true;diffusealpha,0;sleep,0.3;linear,1;diffusealpha,1;),
	},
	Def.Quad{
		OnCommand=cmd(visible,false),
		PauseSoundMessageCommand=function(self,params)
			GasterSound('pause')
			self:sleep(0.25);
			self:queuecommand('UnPause');
		end,
		UnPauseCommand=function(self)
			GasterSound('pause')
			self:diffusealpha(0);
		end,
	},
	Def.Quad{
		OnCommand=cmd(x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;zoomto,SCREEN_WIDTH,SCREEN_HEIGHT;diffuse,0,0,0,0),
		WhiteFlashMessageCommand=cmd(diffuse,1,1,1,1;linear,1;diffusealpha,0),
		DarkMessageCommand=function(self,params)
			self:diffuse(0,0,0,1);
			self:sleep(0.25);
			self:queuecommand('UnPause');
		end,
		UnPauseCommand=function(self)
			self:diffusealpha(0);
		end,
	},
}