local songName= GAMESTATE:GetCurrentSong():GetSongDir()

muffet_playerlist = {PLAYER_1,PLAYER_2};

local function muffet_mod_internal(str, pn)
	local ps= GAMESTATE:GetPlayerState(pn)
	local pmods= ps:GetPlayerOptionsString('ModsLevel_Song')
	ps:SetPlayerOptions('ModsLevel_Song', pmods .. ', ' .. str)
	--GAMESTATE:ApplyGameCommand('mod,'..str, pn)
end

local function muffet_mod(str)
	for i=1,2 do
		muffet_mod_internal(str, 'PlayerNumber_P' .. i)
	end
end

local function get_speed_from_poptions(player_number)
	if GAMESTATE:IsPlayerEnabled(player_number) then
		local poptionsray= GAMESTATE:GetPlayerState(player_number):GetPlayerOptionsArray("ModsLevel_Song")
		local speed= nil
		local mode= nil
		for i, el in ipairs(poptionsray) do
			local fel= el:sub(1, 1)
			local lel= el:sub(-1)
			if fel == "m" or fel == "C" then
				speed= tonumber(el:sub(2))
				mode= fel
			elseif lel == "x" then
				speed= tonumber(el:sub(1, -2))
				mode= lel
			end
			if speed and mode then
				break
			end
		end
	end
	if not speed or not mode then
		speed= 2
		mode= "x"
	end
	return { speed= speed, mode= mode }
end

local function set_player_speed(player_number, speed_info)
	if not GAMESTATE:IsPlayerEnabled(player_number) then return end
	local mode_functions= {
		x= function(speed)
				 muffet_mod_internal(("*1000 %.2f"):format(speed).."x", player_number)
			 end,
		C= function(speed)
				 muffet_mod_internal("*1000 C"..("%.0f"):format(speed), player_number)
			 end,
		m= function(speed)
				 local max_bpm= GAMESTATE:GetCurrentSteps(pn):GetDisplayBpms()[2]
				 local real_speed= (speed / max_bpm)
				 -- Setting an mmod while on ScreenGameplay doesn't actually work, due to the way mmods are implemented in the engine. So set the equivalent xmod
				 muffet_mod_internal(("*1000 %.2f"):format(real_speed).."x", player_number)
			 end
	}
	mode_functions[speed_info.mode](speed_info.speed)
end


-- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
-- INPUT handler provided by a very generous man mr guzek, verrry generous
-- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

local tpaused = false;

local InputHandler = function( event )

	-- if (somehow) there's no event, bail
	if not event then return end

	if event.type == "InputEventType_FirstPress" then
		
		if event.button == "Start" or event.button == "Back" then
			if muffet_nobodycame then
				tpaused = not tpaused
				screen:PauseGame(tpaused)
				tpaused = not tpaused
				screen:PauseGame(tpaused)			
			end
		end
		
		if event.button == "Left" and event.PlayerNumber == PLAYER_1 then
			muffet_keys[1] = 1
		end
		if event.button == "Down" and event.PlayerNumber == PLAYER_1 then
			muffet_keys[2] = 1
		end
		if event.button == "Up" and event.PlayerNumber == PLAYER_1 then
			muffet_keys[3] = 1
		end
		if event.button == "Right" and event.PlayerNumber == PLAYER_1 then
			muffet_keys[4] = 1
		end
		if event.button == "Left" and event.PlayerNumber == PLAYER_2 then
			muffet_keys[5] = 1
		end
		if event.button == "Down" and event.PlayerNumber == PLAYER_2 then
			muffet_keys[6] = 1
		end
		if event.button == "Up" and event.PlayerNumber == PLAYER_2 then
			muffet_keys[7] = 1
		end
		if event.button == "Right" and event.PlayerNumber == PLAYER_2 then
			muffet_keys[8] = 1
		end
		
	end
	
	if event.type == "InputEventType_Release" then
		
		if event.button == "Left" and event.PlayerNumber == PLAYER_1 then
			muffet_keys[1] = 0
		end
		if event.button == "Down" and event.PlayerNumber == PLAYER_1 then
			muffet_keys[2] = 0
		end
		if event.button == "Up" and event.PlayerNumber == PLAYER_1 then
			muffet_keys[3] = 0
		end
		if event.button == "Right" and event.PlayerNumber == PLAYER_1 then
			muffet_keys[4] = 0
		end
		if event.button == "Left" and event.PlayerNumber == PLAYER_2 then
			muffet_keys[5] = 0
		end
		if event.button == "Down" and event.PlayerNumber == PLAYER_2 then
			muffet_keys[6] = 0
		end
		if event.button == "Up" and event.PlayerNumber == PLAYER_2 then
			muffet_keys[7] = 0
		end
		if event.button == "Right" and event.PlayerNumber == PLAYER_2 then
			muffet_keys[8] = 0
		end
		
	end

end

muffet_bpm = 230

muffet_killed = false;

muffet_voting = {0,0}

muffet_healspawner = math.random(2,5);

function Sound(str)
	local songName = GAMESTATE:GetCurrentSong():GetSongDir();
	SOUND:PlayOnce(songName..'lua/sounds/'..str..'.ogg');
end

muffet_srng = {math.random(0,200)-100,math.random(0,200)-100,math.random(0,200)-100,math.random(0,200)-100,math.random(0,200)-100,math.random(0,200)-100}
muffet_srng2 = {math.random(0,200)-100,math.random(0,200)-100,math.random(0,200)-100,math.random(0,200)-100,math.random(0,200)-100,math.random(0,200)-100}
muffet_spdr_ypos = {-96,-32,32,96,-64,64}

muffet_numplayers = 0
if GAMESTATE:IsPlayerEnabled(PLAYER_1) then muffet_numplayers = muffet_numplayers+1 end
if GAMESTATE:IsPlayerEnabled(PLAYER_2) then muffet_numplayers = muffet_numplayers+1 end

function muffet_other(pos)
	local poses = {-1,0,1}
	for i=3,1,-1 do
		if poses[i] == pos then
			table.remove(poses,i)
		end
	end
	return poses[math.random(1,table.getn(poses))]
end

muffet_numalive = muffet_numplayers

-- Gets the Current Rate Mod
function muffet_GetRateMod()
	
	--if true then return 0.5 end;
	
	--GAMESTATE:GetSongOptionsObject("ModsLevel_Song"):MusicRate()
	local so = GAMESTATE:GetSongOptions(3);
	Trace(so);
	local s = '';
	if not so then return 1.0 else s = so end
	if not s then return 1.0 end;
	
	local fbegin = string.find(s,'.',1,true);
	local fend = string.find(s,'xMusic');
	if fbegin and fend then
		return tonumber(string.sub(s,fbegin-1,fend-1));
	else
		return 1.0;
	end
	
	--TODO check if this works
	--return 1.0
	
end

muffet_ratemod = muffet_GetRateMod();
m_bl = (60/(muffet_bpm * muffet_ratemod));

function muffet_saveFileExists()
	local path=GAMESTATE:GetCurrentSong():GetSongDir();
	if FILEMAN:DoesFileExist(path.."lua/chara/muffet/savefile.lua") then
		return true
	end
	return false
end

function muffet_writeSaveFile()
	local file = RageFileUtil.CreateRageFile()
	local path=GAMESTATE:GetCurrentSong():GetSongDir();
	file:Open( path.."lua/chara/muffet/savefile.lua", 2 ) --2 = write
	file:PutLine("muffet_played = "..muffet_played)
	file:PutLine("muffet_failed = "..muffet_failed)
	file:PutLine("muffet_spare = "..muffet_spare)
	file:PutLine("muffet_kill = "..muffet_kill)
	file:PutLine("muffet_last = "..muffet_last)
	file:PutLine("--")
	file:PutLine("ut_LOVE = "..ut_LOVE)
	file:Close();
end

if muffet_saveFileExists() then
	--SCREENMAN:SystemMessage('Save File exists, loading');
	LoadActor("chara/muffet/savefile")
else
	--SCREENMAN:SystemMessage('Save File does not exist, creating new');
	muffet_played = 0
	muffet_failed = 0
	muffet_kill = 0
	muffet_spare = 0
	muffet_last = 0
	if not ut_LOVE then ut_LOVE = 0 end
	muffet_writeSaveFile()
end

if not ut_LOVE then ut_LOVE = 0 end

muffet_keys = {0,0,0,0,0,0,0,0}
muffet_held = {0,0,0,0,0,0,0,0}

muffet_state = 0
--0 = steps
--1 = dodging
--2 = menus

--test io
function test_printio()
	local s = 'io = {'
	
	for i=1,8 do
		s = s..tostring(muffet_keys[i])
	end
	
	Trace(s..'}')
end

muffet_posx = {-160,160}
muffet_posy = {0,0}

muffet_allfailed = false
muffet_dead = {false,false}
muffet_hp = {20,20}
muffet_heals = {0,0}
muffet_hits = {0,0}

muffet_lifebars = {}

muffet_hearts = {}
muffet_invin = {0,0}

muffet_lines = {}

function muffet_hittest(ax,ay,aw,ah,bx,by,bw,bh)
			
	if ax-(aw/2) > bx+(bw/2) then return false end
	if ax+(aw/2) < bx-(bw/2) then return false end
	if ay-(ah/2) > by+(bh/2) then return false end
	if ay+(ah/2) < by-(bh/2) then return false end
	
	return true;
	
end

muffet_spacingy = 64
muffet_movespdx = 4;
muffet_movespdy = 0.06;

muffet_top = -1
muffet_bottom = 1

muffet_scrollspd = 0;
muffet_addy = 0;
muffet_spawntop = -2;
muffet_scrollspawn = -1
muffet_scrolldist = 0;

function muffet_move(pn,dir)
	
	if dir == -1 and muffet_posy[pn] == muffet_top then return end
	if dir == 1 and muffet_posy[pn] == muffet_bottom then return end
	
	muffet_posy[pn] = muffet_posy[pn]+dir
	muffet_hearts[pn]:stoptweening();
	muffet_hearts[pn]:linear(muffet_movespdy);
	muffet_hearts[pn]:y(muffet_posy[pn]*muffet_spacingy + muffet_addy);
	
end

muffet_spawndist = 256;
muffet_culldist = 256
muffet_cull_all = false;

muffet_numslumpage = 0;
muffet_numhard = 0;

if GAMESTATE:IsPlayerEnabled(PLAYER_1) and GAMESTATE:GetCurrentSteps(PLAYER_1):GetDifficulty() == Difficulty_Edit then muffet_numslumpage = muffet_numslumpage+1 end
if GAMESTATE:IsPlayerEnabled(PLAYER_2) and GAMESTATE:GetCurrentSteps(PLAYER_2):GetDifficulty() == Difficulty_Edit then muffet_numslumpage = muffet_numslumpage+1 end
if GAMESTATE:IsPlayerEnabled(PLAYER_1) and GAMESTATE:GetCurrentSteps(PLAYER_1):GetDifficulty() == Difficulty_Hard then muffet_numhard = muffet_numhard+1 end
if GAMESTATE:IsPlayerEnabled(PLAYER_2) and GAMESTATE:GetCurrentSteps(PLAYER_2):GetDifficulty() == Difficulty_Hard then muffet_numhard = muffet_numhard+1 end

--seperate 3 projectiles into individual sprites
muffet_stuff = {{ptr=1},{ptr=1},{ptr=1},{ptr=1}}
function muffet_spawnprojectile(type,row,dir,speedmult,xspd,yspd,free)

	if muffet_numslumpage == muffet_numplayers then
		if type == 3 then type = 0 end			
	end
	
	if muffet_numhard == muffet_numplayers then
		if type == 0 and math.random(0,200)<10 then type = 3 end			
	end
	
	local a = muffet_stuff[type+1][ muffet_stuff[type+1].ptr ]
	
	local mov = 1
	if xspd then mov = xspd end
	
	if a then
		
		local ts = {'spider','donut','croissant','heal'}
		Trace('Spawning '..ts[type+1]);
		
		if xspd then a.xspd = xspd*muffet_ratemod end
		if yspd then a.yspd = yspd*muffet_ratemod end
		
		if free then
			a.free = free
		else
			a.free = 0;
		end
		
		local b = a.actor
		
		b:finishtweening();
		b:visible(true);
		b:y(row*muffet_spacingy)
		if not free or free and type==1 then
			b:x(dir*muffet_spawndist*-1)
		else
			b:x(speedmult)
		end
		
		b:zoom(1.4);
		
		a.dmg = 3;
		
		b:diffusealpha(0);
		
		if not free or free and type==1 then
			b:linear((1*m_bl)/muffet_ratemod)
			b:diffusealpha(1);
		end
		if not free then
			b:aux(1);
		end
		
		if free then
			if type == 0 or type == 1 or type == 3 then
				b:sleep(0);
				b:aux(1);
				b:diffusealpha(1);
			end
		else
			if type == 0 or type == 3 then
				b:linear((16*m_bl)/speedmult/muffet_ratemod)
				b:addx(muffet_spawndist*2*mov*dir)
				b:stopeffect();
			end
			if type == 2 then
				b:decelerate((16*m_bl)/speedmult/muffet_ratemod)
				b:addx(muffet_spawndist*2*mov*0.75*dir)
				b:accelerate((16*m_bl)/speedmult/muffet_ratemod)
				b:addx(-muffet_spawndist*2*mov*0.75*dir)
				b:spin();
				b:effectmagnitude(0,0,180);
			end
			b:sleep(0);
			b:linear((1*m_bl)/muffet_ratemod)
			b:diffusealpha(0);
			b:aux(0);
			b:queuecommand('Hide');
		end
		
	end
	
	muffet_stuff[type+1].ptr = muffet_stuff[type+1].ptr+1
	if muffet_stuff[type+1].ptr > table.getn(muffet_stuff[type+1]) then
		muffet_stuff[type+1].ptr = 1
	end
	
end

muffet_eyes = {}
muffet_eyestate = {1,1,1,1,1}
muffet_eyetimer = {0.03,0.03,0.03,0.03,0.03} --offset slightly
muffet_eyes_anm = {
	{0,-1},
	{1,0.05},
	{2,0.05},
	{3,0.1},
	{2,0.05},
	{1,0.05},
	{0,-2},
	{1,0.05},
	{2,0.05},
	{3,0.1},
	{2,0.05},
	{1,0.05},
	{0,-3},
	{1,0.05},
	{2,0.05},
	{3,0.1},
	{2,0.05},
	{1,0.05},
	{0,-3},
}

local function muffet_init()
	checked = false;
	
	mod_firstSeenBeat = GAMESTATE:GetSongBeat()
			
--how can I make simple m0d?
--this will instantly turn a mod on to max and then quickly turn it off with the specified parameters
--it's a simple mod

function simple_m0d(beat,strength,mult,mod,pn)
	if not strength then strength = 400 end
	if not mult then mult = 1 end
	if not mod then mod = 'drunk' end
	
	local alive = math.max(2*mult*math.abs(strength)/100,0.25)
	
	table.insert(mods,{beat,'*100000 '..strength..' '..mod,pn});
	table.insert(mods,{beat+.1,'*'..((1/mult)*math.abs(strength)/100)..' no '..mod,pn});
end
			
--alternates a mod back and forth before resetting to 0
--beat,num,div,amt,mod,pn
function mod_wiggle(beat,num,div,spd,amt,mod,pn,first)
	local fluct = 1
	for i=0,(num-1) do
		b = beat+(i/div)
		local m = 1
		if i==0 and not first then m = 0.5 end
		table.insert(mods,{b,'*'..math.abs(spd*m*amt/10)..' '..(amt*fluct)..' '..mod..'',pn});
		fluct = fluct*-1;
	end
	table.insert(mods,{beat+(num/div),'*'..math.abs(amt/20)..' no '..mod..'',pn});
end
			
--lua course :D
curmod = 1;
--{beat,mod,player}
mods = {
{0,'clearall'},
{1,'*10 1.5x'},
{1,'*1 sudden, *100000 100 suddenoffset, *10 reverse, *10 0 centered, *3 30 mini'},
{48,'*0.25 50 flip, *0.15 -30 tornado, dark'},

{68,'*10 centered, *10 no reverse, *10 no tornado, 1x'},

{124,'*0.48 no dark'},
{126,'*1.92 no centered, *0.96 no flip, *0.96 1.5x'},

--{127.5,'*1000 200 beat'},
--{190.5,'*1000 no beat'},

{188,'*1.92 centered, *0.96 50 flip, *0.96 1x, dark'},

{251,'*0.48 no dark'},
{252,'*3.84 no centered, *1.92 no flip, *1.92 1x, blind'},

{318,'*1.92 centered, *0.96 50 flip, *0.96 1x, dark'},

{380,'*0.48 no dark'},
{383,'*1.92 no centered, *0.96 no flip, *0.96 1.5x'},

{440,'*3.84 centered, *1.92 50 flip, dark'},

{500,'*10000 reverse, *10000 33 flip, *10000 -400 flip, *10000 1300 invert'},

{508,'*0.48 no dark'},

{32,'no blind'},
{64,'blind'},
{128,'no blind'},
{192,'blind'},
{256,'blind'},
{318,'blind'},
{384,'no blind'},
{444,'blind'},
{520,'no blind'},
{576,'blind'},

{580,'*2 dark'},

}

local fluct = 1
for i=129,190,2 do
	simple_m0d(i,600,0.3,'bumpy');
	simple_m0d(i,200*fluct,0.3,'drunk');
	simple_m0d(i,-80,0.3,'tornado');
	fluct = fluct*-1
end

for i=256,315,2 do
	simple_m0d(i,50,0.3,'stealth');
end

for i=384,407,4 do
	table.insert(mods,{i-.05,'*2 10 split'});
	table.insert(mods,{i+0.95,'*2 no split'});
	table.insert(mods,{i+1.95,'*2 -10 split, *2 10 reverse'});
	table.insert(mods,{i+2.95,'*2 no split, *2 no reverse'});
end
for i=416,439,4 do
	table.insert(mods,{i-.05,'*2 10 alternate'});
	table.insert(mods,{i+0.95,'*2 no alternate'});
	table.insert(mods,{i+1.95,'*2 -10 alternate, *2 10 reverse'});
	table.insert(mods,{i+2.95,'*2 no alternate, *2 no reverse'});
end

for j=0,3 do
	for i=0,7 do
		if 255.9+(2*i)+(16*j) < 316.5 then
			table.insert(mods,{255.8+(2*i)+(16*j),'*10000 no centered'})
			table.insert(mods,{256+(2*i)+(16*j),'*1.55 300 centered'})
			table.insert(mods,{256.1+(2*i)+(16*j),'*1.55 300 centered'})
			table.insert(mods,{256.2+(2*i)+(16*j),'*1.55 300 centered'})
			table.insert(mods,{256.3+(2*i)+(16*j),'*1.55 300 centered'})
			table.insert(mods,{256.4+(2*i)+(16*j),'*1.55 300 centered'})
			table.insert(mods,{256.5+(2*i)+(16*j),'*1.55 300 centered'})
		end
	end
end

--function mod_wiggle(beat,num,div,spd,amt,mod,pn,first)

--muffet got tha moves
muffet_curaction = 1;
--{beat,action,persist}
muffet_actions = {
	{1,function()
		muffet_textbox:x(SCREEN_CENTER_X+200);
		muffet_textbox:y(SCREEN_CENTER_Y-100);
		setBubble(0,9,16);
		sayThis('                  Ahuhuhu~',0.06,'',1);
		setTalkSpeeds(1,18,0)
		
		for i=1,72 do
			_G['let'..i]:bob();
			_G['let'..i]:effectmagnitude(0,3,0)
			_G['let'..i]:effectperiod(4)
			_G['let'..i]:effectoffset(i/4.5)
			_G['let'..i]:effectclock('bgm');
		end
		Sound('muffet1');
	end},
	{12,function()
	
		muffet_textbox:x(SCREEN_CENTER_X+200);
		muffet_textbox:y(SCREEN_CENTER_Y-100);
		setBubble(0,9,16);
		if muffet_played == 0 then
			sayThis('                  Humans...         My favourite~!',0.06,'',1);
			setTalkSpeeds(1,18,0)
			setTalkSpeeds(25,27,0.4)
			setTalkSpeeds(28,35,0)
		else
			if muffet_failed == 0 then
				if muffet_last == 1 then
					sayThis('                  Humans...         How awful~!',0.06,'',1);
					setTalkSpeeds(1,18,0)
					setTalkSpeeds(25,27,0.4)
					setTalkSpeeds(28,35,0)
				elseif muffet_last == 0 then
					sayThis('                  Oh... Have we     met before~?',0.06,'',1);
					setTalkSpeeds(1,18,0)
					setTalkSpeeds(21,23,0.4)
					setTalkSpeeds(32,36,0)
				end
			else
				sayThis('                  Oh... Have we     met before~?',0.06,'',1);
				setTalkSpeeds(1,18,0)
				setTalkSpeeds(21,23,0.4)
				setTalkSpeeds(32,36,0)
			end
		end
		Sound('muffet1');
		
		muffet_played = muffet_played+1;
		muffet_failed = muffet_failed+1;
		
		muffet_writeSaveFile();
	
	end},
	{28,function()
		clearThis()
		hideBubble()
	end},
	{64,function()
		muffet_textbox:x(SCREEN_CENTER_X+200);
		muffet_textbox:y(SCREEN_CENTER_Y-100);
		setBubble(0,8,16);
		for i=1,72 do
			_G['let'..i]:addy(-8);
		end
		colourText(19,24,.8,0,.8,1)
		if muffet_numplayers > 1 then
			sayThis('                  Purple looks      much better on    you, dearies~!',0.06,'',1);
		else
			sayThis('                  Purple looks      much better on    you, dearie~!',0.06,'',1);
		end
		setTalkSpeeds(1,18,0)
		setTalkSpeeds(31,36,0)
		setTalkSpeeds(50,54,0)
		Sound('muffet1');
	end},
	{80,function()
		clearThis()
		hideBubble()
	end},
	{264,function()
		muffet_textbox:x(SCREEN_CENTER_X);
		muffet_textbox:y(SCREEN_CENTER_Y-100);
		setBubble(1,8,16);
		for i=1,72 do
			_G['let'..i]:addy(-8);
		end
		
		sayThis('                  Ahuhuhu~',0.06,'',1);
		
		setTalkSpeeds(1,18,0)
		
		Sound('muffet1');
	end},
	{272,function()
		muffet_textbox:x(SCREEN_CENTER_X);
		muffet_textbox:y(SCREEN_CENTER_Y-100);
		setBubble(1,8,16);
		for i=1,72 do
			_G['let'..i]:addy(-8);
		end
		
		sayThis('                  Even your arrows  are caught in     my web~?',0.06,'',1);
		
		setTalkSpeeds(1,18,0)
		
		Sound('muffet1');
	end},
	{288,function()
		clearThis()
		hideBubble()
	end},
	{324,function()
		muffet_textbox:x(SCREEN_CENTER_X+200);
		muffet_textbox:y(SCREEN_CENTER_Y-100);
		setBubble(0,8,16);
		for i=1,72 do
			_G['let'..i]:addy(-8);
		end
		
		sayThis('                  It\'s time to      meet my pet~',0.06,'',1);
		
		setTalkSpeeds(1,18,0)
		
		Sound('muffet1');
	end},
	{340,function()
		clearThis()
		hideBubble()
	end},
	{520,function()
		
		muffet_textbox:x(SCREEN_CENTER_X+200);
		muffet_textbox:y(SCREEN_CENTER_Y-100);
		setBubble(0,8,16);
		for i=1,72 do
			_G['let'..i]:addy(-8);
		end
		
		sayThis('                  Can you dance     while dodging~?',0.06,'',1);
		
		setTalkSpeeds(1,18,0)
		setTalkSpeeds(31,36,0)
		Sound('muffet1');

	end},
	{540,function()
		clearThis()
		hideBubble()
	end},
	{580,function()
		muffet_state = 0;
		
		muffet_boxsize:linear(m_bl*2)
		muffet_boxsize:x(600);
		
		MESSAGEMAN:Broadcast('HideBar');
		
		for pn=1,2 do
			local flair = ''
			if GAMESTATE:IsPlayerEnabled(muffet_playerlist[pn]) then
				if muffet_hits[pn] == 0 then
					flair = 'no damage clear!'
				elseif muffet_hp[pn] == 20 and muffet_hits[pn] > 0 then
					flair = 'full health clear!'
				elseif muffet_hp[pn] > 0 and muffet_heals[pn] == 0 then
					flair = 'no heal clear!'
				end
			end
			_G['muffet_flairtext'..pn]:settext(flair);
		end
		
		muffet_world:linear(m_bl*2)
		muffet_world:x(SCREEN_CENTER_X)
		muffet_world:y(SCREEN_HEIGHT*0.75)
		
		muffet_textbox:x(SCREEN_CENTER_X+200);
		muffet_textbox:y(SCREEN_CENTER_Y-100);
		setBubble(0,8,16);
		for i=1,72 do
			_G['let'..i]:addy(-8);
		end
		
		sayThis('                  Ahuhuhu, okay~',0.06,'',1);
		
		setTalkSpeeds(1,18,0)
		
		Sound('muffet1');
		MESSAGEMAN:Broadcast('Ending');
	end},
	{584,function()
		for pn=1,2 do
			local a = _G['P'..pn]
			if a then a:basezoomx(0); a:basezoomy(0); end
		end
	end},
	{590,function()
		--wenis
		MESSAGEMAN:Broadcast('ShowChoices');
	end},
	{592,function()
		muffet_textbox:x(SCREEN_CENTER_X+200);
		muffet_textbox:y(SCREEN_CENTER_Y-100);
		setBubble(0,8,16);
		for i=1,72 do
			_G['let'..i]:addy(-8);
		end
		
		sayThis('                  I\'ll let you      leave~',0.06,'',1);
		
		setTalkSpeeds(1,18,0)
		setTalkSpeeds(49,54,0)
		
		Sound('muffet1');
	end},
	{612+20.0,function()
	
		muffet_failed = 0;
		--song cleared tbh
	
		--spare/kill voting
		if muffet_voting[1] > muffet_voting[2] then
			Sound('fatal');
			char_muffet:playcommand('Kill');
			clearThis()
			hideBubble()
			muffet_last = 1; --0=spare,1=kill
			muffet_kill = muffet_kill+1;
			if not ut_LOVE then
				ut_LOVE = 1
			else
				ut_LOVE = ut_LOVE+1;
			end
		else
			muffet_textbox:x(SCREEN_CENTER_X+200);
			muffet_textbox:y(SCREEN_CENTER_Y-100);
			setBubble(0,8,16);
			for i=1,72 do
				_G['let'..i]:addy(-8);
			end
			
			sayThis('                  Ahuhuhu~',0.06,'',1);
			
			setTalkSpeeds(1,18,0)
			Sound('muffet1');
			muffet_last = 0; --0=spare,1=kill
			muffet_spare = muffet_spare+1;
		end
		muffet_writeSaveFile();
	end},
	{624+20.0,function()
		if muffet_voting[1] > muffet_voting[2] then
			char_muffet:playcommand('Die');
			MESSAGEMAN:Broadcast('ut_LOVE');
		else
			muffet_textbox:x(SCREEN_CENTER_X+200);
			muffet_textbox:y(SCREEN_CENTER_Y-100);
			setBubble(0,8,16);
			for i=1,72 do
				_G['let'..i]:addy(-8);
			end
			
			sayThis('                  Come back again   some time~',0.06,'',1);
			
			setTalkSpeeds(1,18,0)
			setTalkSpeeds(52,54,0)
			Sound('muffet1');
		end
	end},
}

--muffet_spawnprojectile(type,row,dir,speedmult,xspd,yspd,free)
--{beat,type,row,dir,mult,xspd,yspd,free}
curprojectile = 1;
projectiles = {

--1st section

--{72,1,-1,1,1,3,2,1},
--{73,0,0,1,1,3,2,1},

{80,0,-1,-1,2},
{82,0,-1,-1,2},
{84,0,1,-1,2},
{86,0,1,-1,2},
{88,0,0,1,2},

{96,0,-1,1,2},
{96,0,1,1,2},
{100,0,0,-1,2},
{104,0,0,1,2},
{104,0,1,1,2},
{108,0,0,-1,2},
{108,0,-1,-1,2},

{112,0,1,1,3},
{114,0,0,1,3},
{116,0,-1,1,3},
{118,0,0,1,3},

{120,3,1,-1,2},
{120,0,-1,-1,2},

--2nd section

{192,0,0,-1,1},
{200,0,0,-1,1},

--[[
{208,2,-1,-1,2},
{212,2,0,-1,2},
{216,2,1,1,2},
{220,2,0,1,2},
]]

--muffet_spawnprojectile(type,row,dir,speedmult,xspd,yspd,free)
{208,1,0,1,1.5,3,3,1},
{208,1,0,1,1.5,3,0,1},

{212,1,0,-1,1.5,-3,3,1},
{212,1,0,-1,1.5,-3,0,1},

{216,1,0,1,1.5,3,-3,1},
{216,1,0,1,1.5,3,0,1},

{220,1,0,-1,1.5,-3,-3,1},
{220,1,0,-1,1.5,-3,0,1},

{228,2,-1,-1,2},
{228,2,0,-1,2},
{232,2,1,1,2},
{232,2,0,1,2},
{236,2,-1,-1,2},
{236,2,1,-1,2},

{248,0,-1,1,3},
{250,0,0,1,3},

--pet intro

{324,0,-1,-1,3},
{326,0,0,-1,3},
{328,0,1,-1,3},
{330,0,0,-1,3},
{332,0,-1,-1,3},
{334,0,0,-1,3},
{336,0,1,-1,3},
{338,0,0,-1,3},
{340,0,-1,-1,3},
{340,0,0,-1,3},
{342,0,-1,-1,3.5},
{342,0,1,-1,3.5},

--finale (dodge spiders while stepping)

{516,0,98,1,1},
{516,0,99,-1,1},
{524,0,98,1,1},
{524,0,99,-1,1},
{532,3,98,1,1},
{532,0,99,-1,1},
{540,0,98,1,1},
{540,0,99,-1,1},
{548,0,98,1,1},
{548,3,99,-1,1},
{556,0,98,1,1},
{556,0,99,-1,1},
{564,0,98,1,1},
{564,0,99,-1,1},
{572,0,98,1,1},
{572,0,99,-1,1},

}

for i=0,3 do
	local a = 0;
	local b = 0;
	if i==1 then a=3 end
	if i==3 then b=3 end
	table.insert(projectiles,{194+(i*4),a,-1,1,2})
	table.insert(projectiles,{196+(i*4),b,1,1,2})
end

--timed action broadcaster
curaction = 1;
--{beat,action,persist}
actions = {
	{1,function()
		for pn=1,2 do
			local a = _G['P'..pn]
			local d = 1;
			if pn==2 then d = -1 end
			if a then
				a:linear(0.1);
				a:addy(-85+60);
				a:x(SCREEN_CENTER_X-(160*d));
			end
		end
		
		for i=1,table.getn(muffet_lines) do
			muffet_lines[i]:y((i*muffet_spacingy)-(muffet_spacingy*8))
		end
		
		muffet_boxsize:linear(m_bl)
		muffet_boxsize:x(600);
		muffet_boxsize:z(1);
		muffet_boxsize:linear(m_bl)
		muffet_boxsize:y(200);
		
		muffet_world:sleep(m_bl)
		muffet_world:linear(m_bl)
		
	end},
	{1,function()
		char_muffet:x(SCREEN_CENTER_X)
		char_muffet:y(SCREEN_CENTER_Y-100)
		char_muffet:bounceend(0.3)
		char_muffet:zoom(1)
	end,true},
	{32,function()
		muffet_purple:linear(16*m_bl)
		muffet_purple:zoomy(200)
		muffet_purple:sleep(8*m_bl)
		muffet_purple:linear(8*m_bl)
		muffet_purple:diffusealpha(0)
	end},
	{48,function()
		for i=1,table.getn(muffet_lines) do
			muffet_lines[i]:diffusealpha(1);
		end
		for i=1,table.getn(muffet_hearts) do
			if GAMESTATE:IsPlayerEnabled(i-1) then
				muffet_hearts[i]:zoom(0.75)
			end
		end
	end,true},
	{64,function()
		muffet_state = 1;
		muffet_boxsize:linear(m_bl)
		muffet_boxsize:x(450);
		muffet_world:linear(m_bl)
		muffet_world:addy(-60);
		
		MESSAGEMAN:Broadcast('ShowBar');
	end},
	{126,function()
		muffet_state = 0;
		for pn=1,2 do
			local a = _G['P'..pn]
			local d = 1;
			if pn==2 then d = -1 end
			if a then
				a:linear(m_bl*2);
				a:y(SCREEN_CENTER_Y);
				a:x(SCREEN_CENTER_X-(160*d));
				if not muffet_dead[pn] then
					muffet_hearts[pn]:linear(m_bl*2);
					muffet_hearts[pn]:y(SCREEN_CENTER_Y-120);
					muffet_hearts[pn]:x(SCREEN_CENTER_X-(160*d));
				end
			end
		end
		
		char_muffet:sleep(m_bl)
		char_muffet:linear(m_bl)
		char_muffet:y(SCREEN_CENTER_Y);
		
		muffet_boxsize:linear(m_bl)
		muffet_boxsize:x(0);
		muffet_boxsize:linear(m_bl)
		muffet_boxsize:y(0);
		muffet_boxsize:linear(m_bl)
		muffet_boxsize:z(0);
		
		MESSAGEMAN:Broadcast('HideBar');
		
	end},
	
	{128,function()
		for pn=1,2 do
			local a = _G['P'..pn]
			local d = 1;
			if pn==2 then d = -1 end
			if a then
				a:wag()
				a:effectperiod(4)
				a:effectclock('bgm')
				a:effectmagnitude(0,0,15)
			end
		end
	end},
	
	{144,function() MESSAGEMAN:Broadcast('Spdr1'); MESSAGEMAN:Broadcast('Spdr2'); end},
	{160,function() MESSAGEMAN:Broadcast('Spdr3'); MESSAGEMAN:Broadcast('Spdr4'); end},
	{176,function() MESSAGEMAN:Broadcast('Spdr5'); MESSAGEMAN:Broadcast('Spdr6'); end},
	{188,function() MESSAGEMAN:Broadcast('SpdrAway'); end},
	
	{400,function() MESSAGEMAN:Broadcast('Spdr1B'); MESSAGEMAN:Broadcast('Spdr2B'); end},
	{416,function() MESSAGEMAN:Broadcast('Spdr3B'); MESSAGEMAN:Broadcast('Spdr4B'); end},
	{432,function() MESSAGEMAN:Broadcast('Spdr5B'); MESSAGEMAN:Broadcast('Spdr6B'); end},
	{440,function() MESSAGEMAN:Broadcast('SpdrAwayB'); end},

	{188,function()
		muffet_state = 0;
		for pn=1,2 do
		
			local d = 1;
			if pn==2 then d = -1 end
			
			if not muffet_dead[pn] then
				muffet_hearts[pn]:x(-120*d);
				muffet_hearts[pn]:y(0);
			end
			
			muffet_posx[pn] = -120*d
			muffet_posy[pn] = 0
			
			local a = _G['P'..pn]
			if a then
				a:linear(m_bl*2);
				a:x(SCREEN_CENTER_X+muffet_posx[pn]);
				a:y((SCREEN_HEIGHT*0.75-70)+(muffet_posy[pn]*muffet_spacingy));
				a:stopeffect();
			end
		end
		
		char_muffet:sleep(m_bl)
		char_muffet:linear(m_bl)
		char_muffet:y(SCREEN_CENTER_Y-100);
		
		muffet_boxsize:linear(m_bl)
		muffet_boxsize:x(450);
		muffet_boxsize:z(1);
		muffet_boxsize:linear(m_bl)
		muffet_boxsize:y(200);
		
	end},
	{191,function()		
		MESSAGEMAN:Broadcast('ShowBar');
	end},
	{192,function()
		muffet_state = 1;
	end},
	{252,function()		
		MESSAGEMAN:Broadcast('HideBar');
	end},
	{252,function()
		muffet_state = 0;
		for pn=1,2 do
			local a = _G['P'..pn]
			local d = 1;
			if pn==2 then d = -1 end
			if a then
				a:linear(m_bl*2);
				a:y(SCREEN_CENTER_Y);
				a:x(SCREEN_CENTER_X-(SCREEN_WIDTH*0.25*d));
				if not muffet_dead[pn] then
					muffet_hearts[pn]:linear(m_bl*2);
					muffet_hearts[pn]:y(SCREEN_CENTER_Y-120);
					muffet_hearts[pn]:x(SCREEN_CENTER_X-(SCREEN_WIDTH*0.25*d));
					muffet_hearts[pn]:diffusealpha(0);
				end
			end
		end
		
		muffet_boxsize:linear(m_bl*2)
		muffet_boxsize:x(SCREEN_WIDTH-40);
		muffet_boxsize:linear(m_bl*2)
		muffet_boxsize:y(SCREEN_HEIGHT-40);
		muffet_world:linear(m_bl*2)
		muffet_world:x(SCREEN_WIDTH*0.5);
		muffet_world:linear(m_bl*2)
		muffet_world:y(SCREEN_HEIGHT*0.5);
	end},
	{288-.25,function()
		for pn=1,2 do
			local a = _G['P'..pn]
			local d = 1;
			if pn==2 then d = -1 end
			if a then
				a:rotationz(-20);
				a:sleep(m_bl*6);
				a:rotationz(-12);
				a:sleep(m_bl*0.5);
				a:rotationz(-4);
				a:sleep(m_bl*0.5);
				a:rotationz(4);
				a:sleep(m_bl*0.5);
				a:rotationz(12);
				a:sleep(m_bl*0.5);
				
				a:rotationz(20);
				a:sleep(m_bl*6);
				a:rotationz(12);
				a:sleep(m_bl*0.5);
				a:rotationz(4);
				a:sleep(m_bl*0.5);
				a:rotationz(-4);
				a:sleep(m_bl*0.5);
				a:rotationz(-12);
				a:sleep(m_bl*0.5);
				
				a:rotationz(-20);
				a:sleep(m_bl*6);
				a:rotationz(0);
				a:sleep(m_bl*2);
				a:rotationz(20);
				a:sleep(m_bl*4);
				a:rotationz(0);
				
			end
		end
	end},
	{318,function()
	
		muffet_spawndist = 200
		muffet_culldist = 200
	
		muffet_state = 0;
		for pn=1,2 do
		
			local d = 1;
			if pn==2 then d = -1 end
			
			if not muffet_dead[pn] then
				muffet_hearts[pn]:x(-100*d);
				muffet_hearts[pn]:y(0);
			
				muffet_hearts[pn]:linear(m_bl*2);
				muffet_hearts[pn]:diffusealpha(1);
			end
			
			muffet_posx[pn] = -100*d
			muffet_posy[pn] = 0
			
			local a = _G['P'..pn]
			if a then
				a:linear(m_bl*2);
				a:x(SCREEN_CENTER_X-150+muffet_posx[pn]);
				a:y((SCREEN_HEIGHT*0.75-70)+(muffet_posy[pn]*muffet_spacingy));
				a:stopeffect();
			end
		end
		
		muffet_boxsize:linear(m_bl*2)
		muffet_boxsize:x(300);
		muffet_boxsize:y(200);
		muffet_boxsize:z(1);
		
		muffet_world:linear(m_bl*2)
		muffet_world:x(SCREEN_CENTER_X-150)
		muffet_world:y(SCREEN_HEIGHT*0.75-60)
		
	end,true},
	{319,function()		
		MESSAGEMAN:Broadcast('ShowBar');
	end},
	{320,function()
		muffet_state = 1;
		
		muffet_world:bob()
		muffet_world:effectperiod(4)
		muffet_world:effectclock('bgm')
		muffet_world:effectmagnitude(0,32,0)
		
		muffet_world:linear(24*m_bl);
		muffet_world:x(SCREEN_CENTER_X+150)
		
	end},
	{343,function()
		
		MESSAGEMAN:Broadcast('PetPhase1');
		
	end},
	{344,function()
		
		muffet_world:stopeffect();
		
	end},
	{348,function()
		
		MESSAGEMAN:Broadcast('OpenMouth');
		
	end},
	
	{350,function()
	
		muffet_spawndist = 120;
		muffet_culldist = 120;
		
		muffet_boxsize:linear(m_bl*2)
		muffet_boxsize:x(200);
		muffet_boxsize:y(300);
		
		muffet_world:linear(m_bl*2)
		muffet_world:x(SCREEN_CENTER_X)
		muffet_world:y(SCREEN_HEIGHT*0.5)
		
		char_muffet:linear(m_bl*2);
		char_muffet:x(SCREEN_CENTER_X-200);
		char_muffet:y(SCREEN_CENTER_Y);
		
		MESSAGEMAN:Broadcast('PetPhase2');
		
	end},
	
	{352,function()
	
		muffet_top = -999
		muffet_bottom = 999
		muffet_scrollspd = 2*muffet_ratemod
		
		muffet_world:wag()
		muffet_world:effectperiod(8)
		muffet_world:effectclock('bgm')
		muffet_world:effectmagnitude(0,0,15)
		
	end},
	{383,function()
	
		for i=1,table.getn(muffet_lines) do
			muffet_lines[i]:linear(m_bl);
			muffet_lines[i]:y((i*muffet_spacingy)-(muffet_spacingy*8))
		end
		
		muffet_world:stopeffect()
		muffet_state = 0;
		muffet_scrollspd = 0
		muffet_scrolldist = 0;
		
		for pn=1,2 do
			local a = _G['P'..pn]
			local d = 1;
			if pn==2 then d = -1 end
			if a then
				a:linear(m_bl);
				a:x(SCREEN_CENTER_X-(160*d));
			end
		end
		
		MESSAGEMAN:Broadcast('PetAway');
	
		char_muffet:linear(m_bl*1);
		char_muffet:x(SCREEN_CENTER_X)
		char_muffet:y(SCREEN_CENTER_Y)
		
		muffet_boxsize:linear(m_bl*1)
		muffet_boxsize:x(0);
		muffet_boxsize:y(0);
		muffet_boxsize:linear(m_bl)
		muffet_boxsize:z(0);
		
		muffet_cull_all = true;
		muffet_srng = {math.random(0,200)-100,math.random(0,200)-100,math.random(0,200)-100,
		math.random(0,200)-100,math.random(0,200)-100,math.random(0,200)-100}
		
		MESSAGEMAN:Broadcast('HideBar');
	end},
	{385,function()
		muffet_cull_all = false;
		muffet_addy = 0;
		muffet_spawntop = -2;
		muffet_scrollspawn = -1
	end},
	
	
	{439,function()
		MESSAGEMAN:Broadcast('PetPhase1');
	end},
	{440,function()
		
	end},
	{444,function()
		MESSAGEMAN:Broadcast('OpenMouth');
	end},
	{438,function()
	
		muffet_spawndist = 200
		muffet_culldist = 200
	
		muffet_state = 0;
		for pn=1,2 do
		
			local d = 1;
			if pn==2 then d = -1 end
			
			if not muffet_dead[pn] then
				muffet_hearts[pn]:x((-80*d)-50);
				muffet_hearts[pn]:y(0);
				
				muffet_hearts[pn]:linear(m_bl*2);
				muffet_hearts[pn]:diffusealpha(1);
			end
			
			muffet_posx[pn] = (-80*d)-50
			muffet_posy[pn] = 0
			
			local a = _G['P'..pn]
			if a then
				a:linear(m_bl*2);
				a:x(SCREEN_CENTER_X+150+muffet_posx[pn]);
				a:y((SCREEN_HEIGHT*0.75-70)+(muffet_posy[pn]*muffet_spacingy));
				a:stopeffect();
			end
		end
		
		muffet_boxsize:linear(m_bl*2)
		muffet_boxsize:x(300);
		muffet_boxsize:y(200);
		muffet_boxsize:z(1);
		
		muffet_world:linear(m_bl*2)
		muffet_world:x(SCREEN_CENTER_X+150)
		muffet_world:y(SCREEN_HEIGHT*0.75-60)
		
	end,true},
	{439,function()		
		MESSAGEMAN:Broadcast('ShowBar');
	end},
	
	{446,function()
	
		muffet_state = 1;
	
		muffet_spawndist = 140;
		muffet_culldist = 140;
		
		muffet_boxsize:linear(m_bl*2)
		muffet_boxsize:x(240);
		muffet_boxsize:y(300);
		
		muffet_world:linear(m_bl*2)
		muffet_world:x(SCREEN_CENTER_X+120)
		muffet_world:y(SCREEN_HEIGHT*0.5)
		
		char_muffet:linear(m_bl*2);
		char_muffet:x(SCREEN_CENTER_X-200);
		char_muffet:y(SCREEN_CENTER_Y);
		
		MESSAGEMAN:Broadcast('PetPhase2');
		
	end},
	
	{448,function()
	
		muffet_top = -999
		muffet_bottom = 999
		muffet_scrollspd = 2.2*muffet_ratemod
		
		muffet_world:wag()
		muffet_world:effectperiod(8)
		muffet_world:effectclock('bgm')
		muffet_world:effectmagnitude(0,0,15)
		
		muffet_world:accelerate(m_bl*4)
		muffet_world:x(SCREEN_CENTER_X)
		muffet_world:decelerate(m_bl*4)
		muffet_world:x(SCREEN_CENTER_X-120)
		muffet_world:accelerate(m_bl*4)
		muffet_world:x(SCREEN_CENTER_X)
		muffet_world:decelerate(m_bl*4)
		muffet_world:x(SCREEN_CENTER_X+120)
		muffet_world:accelerate(m_bl*4)
		muffet_world:x(SCREEN_CENTER_X)
		muffet_world:decelerate(m_bl*4)
		muffet_world:x(SCREEN_CENTER_X-120)
		muffet_world:accelerate(m_bl*4)
		muffet_world:x(SCREEN_CENTER_X)
		muffet_world:decelerate(m_bl*4)
		muffet_world:x(SCREEN_CENTER_X+120)
		muffet_world:accelerate(m_bl*4)
		muffet_world:x(SCREEN_CENTER_X)
		muffet_world:decelerate(m_bl*4)
		muffet_world:x(SCREEN_CENTER_X-120)
		muffet_world:accelerate(m_bl*4)
		muffet_world:x(SCREEN_CENTER_X)
		muffet_world:decelerate(m_bl*4)
		muffet_world:x(SCREEN_CENTER_X+120)
		muffet_world:accelerate(m_bl*4)
		muffet_world:x(SCREEN_CENTER_X)
		muffet_world:decelerate(m_bl*4)
		muffet_world:x(SCREEN_CENTER_X-120)
		muffet_world:accelerate(m_bl*4)
		muffet_world:x(SCREEN_CENTER_X)
		
	end},
	
	{500,function()
		for pn=1,2 do
			local a = _G['P'..pn]
			if a then
				a:linear(m_bl*2);
				a:x(SCREEN_CENTER_X+muffet_posx[pn]);
				a:y(SCREEN_CENTER_Y);
			end
		end
	end},
	
	{508,function()
	
		MESSAGEMAN:Broadcast('PetAway');
		
		muffet_spawndist = 300
		muffet_culldist = 300
	
		muffet_scrollspd = 0;
		muffet_state = 0;
		
		for i=1,table.getn(muffet_lines) do
			muffet_lines[i]:linear(0);
			muffet_lines[i]:y((i*muffet_spacingy)-(muffet_spacingy*8))
		end
		muffet_scrolldist = 0;
		
		local d = 1
		
		for pn=1,2 do
		
			if pn == 2 then d = -1 end
			
			muffet_posx[pn] = (-120*d)
			muffet_posy[pn] = 0
			
			local a = _G['P'..pn]
			if a then
				a:linear(m_bl*2);
				a:x(SCREEN_CENTER_X+muffet_posx[pn]);
				a:y((SCREEN_HEIGHT*0.75-70)+(muffet_posy[pn]*muffet_spacingy));
			end
			
			if not muffet_dead[pn] then
				muffet_hearts[pn]:linear(m_bl*2)
				muffet_hearts[pn]:x(muffet_posx[pn])
				muffet_hearts[pn]:y(0)
			end
			
		end
		
		muffet_boxsize:linear(m_bl*2)
		muffet_boxsize:x(520);
		muffet_boxsize:y(200);
		muffet_boxsize:z(1);
		
		muffet_world:stopeffect()
		muffet_world:linear(m_bl*2)
		muffet_world:x(SCREEN_CENTER_X)
		muffet_world:y(SCREEN_HEIGHT*0.75-60)
		
		char_muffet:linear(m_bl*2)
		char_muffet:x(SCREEN_CENTER_X)
		char_muffet:y(SCREEN_CENTER_Y-100)
		
		muffet_top = -1
		muffet_bottom = 1
		muffet_addy = 0;
		
		muffet_cull_all = true;
	end},
	{512,function()
		muffet_state = 1;
		muffet_cull_all = false;
	end},
	
}

--SCREAMING GUMBALL
curmessage = 1;
--{beat,message}
messages = {
}

	function modtable_compare(a,b)
		return a[1] < b[1]
	end
	
	if table.getn(mods) > 1 then
		table.sort(mods, modtable_compare)
	end
	
	if table.getn(messages) > 1 then
		table.sort(messages, modtable_compare)
	end
	
	if table.getn(actions) > 1 then
		table.sort(actions, modtable_compare)
	end
	
	if table.getn(projectiles) > 1 then
		table.sort(projectiles, modtable_compare)
	end
	
	if table.getn(muffet_actions) > 1 then
		table.sort(muffet_actions, modtable_compare)
	end
	
end

local function muffet_update(self, delta)

	if GAMESTATE:GetSongBeat()>0 and not checked then
		if SCREENMAN:GetTopScreen():GetChild('PlayerP1') then p1on = true; else p1on = false; end
		if SCREENMAN:GetTopScreen():GetChild('PlayerP2') then p2on = true; else p2on = false; end
		
		P1 = SCREENMAN:GetTopScreen():GetChild('PlayerP1');
		P2 = SCREENMAN:GetTopScreen():GetChild('PlayerP2');
		
		muffet_nobodycame = false;
		
		Trace(muffet_kill%2);
		
		if muffet_kill%2 == 0 and muffet_kill > 0 then
			--BUT NOBODY CAME
			MESSAGEMAN:Broadcast('ButNobodyCame');
			Sound('nobody');
			
			muffet_lastunpausedtime = GetTimeSinceStart();
			
			SCREENMAN:GetTopScreen():PauseGame(true);
			muffet_nobodycame = true;
			muffet_kill = muffet_kill+1;
			muffet_writeSaveFile();
		end
		
		screen = SCREENMAN:GetTopScreen();
		screen:SetDrawByZPosition(true);
		
		screen:AddInputCallback( InputHandler )
		
		if SCREENMAN:GetTopScreen():GetChild('SongForeground') then
			SCREENMAN:GetTopScreen():GetChild('SongForeground'):z(2)
		end
		
		if P1 then P1:z(1) end
		if P2 then P2:z(1) end
		
		checked = true;
	end
	
	--Trace(muffet_kill);
	
	if muffet_nobodycame and GetTimeSinceStart() - muffet_lastunpausedtime > 10 then
		--SCREENMAN:GetTopScreen():PauseGame(false);
		if GAMESTATE:IsPlayerEnabled(PLAYER_1) then
			local pss = STATSMAN:GetCurStageStats():GetPlayerStageStats(PLAYER_1);
			if pss then
				pss:FailPlayer()
			end
		end
		if GAMESTATE:IsPlayerEnabled(PLAYER_2) then
			local pss = STATSMAN:GetCurStageStats():GetPlayerStageStats(PLAYER_2);
			if pss then
				pss:FailPlayer()
			end
		end
		SCREENMAN:GetTopScreen():StartTransitioningScreen("SM_DoNextScreen")
	end
	
	if checked then
		--test_printio()
	end
	
	local beat = GAMESTATE:GetSongBeat()
	
	for pn=1,2 do
		if muffet_dead[pn] == false and muffet_hp[pn] <= 0 then
			muffet_dead[pn] = true;
			muffet_numalive = muffet_numalive-1;
			muffet_hearts[pn]:stoptweening();
			muffet_hearts[pn]:setstate(((pn-1)*2)+1);
			muffet_hearts[pn]:sleep(1);
			muffet_hearts[pn]:linear(1);
			muffet_hearts[pn]:diffusealpha(0);
			
			if _G['P'..pn] then
				_G['P'..pn]:basezoomx(0);
				_G['P'..pn]:basezoomy(0);
			end
			
			Sound('die1');
		end
	end
	
	if muffet_numalive == 0 and not muffet_allfailed then
		MESSAGEMAN:Broadcast('GameOver');
		muffet_allfailed = true;
	end
	
	if beat>352 and beat<383 or beat>448 and beat<508 then
		for i=1,table.getn(muffet_lines) do
			muffet_lines[i]:addy(muffet_scrollspd*delta*50);
		end
		
		muffet_scrolldist = muffet_scrolldist+(muffet_scrollspd*delta*50)
		
		if muffet_scrolldist > muffet_spacingy then
			for i=1,table.getn(muffet_lines) do
				muffet_lines[i]:addy(-muffet_spacingy);
			end
			muffet_spawntop = muffet_spawntop-1;
			
				--muffet_spawnprojectile(type,row,dir,speedmult,xspd,yspd,free)
				
				local h = 0;
				
				muffet_healspawner = muffet_healspawner-1;
				if muffet_healspawner <= 0 then
					h = 3;
					muffet_healspawner = 10
				end
				
				if beat > 440 then
					muffet_spawnprojectile(0,muffet_spawntop,(math.random(0,1)*2)-1,math.random(60,140)*1,2.2,0,1)
					muffet_spawnprojectile(h,muffet_spawntop,(math.random(0,1)*2)-1,math.random(0,80)-40,2.2,0,1)
					muffet_spawnprojectile(0,muffet_spawntop,(math.random(0,1)*2)-1,math.random(60,140)*-1,2.2,0,1)
				else
					muffet_spawnprojectile(0,muffet_spawntop,(math.random(0,1)*2)-1,math.random(10,80)*1,2,0,1)
					muffet_spawnprojectile(h,muffet_spawntop,(math.random(0,1)*2)-1,math.random(10,80)*-1,2,0,1)
				end
				
			muffet_scrolldist = muffet_scrolldist-muffet_spacingy
		end
		
		muffet_addy = muffet_addy+(muffet_scrollspd*delta*50);
		for pn=1,2 do
			if GAMESTATE:IsPlayerEnabled(muffet_playerlist[pn]) and not muffet_dead[pn] then
				muffet_hearts[pn]:addy(muffet_scrollspd*delta*50);
			end
		end
	end
	
	for i=1,table.getn(muffet_stuff) do
		for j=1,table.getn(muffet_stuff[i]) do
			if muffet_stuff[i][j].actor:getaux() >= 0.6 then
				local a = muffet_stuff[i][j];
				local b = muffet_stuff[i][j].actor;
				if a.xspd and a.xspd ~= 0 then
					b:addx(a.xspd*delta*50)
					local dir = a.xspd/math.abs(a.xspd)
					if muffet_scrollspd ~= 0 then
						if b:GetX() > muffet_boxsize:GetX()/2 - 16 then
							b:x(muffet_boxsize:GetX()/2 - 16);
							a.xspd = -math.abs(a.xspd)
						end
						if b:GetX() < -muffet_boxsize:GetX()/2 + 16 then
							b:x(-muffet_boxsize:GetX()/2 + 16);
							a.xspd = math.abs(a.xspd)
						end
					else
						if (dir == 1 and b:GetX() > 0 or dir == -1 and b:GetX() < 0) and math.abs(b:GetX()) > muffet_culldist or muffet_cull_all then
							b:stoptweening();
							b:visible(false)
							b:aux(0)
						end
					end
				end
				if muffet_scrollspd > 0 and a.free then
					b:addy(muffet_scrollspd*delta*50)
				end
				if a.yspd and a.yspd ~= 0 and a.type == 1 then
					b:addy(a.yspd*delta*50)
					if b:GetY() > muffet_boxsize:GetY()/2 - 16 then
						b:y(muffet_boxsize:GetY()/2 - 16);
						a.yspd = -math.abs(a.yspd)
						b:setstate(1)
					end
					if b:GetY() < -muffet_boxsize:GetY()/2 + 16 then
						b:y(-muffet_boxsize:GetY()/2 + 16);
						a.yspd = math.abs(a.yspd)
						b:setstate(1)
					end
				end
			end
		end
	end
	
	if beat>596 and beat<612+20.0 then
		muffet_votetimer:settext(tostring(math.floor((0.25*(612+20.0))-(0.25*GAMESTATE:GetSongBeat()))));
	end
	if beat>612+20.0 and beat<612.25+20.0 then
		muffet_votetimer:settext('');
	end
	
	if beat>592 and beat<612+20.0 then
		muffet_vote1:settext(muffet_voting[1])
		muffet_vote2:settext(muffet_voting[2])
		if muffet_voting[1]>muffet_voting[2] then
			muffet_btn1:setstate(1);
			muffet_btn2:setstate(0);
		else
			muffet_btn1:setstate(0);
			muffet_btn2:setstate(1);
		end
	end
	
	if table.getn(muffet_hearts) > 0 then
		for pn=1,2 do
		
			if muffet_state == 1 and GAMESTATE:IsPlayerEnabled(muffet_playerlist[pn]) then
				if muffet_invin[pn] < 0 or muffet_dead[pn] then
					muffet_invin[pn] = 0;
				end
				if muffet_invin[pn] > 0 then
					muffet_invin[pn] = muffet_invin[pn]-delta;
				else
					muffet_hearts[pn]:stopeffect();
				end
			end
		
			if beat>68 and beat<126 or beat>249 and beat<252 then
				local a = _G['P'..pn]
				if a then
					a:x(SCREEN_CENTER_X+muffet_posx[pn]);
					a:y((SCREEN_HEIGHT*0.75-70)+(muffet_hearts[pn]:GetY()));
				end
			end
			
			if beat>380 and beat<383 then
				local a = _G['P'..pn]
				if a then
					a:x(SCREEN_CENTER_X+muffet_posx[pn]);
					a:y(SCREEN_CENTER_Y);
				end
			end
			
			if beat>512 then
				local a = _G['P'..pn]
				if a then
					a:x(SCREEN_CENTER_X+muffet_posx[pn]);
					a:y((SCREEN_HEIGHT*0.75-70)+(muffet_hearts[pn]:GetY()));
				end
			end
		
			local bpn = pn-1;
			
			if beat>592 and beat<612+20.0 then
				for i=1,4 do
					if muffet_keys[i+(bpn*4)] == 1 and muffet_held[i+(bpn*4)] == 0 then						
						if i==1 then
							muffet_voting[1] = muffet_voting[1]+1;
						elseif i==4 then
							muffet_voting[2] = muffet_voting[2]+1;
						end
					end
					muffet_held[i+(bpn*4)] = 1;
					if muffet_keys[i+(bpn*4)] == 0 then
						muffet_held[i+(bpn*4)] = 0
					end
				end
			end
			
			if muffet_state == 1 and not muffet_dead[pn] then
				for i=1,4 do
					if muffet_keys[i+(bpn*4)] == 1 and muffet_held[i+(bpn*4)] == 0 then						
						local p = muffet_hearts[pn]
						if i==2 and p and p:GetY() < 96 then
							muffet_move(pn,1)
						elseif i==3 and p and p:GetY() > -96 then
							muffet_move(pn,-1)
						end
						muffet_held[i+(bpn*4)] = 1;
					end
					if muffet_keys[i+(bpn*4)] == 0 then
						muffet_held[i+(bpn*4)] = 0
					end
				end
				if beat<508 then
					if muffet_keys[1+(bpn*4)] == 1 then
						muffet_hearts[pn]:addx(-muffet_movespdx*delta*50)
					end
					if muffet_keys[4+(bpn*4)] == 1 then
						muffet_hearts[pn]:addx(muffet_movespdx*delta*50)
					end
				end
				
				if muffet_hearts[pn]:GetX() > muffet_boxsize:GetX()/2 - 16 then
					muffet_hearts[pn]:x(muffet_boxsize:GetX()/2 - 16);
				end
				if muffet_hearts[pn]:GetX() < -muffet_boxsize:GetX()/2 + 16 then
					muffet_hearts[pn]:x(-muffet_boxsize:GetX()/2 + 16);
				end
				muffet_posx[pn] = muffet_hearts[pn]:GetX()
			end
			
			--hittest
			if muffet_state == 1 then
				
				if GAMESTATE:IsPlayerEnabled(muffet_playerlist[pn]) and not muffet_dead[pn] then
					local p = muffet_hearts[pn]
					if p and p:GetY() > 128 then
						if muffet_invin[pn] == 0 then
							muffet_invin[pn] = 3;
							muffet_hp[pn] = muffet_hp[pn]-5
							Sound('damage');
							muffet_hits[pn] = muffet_hits[pn]+1
							
							muffet_hearts[pn]:diffuseblink();
							muffet_hearts[pn]:effectcolor1(1,1,1,0.8);
							muffet_hearts[pn]:effectcolor2(1,1,1,0.4);
							muffet_hearts[pn]:effectclock('bgm');
							muffet_hearts[pn]:effectperiod(0.5);
						
						end
						muffet_move(pn,-1)
					end
				end
				
				if GAMESTATE:IsPlayerEnabled(muffet_playerlist[pn]) and not muffet_dead[pn] then
					local p = muffet_hearts[pn]
					local i = 4
					for j=1,table.getn(muffet_stuff[i]) do
						if muffet_stuff[i][j].actor:getaux() >= 0.6 then
							local b = muffet_stuff[i][j];
							local a = muffet_stuff[i][j].actor;
							if muffet_hittest(p:GetX(),p:GetY(),16,16,a:GetX(),a:GetY(),24,24) then
								
								Sound('heal');
								Trace('Heal (P'..pn..' '..p:GetX()..','..p:GetY()..' obj'..i..' '..a:GetX()..','..a:GetY()..')');
								muffet_hp[pn] = math.min(muffet_hp[pn]+5,20);
								muffet_heals[pn] = muffet_heals[pn]+1
								
								a:stoptweening();
								a:visible(false)
								a:aux(0)
								
							end
						end
					end
					
				end 
				
				if muffet_invin[pn] == 0 and GAMESTATE:IsPlayerEnabled(muffet_playerlist[pn]) and not muffet_dead[pn] then
					local p = muffet_hearts[pn]
					for i=1,table.getn(muffet_stuff)-1 do
						for j=1,table.getn(muffet_stuff[i]) do
							if muffet_stuff[i][j].actor:getaux() >= 0.6 then
								local b = muffet_stuff[i][j];
								local a = muffet_stuff[i][j].actor;
								if muffet_hittest(p:GetX(),p:GetY(),16,16,a:GetX(),a:GetY(),24,24) then
									
									Sound('damage');
									Trace('Hit (P'..pn..' '..p:GetX()..','..p:GetY()..' obj'..i..' '..a:GetX()..','..a:GetY()..')');
									muffet_invin[pn] = 2.5;
									muffet_hp[pn] = math.max(muffet_hp[pn]-b.dmg,0);
									muffet_hits[pn] = muffet_hits[pn]+1
									
									muffet_hearts[pn]:diffuseblink();
									muffet_hearts[pn]:effectcolor1(1,1,1,0.8);
									muffet_hearts[pn]:effectcolor2(1,1,1,0.4);
									muffet_hearts[pn]:effectclock('bgm');
									muffet_hearts[pn]:effectperiod(0.5);
									
								end
							end
						end
					end
				end
			else
				local p = muffet_hearts[pn]
				muffet_hearts[pn]:stopeffect();
				muffet_invin[pn] = 0;
			end
			
		end
	end
	
	if beat > mod_firstSeenBeat+0.1 then
		
		if beat > mod_firstSeenBeat+5 then
			for pn=1,2 do
				if GAMESTATE:IsPlayerEnabled(muffet_playerlist[pn]) then
					if muffet_hp[pn] > 0 then
						muffet_lifebars[pn]:zoomto(muffet_hp[pn]*3,20)
					else
						muffet_lifebars[pn]:zoomto(0,20)
					end
				else
					muffet_lifebars[pn]:visible(false)
				end
			end
		end
	
		for i=1,5 do
			if not muffet_killed then
				muffet_eyetimer[i] = muffet_eyetimer[i]+delta
				local dly = muffet_eyes_anm[ muffet_eyestate[i] ][2]
				if dly == -1 then
					dly = (i-1)*m_bl;
				end
				if dly == -2 then
					dly = (m_bl*8)-0.3-((i-1)*m_bl)
				end
				if dly == -3 then
					dly = (m_bl*4)-0.3
				end
				if muffet_eyetimer[i] > dly then
					muffet_eyetimer[i] = muffet_eyetimer[i]-dly;
					muffet_eyestate[i] = muffet_eyestate[i]+1
					if muffet_eyestate[i] > table.getn(muffet_eyes_anm) then
						muffet_eyestate[i] = 1
					end
					muffet_eyes[i]:setstate(muffet_eyes_anm[ muffet_eyestate[i] ][1])
				end
			else
				muffet_eyes[i]:setstate(3);
			end
		end
	end
	
	-- Collect all the mods that will be applied in this frame into one string.
	-- Mod tweening doesn't work correctly if the mods are in seperate commands.
	local mods_this_frame= {}
	local function add_mod(mod_str)
		mods_this_frame[#mods_this_frame+1]= mod_str
	end
	local function execute_mods()
		if #mods_this_frame <= 0 then return end
		local total_mod_str= ""
		for i, ms in ipairs(mods_this_frame) do
			if #total_mod_str > 0 then
				total_mod_str= total_mod_str .. ", "
			end
			total_mod_str= total_mod_str .. ms
		end
		muffet_mod(total_mod_str)
	end
	
	while curmod<= #mods and GAMESTATE:GetSongBeat()>=mods[curmod][1] do
		if table.getn(mods[curmod]) < 3 then
			add_mod(mods[curmod][2])
		else
			muffet_mod_internal(mods[curmod][2], 'PlayerNumber_P' .. mods[curmod][3])
		end
		curmod = curmod+1
	end

	execute_mods()
	
	--SCREAMING GUMBALL
	if not muffet_nobodycame then
		while curmessage<= #messages and GAMESTATE:GetSongBeat()>=messages[curmessage][1] do
			if messages[curmessage][4] and GAMESTATE:GetSongBeat()>=messages[curmessage][1]+5 then
				curmessage = curmessage+1;
			else
				MESSAGEMAN:Broadcast(messages[curmessage][2],messages[curmessage][3])
				curmessage = curmessage+1;
			end
		end
		
		---------------------------------------
		-- ACTION RPGS AINT GOT SHIT ON THIS --
		---------------------------------------
		if beat > mod_firstSeenBeat+0.1 then -- performance coding!! --
			
			muffet_zbuf:zoomto( muffet_boxsize:GetX(), muffet_boxsize:GetY() );
			muffet_gbox:zoomto( muffet_boxsize:GetX()+8, muffet_boxsize:GetY()+8 );
			muffet_gbox:diffusealpha( muffet_boxsize:GetZ() );
		
			--muffet_spawnprojectile(type,row,dir,speedmult,xspd,yspd,free)
			--projectile list = {beat,type,row,dir,mult,xspd,yspd,free}
			while curprojectile<=table.getn(projectiles) and GAMESTATE:GetSongBeat()>=projectiles[curprojectile][1]-1 do
				if GAMESTATE:GetSongBeat() < projectiles[curprojectile][1]+2 then
					local p = projectiles[curprojectile]
					if p[3] == 98 then
						if GAMESTATE:IsPlayerEnabled(PLAYER_1) then
							muffet_spawnprojectile(p[2],muffet_posy[1],p[4],p[5],p[6],p[7],p[8])
						else
							muffet_spawnprojectile(p[2],muffet_other(muffet_posy[2]),p[4],p[5],p[6],p[7],p[8])
						end
					elseif p[3] == 99 then
						if GAMESTATE:IsPlayerEnabled(PLAYER_2) then
							muffet_spawnprojectile(p[2],muffet_posy[2],p[4],p[5],p[6],p[7],p[8])
						else
							muffet_spawnprojectile(p[2],muffet_other(muffet_posy[1]),p[4],p[5],p[6],p[7],p[8])
						end
					else
						muffet_spawnprojectile(p[2],p[3],p[4],p[5],p[6],p[7],p[8])
					end
				end
				curprojectile = curprojectile+1;
			end
			
			while curaction<=table.getn(actions) and GAMESTATE:GetSongBeat()>=actions[curaction][1] do
				if actions[curaction][3] or GAMESTATE:GetSongBeat() < actions[curaction][1]+2 then
					actions[curaction][2]()
				end
				curaction = curaction+1;
			end
			
			while muffet_curaction<=table.getn(muffet_actions) and GAMESTATE:GetSongBeat()>=muffet_actions[muffet_curaction][1] do
				if muffet_actions[muffet_curaction][3] or GAMESTATE:GetSongBeat() < muffet_actions[muffet_curaction][1]+2 then
					muffet_actions[muffet_curaction][2]()
				end
				muffet_curaction = muffet_curaction+1;
			end
			
		end
	end
	
end

MLines = Def.ActorFrame{}

for i=0,18 do
	MLines[#MLines+1] = Def.Quad{
		OnCommand=cmd(visible,true;diffuse,0.72,0.11,0.65,0;zoomto,SCREEN_WIDTH,1;y,muffet_spacingy*(i-9);sleep,0.02;queuecommand,"SetMe"),
		SetMeCommand=function(self) table.insert(muffet_lines,self) end
	}
end

MSpiders = Def.ActorFrame{}
MDonuts = Def.ActorFrame{}
MCroissants = Def.ActorFrame{}
MHeals = Def.ActorFrame{}

for i=0,63 do
	MSpiders[#MSpiders+1] = LoadActor("p_spider")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"SetMe"), HideCommand=cmd(visible,false),
	InitCommand=function(self) self:SetTextureFiltering(false); end,
	SetMeCommand=function(self) table.insert(muffet_stuff[1],{actor=self,type=0,dmg=-1}) end, }
end

for i=0,15 do
	MDonuts[#MDonuts+1] = Def.Sprite{ Texture="donut 2x2.png",
	Frame0000=0,
	Delay0000=999,
	Frame0001=1,
	Delay0001=0.05,
	Frame0002=2,
	Delay0002=0.05,
	Frame0003=3,
	Delay0003=0.05,
	InitCommand=function(self) self:SetTextureFiltering(false); end,
	OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"SetMe"), HideCommand=cmd(visible,false),
	SetMeCommand=function(self) table.insert(muffet_stuff[2],{actor=self,type=1,dmg=-1}) end, }
end
for i=0,15 do
	MCroissants[#MCroissants+1] = LoadActor("p_croissant")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"SetMe"), HideCommand=cmd(visible,false),
	InitCommand=function(self) self:SetTextureFiltering(false); end,
	SetMeCommand=function(self) table.insert(muffet_stuff[3],{actor=self,type=2,dmg=-1}) end, }
end
for i=0,15 do
	MHeals[#MHeals+1] = LoadActor("p_heal")..{ OnCommand=cmd(visible,false;sleep,0.02;queuecommand,"SetMe"), HideCommand=cmd(visible,false),
	InitCommand=function(self) self:SetTextureFiltering(false); end,
	SetMeCommand=function(self) table.insert(muffet_stuff[4],{actor=self,type=3,dmg=-1}) end, }
end

return Def.ActorFrame{
	OnCommand= function(self)
							 muffet_init()
							 self:SetUpdateFunction(muffet_update)
							 
						 end,
	Def.Quad{
		Name= "I may be sleeping, but I preserve the world.",
		InitCommand= cmd(visible,false),
		OnCommand= cmd(sleep,1000),
	},
	
	Def.Quad{
		InitCommand= cmd(visible,false),
		HealthStateChangedMessageCommand=function(self,params)
			if params.HealthState == 'HealthState_Dead' then
				if params.PlayerNumber == PLAYER_1 then
					--SCREENMAN:SystemMessage('Player 1 died');
					--muffet_playerfailed[1] = 1
				elseif params.PlayerNumber == PLAYER_2 then
					--SCREENMAN:SystemMessage('Player 2 died');
					--muffet_playerfailed[2] = 1
				else
					SCREENMAN:SystemMessage('Someone died somewhere');
				end
			end
		end
	},
	
	Def.Quad{
		OnCommand=cmd(visible,false),
		InitCommand=function(self) muffet_boxsize = self end,
	},
	
	Def.ActorFrame{
		Def.ActorFrame{ InitCommand=function(self) muffet_world = self end, OnCommand=cmd(x,SCREEN_CENTER_X;y,SCREEN_HEIGHT*0.75),
			
			Def.Quad{ InitCommand=function(self) muffet_zbuf = self end, OnCommand=cmd(blend,10;zwrite,1;zoomto,0,0;) },
			Def.Quad{ InitCommand=function(self) muffet_gbox = self end, OnCommand=cmd(ztest,1;zoomto,8,8;) },
			Def.ActorFrame{
				OnCommand=cmd(ztestmode,2),
				MLines,
				
				LoadActor("heart")..{ InitCommand=function(self) self:SetTextureFiltering(false); end,
				OnCommand=cmd(visible,true;animate,0;zoom,0;setstate,0;sleep,0.02;queuecommand,"SetMe"),
				SetMeCommand=function(self) table.insert(muffet_hearts,self); self:x(muffet_posx[1]); self:y(muffet_spacingy*muffet_posy[1]) end,},
				LoadActor("heart")..{ InitCommand=function(self) self:SetTextureFiltering(false); end,
				OnCommand=cmd(visible,true;animate,0;zoom,0;setstate,2;sleep,0.02;queuecommand,"SetMe"),
				SetMeCommand=function(self) table.insert(muffet_hearts,self); self:x(muffet_posx[2]); self:y(muffet_spacingy*muffet_posy[2]) end,},
				
				Def.Quad{ OnCommand=cmd(vertalign,bottom;diffuse,0.55,0.08,0.5,1;zoomto,800,0;y,100;),
				InitCommand=function(self) muffet_purple = self end, },
				
			},
			
			MSpiders,
			MDonuts,
			MCroissants,
			MHeals,
			
			Def.ActorFrame{
				OnCommand=cmd(ztestmode,2;visible,false), HideCommand=cmd(visible,false),
				PetAwayMessageCommand=cmd(playcommand,"Do2";sleep,m_bl*4;queuecommand,"Hide"), PetPhase1MessageCommand=cmd(visible,true;playcommand,"Do1"),
				Def.Sprite{
					Texture="chara/pet/chomp 1x3.png",
					Frame0000=0,
					Delay0000=0.95,
					Frame0001=1,
					Delay0001=1,
					Frame0002=2,
					Delay0002=1,
					Frame0003=1,
					Delay0003=1,
					Frame0004=0,
					Delay0004=0.05,
					InitCommand=function(self) self:SetTextureFiltering(false); end,
					OnCommand=cmd(y,200;bob;effectclock,"bgm";effectperiod,16;effectmagnitude,0,-20,0),
					PetPhase2MessageCommand=cmd(sleep,m_bl*2;linear,m_bl*4;y,130;),
					Do2Command=cmd(linear,m_bl*4;y,200;),
				},
				LoadActor( "chara/pet/pet_roar" )..{
					InitCommand=function(self) self:SetTextureFiltering(false); end,
					OnCommand=cmd(cropleft,0.05;x,220;animate,0;vibrate;effectmagnitude,2,2,0), HideCommand=cmd(visible,false),
					Do1Command=cmd(visible,true;linear,m_bl*2;x,80;), PetPhase2MessageCommand=cmd(linear,m_bl*2;x,220;sleep,0;queuecommand,"Hide"),
					OpenMouthMessageCommand=cmd(setstate,1;), Do2Command=cmd(setstate,0;),
				},
			
			},
			
			Def.Quad{
				OnCommand=cmd(ztestmode,2;zoomto,SCREEN_WIDTH,SCREEN_HEIGHT;diffuse,0,0,0,0),
				EndingMessageCommand=cmd(linear,1;diffusealpha,1),
			},
			
			LoadActor( "fite" )..{ InitCommand=function(self) muffet_btn1 = self end, OnCommand=cmd(x,-160;y,-30;diffusealpha,0;animate,0;),
			ShowChoicesMessageCommand=cmd(linear,0.25;diffusealpha,1;), },
			LoadActor( "mercy" )..{ InitCommand=function(self) muffet_btn2 = self end, OnCommand=cmd(x,160;y,-30;diffusealpha,0;animate,0;setstate,1;),
			ShowChoicesMessageCommand=cmd(linear,0.25;diffusealpha,1;), },
			
			Def.Sprite{
				Texture="red 4x4.png",
				Frame0000=0,
				Delay0000=0.0625,
				Frame0001=1,
				Delay0001=0.0625,
				Frame0002=2,
				Delay0002=0.0625,
				Frame0003=3,
				Delay0003=0.0625,
				Frame0004=4,
				Delay0004=0.0625,
				Frame0005=5,
				Delay0005=0.0625,
				Frame0006=6,
				Delay0006=0.0625,
				Frame0007=7,
				Delay0007=0.0625,
				Frame0008=8,
				Delay0008=0.0625,
				Frame0009=9,
				Delay0009=0.0625,
				Frame0010=10,
				Delay0010=0.0625,
				Frame0011=11,
				Delay0011=0.0625,
				Frame0012=12,
				Delay0012=0.0625,
				Frame0013=13,
				Delay0013=0.0625,
				Frame0014=14,
				Delay0014=0.0625,
				Frame0015=15,
				Delay0015=0.0625,
				OnCommand=cmd(diffusealpha,0;x,-160-30;y,30;zoom,0.7;rotationz,90;pulse;effectperiod,2;effectclock,"bgm";effectmagnitude,1.1,1,0),
				ShowChoicesMessageCommand=cmd(linear,0.25;diffusealpha,1;),
			},
			Def.Sprite{
				Texture="red 4x4.png",
				Frame0000=0,
				Delay0000=0.0625,
				Frame0001=1,
				Delay0001=0.0625,
				Frame0002=2,
				Delay0002=0.0625,
				Frame0003=3,
				Delay0003=0.0625,
				Frame0004=4,
				Delay0004=0.0625,
				Frame0005=5,
				Delay0005=0.0625,
				Frame0006=6,
				Delay0006=0.0625,
				Frame0007=7,
				Delay0007=0.0625,
				Frame0008=8,
				Delay0008=0.0625,
				Frame0009=9,
				Delay0009=0.0625,
				Frame0010=10,
				Delay0010=0.0625,
				Frame0011=11,
				Delay0011=0.0625,
				Frame0012=12,
				Delay0012=0.0625,
				Frame0013=13,
				Delay0013=0.0625,
				Frame0014=14,
				Delay0014=0.0625,
				Frame0015=15,
				Delay0015=0.0625,
				OnCommand=cmd(diffusealpha,0;x,160-30;y,30;zoom,0.7;rotationz,-90;pulse;effectperiod,2;effectclock,"bgm";effectmagnitude,1.1,1,0),
				ShowChoicesMessageCommand=cmd(linear,0.25;diffusealpha,1;),
			},
			
			Def.BitmapText{
				File="Common normal",
				Text="0",
				InitCommand=function(self) muffet_vote1 = self end,
				OnCommand=cmd(diffusealpha,0;x,-160+30;y,30),
				ShowChoicesMessageCommand=cmd(linear,0.25;diffusealpha,1;),
			},
			Def.BitmapText{
				File="Common normal",
				Text="0",
				InitCommand=function(self) muffet_vote2 = self end,
				OnCommand=cmd(diffusealpha,0;x,160+30;y,30),
				ShowChoicesMessageCommand=cmd(linear,0.25;diffusealpha,1;),
			},
			
			Def.BitmapText{
				File="Common normal",
				Text="",
				InitCommand=function(self) muffet_votetimer = self end,
				OnCommand=cmd(diffuse,1,0,0,1),
			},
			
			Def.BitmapText{
				Font="Common normal",
				Text="",
				InitCommand=function(self) muffet_flairtext1 = self end,
				OnCommand=cmd(diffuse,1,1,0,0;x,-200;y,-114;zoom,1;shadowlength,0;),
				ShowChoicesMessageCommand=cmd(linear,0.25;diffusealpha,1;),
			},
			Def.BitmapText{
				Font="Common normal",
				Text="",
				InitCommand=function(self) muffet_flairtext2 = self end,
				OnCommand=cmd(diffuse,1,1,0,0;x,200;y,-114;zoom,1;shadowlength,0;),
				ShowChoicesMessageCommand=cmd(linear,0.25;diffusealpha,1;),
			},
			
			Def.Quad{
				OnCommand=cmd(ztestmode,2;zoomto,SCREEN_WIDTH,SCREEN_HEIGHT;diffuse,0,0,0,0),
				ut_LOVEMessageCommand=cmd(linear,1;diffusealpha,1),
			},
			LoadActor( "love" )..{
				OnCommand=cmd(diffusealpha,0;),
				ut_LOVEMessageCommand=cmd(sleep,1;linear,1;diffusealpha,1;),
			},
			
		},
	},
	
	LoadActor( "chara" )..{ OnCommand=function(self) self:ztest(1) end },
	
	LoadActor( "text" )..{ InitCommand=function(self) muffet_textbox = self end, },
	
	LoadActor("p_dancing.lua")..{Condition=GAMESTATE:IsPlayerEnabled(PLAYER_1), OnCommand=cmd(x,-100;y,SCREEN_CENTER_Y-96;zoom,1.8;effectclock,"bgm"),
	Spdr1MessageCommand=cmd(decelerate,m_bl;x,(SCREEN_CENTER_X-160)+(muffet_srng[1]*1);), SpdrAwayMessageCommand=cmd(accelerate,m_bl*2;x,-100)},
	LoadActor("p_dancing.lua")..{Condition=GAMESTATE:IsPlayerEnabled(PLAYER_2), OnCommand=cmd(x,SCREEN_WIDTH+100;y,SCREEN_CENTER_Y-96;zoom,1.8;effectclock,"bgm"),
	Spdr1MessageCommand=cmd(decelerate,m_bl;x,(SCREEN_CENTER_X+160)+(muffet_srng[1]*-1);), SpdrAwayMessageCommand=cmd(accelerate,m_bl*2;x,SCREEN_WIDTH+100)},
	LoadActor("p_dancing.lua")..{Condition=GAMESTATE:IsPlayerEnabled(PLAYER_1), OnCommand=cmd(x,-100;y,SCREEN_CENTER_Y-32;zoom,1.8;effectclock,"bgm"),
	Spdr2MessageCommand=cmd(decelerate,m_bl;x,(SCREEN_CENTER_X-160)+(muffet_srng[2]*1);), SpdrAwayMessageCommand=cmd(accelerate,m_bl*2;x,-100)},
	LoadActor("p_dancing.lua")..{Condition=GAMESTATE:IsPlayerEnabled(PLAYER_2), OnCommand=cmd(x,SCREEN_WIDTH+100;y,SCREEN_CENTER_Y-32;zoom,1.8;effectclock,"bgm"),
	Spdr2MessageCommand=cmd(decelerate,m_bl;x,(SCREEN_CENTER_X+160)+(muffet_srng[2]*-1);), SpdrAwayMessageCommand=cmd(accelerate,m_bl*2;x,SCREEN_WIDTH+100)},
	LoadActor("p_dancing.lua")..{Condition=GAMESTATE:IsPlayerEnabled(PLAYER_1), OnCommand=cmd(x,-100;y,SCREEN_CENTER_Y+32;zoom,1.8;effectclock,"bgm"),
	Spdr3MessageCommand=cmd(decelerate,m_bl;x,(SCREEN_CENTER_X-160)+(muffet_srng[3]*1);), SpdrAwayMessageCommand=cmd(accelerate,m_bl*2;x,-100)},
	LoadActor("p_dancing.lua")..{Condition=GAMESTATE:IsPlayerEnabled(PLAYER_2), OnCommand=cmd(x,SCREEN_WIDTH+100;y,SCREEN_CENTER_Y+32;zoom,1.8;effectclock,"bgm"),
	Spdr3MessageCommand=cmd(decelerate,m_bl;x,(SCREEN_CENTER_X+160)+(muffet_srng[3]*-1);), SpdrAwayMessageCommand=cmd(accelerate,m_bl*2;x,SCREEN_WIDTH+100)},
	LoadActor("p_dancing.lua")..{Condition=GAMESTATE:IsPlayerEnabled(PLAYER_1), OnCommand=cmd(x,-100;y,SCREEN_CENTER_Y+96;zoom,1.8;effectclock,"bgm"),
	Spdr4MessageCommand=cmd(decelerate,m_bl;x,(SCREEN_CENTER_X-160)+(muffet_srng[4]*1);), SpdrAwayMessageCommand=cmd(accelerate,m_bl*2;x,-100)},
	LoadActor("p_dancing.lua")..{Condition=GAMESTATE:IsPlayerEnabled(PLAYER_2), OnCommand=cmd(x,SCREEN_WIDTH+100;y,SCREEN_CENTER_Y+96;zoom,1.8;effectclock,"bgm"),
	Spdr4MessageCommand=cmd(decelerate,m_bl;x,(SCREEN_CENTER_X+160)+(muffet_srng[4]*-1);), SpdrAwayMessageCommand=cmd(accelerate,m_bl*2;x,SCREEN_WIDTH+100)},
	LoadActor("p_dancing.lua")..{Condition=GAMESTATE:IsPlayerEnabled(PLAYER_1), OnCommand=cmd(x,-100;y,SCREEN_CENTER_Y-64;zoom,1.8;effectclock,"bgm"),
	Spdr5MessageCommand=cmd(decelerate,m_bl;x,(SCREEN_CENTER_X-160)+(muffet_srng[5]*1);), SpdrAwayMessageCommand=cmd(accelerate,m_bl*2;x,-100)},
	LoadActor("p_dancing.lua")..{Condition=GAMESTATE:IsPlayerEnabled(PLAYER_2), OnCommand=cmd(x,SCREEN_WIDTH+100;y,SCREEN_CENTER_Y-64;zoom,1.8;effectclock,"bgm"),
	Spdr5MessageCommand=cmd(decelerate,m_bl;x,(SCREEN_CENTER_X+160)+(muffet_srng[5]*-1);), SpdrAwayMessageCommand=cmd(accelerate,m_bl*2;x,SCREEN_WIDTH+100)},
	LoadActor("p_dancing.lua")..{Condition=GAMESTATE:IsPlayerEnabled(PLAYER_1), OnCommand=cmd(x,-100;y,SCREEN_CENTER_Y+64;zoom,1.8;effectclock,"bgm"),
	Spdr6MessageCommand=cmd(decelerate,m_bl;x,(SCREEN_CENTER_X-160)+(muffet_srng[6]*1);), SpdrAwayMessageCommand=cmd(accelerate,m_bl*2;x,-100)},
	LoadActor("p_dancing.lua")..{Condition=GAMESTATE:IsPlayerEnabled(PLAYER_2), OnCommand=cmd(x,SCREEN_WIDTH+100;y,SCREEN_CENTER_Y+64;zoom,1.8;effectclock,"bgm"),
	Spdr6MessageCommand=cmd(decelerate,m_bl;x,(SCREEN_CENTER_X+160)+(muffet_srng[6]*-1);), SpdrAwayMessageCommand=cmd(accelerate,m_bl*2;x,SCREEN_WIDTH+100)},
	
	LoadActor("p_dancing.lua")..{Condition=GAMESTATE:IsPlayerEnabled(PLAYER_1), OnCommand=cmd(x,-100;y,SCREEN_CENTER_Y-96;zoom,1.8;effectclock,"bgm"),
	Spdr1BMessageCommand=cmd(decelerate,m_bl;x,(SCREEN_CENTER_X-160)+(muffet_srng2[1]*1);), SpdrAwayBMessageCommand=cmd(accelerate,m_bl*2;x,-100)},
	LoadActor("p_dancing.lua")..{Condition=GAMESTATE:IsPlayerEnabled(PLAYER_2), OnCommand=cmd(x,SCREEN_WIDTH+100;y,SCREEN_CENTER_Y-96;zoom,1.8;effectclock,"bgm"),
	Spdr1BMessageCommand=cmd(decelerate,m_bl;x,(SCREEN_CENTER_X+160)+(muffet_srng2[1]*-1);), SpdrAwayBMessageCommand=cmd(accelerate,m_bl*2;x,SCREEN_WIDTH+100)},
	LoadActor("p_dancing.lua")..{Condition=GAMESTATE:IsPlayerEnabled(PLAYER_1), OnCommand=cmd(x,-100;y,SCREEN_CENTER_Y-32;zoom,1.8;effectclock,"bgm"),
	Spdr2BMessageCommand=cmd(decelerate,m_bl;x,(SCREEN_CENTER_X-160)+(muffet_srng2[2]*1);), SpdrAwayBMessageCommand=cmd(accelerate,m_bl*2;x,-100)},
	LoadActor("p_dancing.lua")..{Condition=GAMESTATE:IsPlayerEnabled(PLAYER_2), OnCommand=cmd(x,SCREEN_WIDTH+100;y,SCREEN_CENTER_Y-32;zoom,1.8;effectclock,"bgm"),
	Spdr2BMessageCommand=cmd(decelerate,m_bl;x,(SCREEN_CENTER_X+160)+(muffet_srng2[2]*-1);), SpdrAwayBMessageCommand=cmd(accelerate,m_bl*2;x,SCREEN_WIDTH+100)},
	LoadActor("p_dancing.lua")..{Condition=GAMESTATE:IsPlayerEnabled(PLAYER_1), OnCommand=cmd(x,-100;y,SCREEN_CENTER_Y+32;zoom,1.8;effectclock,"bgm"),
	Spdr3BMessageCommand=cmd(decelerate,m_bl;x,(SCREEN_CENTER_X-160)+(muffet_srng2[3]*1);), SpdrAwayBMessageCommand=cmd(accelerate,m_bl*2;x,-100)},
	LoadActor("p_dancing.lua")..{Condition=GAMESTATE:IsPlayerEnabled(PLAYER_2), OnCommand=cmd(x,SCREEN_WIDTH+100;y,SCREEN_CENTER_Y+32;zoom,1.8;effectclock,"bgm"),
	Spdr3BMessageCommand=cmd(decelerate,m_bl;x,(SCREEN_CENTER_X+160)+(muffet_srng2[3]*-1);), SpdrAwayBMessageCommand=cmd(accelerate,m_bl*2;x,SCREEN_WIDTH+100)},
	LoadActor("p_dancing.lua")..{Condition=GAMESTATE:IsPlayerEnabled(PLAYER_1), OnCommand=cmd(x,-100;y,SCREEN_CENTER_Y+96;zoom,1.8;effectclock,"bgm"),
	Spdr4BMessageCommand=cmd(decelerate,m_bl;x,(SCREEN_CENTER_X-160)+(muffet_srng2[4]*1);), SpdrAwayBMessageCommand=cmd(accelerate,m_bl*2;x,-100)},
	LoadActor("p_dancing.lua")..{Condition=GAMESTATE:IsPlayerEnabled(PLAYER_2), OnCommand=cmd(x,SCREEN_WIDTH+100;y,SCREEN_CENTER_Y+96;zoom,1.8;effectclock,"bgm"),
	Spdr4BMessageCommand=cmd(decelerate,m_bl;x,(SCREEN_CENTER_X+160)+(muffet_srng2[4]*-1);), SpdrAwayBMessageCommand=cmd(accelerate,m_bl*2;x,SCREEN_WIDTH+100)},
	LoadActor("p_dancing.lua")..{Condition=GAMESTATE:IsPlayerEnabled(PLAYER_1), OnCommand=cmd(x,-100;y,SCREEN_CENTER_Y-64;zoom,1.8;effectclock,"bgm"),
	Spdr5BMessageCommand=cmd(decelerate,m_bl;x,(SCREEN_CENTER_X-160)+(muffet_srng2[5]*1);), SpdrAwayBMessageCommand=cmd(accelerate,m_bl*2;x,-100)},
	LoadActor("p_dancing.lua")..{Condition=GAMESTATE:IsPlayerEnabled(PLAYER_2), OnCommand=cmd(x,SCREEN_WIDTH+100;y,SCREEN_CENTER_Y-64;zoom,1.8;effectclock,"bgm"),
	Spdr5BMessageCommand=cmd(decelerate,m_bl;x,(SCREEN_CENTER_X+160)+(muffet_srng2[5]*-1);), SpdrAwayBMessageCommand=cmd(accelerate,m_bl*2;x,SCREEN_WIDTH+100)},
	LoadActor("p_dancing.lua")..{Condition=GAMESTATE:IsPlayerEnabled(PLAYER_1), OnCommand=cmd(x,-100;y,SCREEN_CENTER_Y+64;zoom,1.8;effectclock,"bgm"),
	Spdr6BMessageCommand=cmd(decelerate,m_bl;x,(SCREEN_CENTER_X-160)+(muffet_srng2[6]*1);), SpdrAwayBMessageCommand=cmd(accelerate,m_bl*2;x,-100)},
	LoadActor("p_dancing.lua")..{Condition=GAMESTATE:IsPlayerEnabled(PLAYER_2), OnCommand=cmd(x,SCREEN_WIDTH+100;y,SCREEN_CENTER_Y+64;zoom,1.8;effectclock,"bgm"),
	Spdr6BMessageCommand=cmd(decelerate,m_bl;x,(SCREEN_CENTER_X+160)+(muffet_srng2[6]*-1);), SpdrAwayBMessageCommand=cmd(accelerate,m_bl*2;x,SCREEN_WIDTH+100)},
	
	Def.ActorFrame{
		OnCommand=cmd(x,SCREEN_CENTER_X;y,SCREEN_BOTTOM+40),
		ShowBarMessageCommand=cmd(linear,m_bl;y,SCREEN_BOTTOM-40;),
		HideBarMessageCommand=cmd(linear,m_bl;y,SCREEN_BOTTOM+40;),
		Def.Quad{ OnCommand=cmd(horizalign,left;x,-(SCREEN_WIDTH*0.25)-30;zoomto,60,20;diffuse,1,0,0,1;queuecommand,"SetMe"),
		SetMeCommand=function(self) if not GAMESTATE:IsPlayerEnabled(PLAYER_1) then self:visible(false) end end, },
		Def.Quad{ OnCommand=cmd(horizalign,left;x,(SCREEN_WIDTH*0.25)-30;zoomto,60,20;diffuse,1,0,0,1;queuecommand,"SetMe"),
		SetMeCommand=function(self) if not GAMESTATE:IsPlayerEnabled(PLAYER_2) then self:visible(false) end end, },
		Def.Quad{ OnCommand=cmd(horizalign,left;x,-(SCREEN_WIDTH*0.25)-30;zoomto,60,20;diffuse,1,1,0,1;sleep,0.02;queuecommand,"SetMe"),
		SetMeCommand=function(self) table.insert(muffet_lifebars,self) end, },
		Def.Quad{ OnCommand=cmd(horizalign,left;x,(SCREEN_WIDTH*0.25)-30;zoomto,60,20;diffuse,1,1,0,1;sleep,0.02;queuecommand,"SetMe"),
		SetMeCommand=function(self) table.insert(muffet_lifebars,self) end, },
	},
	
	Def.Quad{
		OnCommand=cmd(x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;zoomto,SCREEN_WIDTH,SCREEN_HEIGHT;diffuse,0,0,0,0),
		WhiteFlashLongMessageCommand=cmd(diffuse,1,1,1,1;linear,3;diffusealpha,0),
		WhiteFlashMessageCommand=cmd(diffuse,1,1,1,1;linear,1;diffusealpha,0),
		RedFlashMessageCommand=cmd(diffuse,1,0,0,1;linear,1;diffusealpha,0),
		RedFlashQMessageCommand=cmd(diffuse,1,0,0,0.6;linear,0.6;diffusealpha,0),
	},
	
	Def.Quad{
		OnCommand=cmd(x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;zoomto,SCREEN_WIDTH,SCREEN_HEIGHT;diffuse,0,0,0,0),
		GameOverMessageCommand=function(self) Sound('die1'); self:diffusealpha(1); self:sleep(1.9); self:queuecommand('Sound2') end,
		Sound2Command=function(self) Sound('die2'); self:sleep(0.1); self:queuemessage('DieStuff'); self:sleep(3); self:queuecommand('EndIt') end,
		EndItCommand=function(self)
			--ITG
			--SCREENMAN:SetNewScreen(SongSelectionScreen());
			--SM5
			if GAMESTATE:IsPlayerEnabled(PLAYER_1) then
				local pss = STATSMAN:GetCurStageStats():GetPlayerStageStats(PLAYER_1);
				if pss then
					pss:FailPlayer()
				end
			end
			if GAMESTATE:IsPlayerEnabled(PLAYER_2) then
				local pss = STATSMAN:GetCurStageStats():GetPlayerStageStats(PLAYER_2);
				if pss then
					pss:FailPlayer()
				end
			end
			SCREENMAN:GetTopScreen():StartTransitioningScreen("SM_DoNextScreen")
		end,
	},
	
	Def.ActorFrame{
		LoadActor("heart")..{
			InitCommand=function(self) self:SetTextureFiltering(false); end,
			OnCommand=cmd(visible,false;animate,0;zoom,0.75;setstate,1;x,SCREEN_CENTER_X-160;y,SCREEN_CENTER_Y+80;),
			GameOverMessageCommand=cmd(visible,true;sleep,2;queuecommand,"Hide"), HideCommand=cmd(visible,false),
			Condition=GAMESTATE:IsPlayerEnabled(PLAYER_1),
		},
		LoadActor("heart")..{
			InitCommand=function(self) self:SetTextureFiltering(false); end,
			OnCommand=cmd(visible,false;animate,0;zoom,0.75;setstate,3;x,SCREEN_CENTER_X+160;y,SCREEN_CENTER_Y+80;),
			GameOverMessageCommand=cmd(visible,true;sleep,2;queuecommand,"Hide"), HideCommand=cmd(visible,false),
			Condition=GAMESTATE:IsPlayerEnabled(PLAYER_2),
		},
		
		Def.ActorFrame{
			OnCommand=cmd(visible,false;x,SCREEN_CENTER_X-160;y,SCREEN_CENTER_Y+80;), Condition=GAMESTATE:IsPlayerEnabled(PLAYER_1),
			DieStuffMessageCommand=cmd(visible,true;playcommand,"D"),
			Def.ActorFrame{ DCommand=cmd(accelerate,2;addy,SCREEN_BOTTOM;playcommand,"D2"),
				Def.Quad{ OnCommand=cmd(x,math.random(0,20)-10;y,math.random(0,20)-10;zoomto,10,6;diffuse,0.72,0.11,0.65,1;),
				D2Command=cmd(linear,2;addx,math.random(0,400)-200;addy,math.random(0,400)-200;rotationx,1000;rotationy,1000;rotationz,1000;), },
				Def.Quad{ OnCommand=cmd(x,math.random(0,20)-10;y,math.random(0,20)-10;zoomto,10,6;diffuse,0.72,0.11,0.65,1;),
				D2Command=cmd(linear,2;addx,math.random(0,400)-200;addy,math.random(0,400)-200;rotationx,1000;rotationy,1000;rotationz,1000;), },
				Def.Quad{ OnCommand=cmd(x,math.random(0,20)-10;y,math.random(0,20)-10;zoomto,10,6;diffuse,0.72,0.11,0.65,1;),
				D2Command=cmd(linear,2;addx,math.random(0,400)-200;addy,math.random(0,400)-200;rotationx,1000;rotationy,1000;rotationz,1000;), },
				Def.Quad{ OnCommand=cmd(x,math.random(0,20)-10;y,math.random(0,20)-10;zoomto,10,6;diffuse,0.72,0.11,0.65,1;),
				D2Command=cmd(linear,2;addx,math.random(0,400)-200;addy,math.random(0,400)-200;rotationx,1000;rotationy,1000;rotationz,1000;), },
				Def.Quad{ OnCommand=cmd(x,math.random(0,20)-10;y,math.random(0,20)-10;zoomto,10,6;diffuse,0.72,0.11,0.65,1;),
				D2Command=cmd(linear,2;addx,math.random(0,400)-200;addy,math.random(0,400)-200;rotationx,1000;rotationy,1000;rotationz,1000;), },
				Def.Quad{ OnCommand=cmd(x,math.random(0,20)-10;y,math.random(0,20)-10;zoomto,10,6;diffuse,0.72,0.11,0.65,1;),
				D2Command=cmd(linear,2;addx,math.random(0,400)-200;addy,math.random(0,400)-200;rotationx,1000;rotationy,1000;rotationz,1000;), },
			},
		},
		Def.ActorFrame{
			OnCommand=cmd(visible,false;x,SCREEN_CENTER_X+160;y,SCREEN_CENTER_Y+80;), Condition=GAMESTATE:IsPlayerEnabled(PLAYER_2),
			DieStuffMessageCommand=cmd(visible,true;playcommand,"D"),
			Def.ActorFrame{ DCommand=cmd(accelerate,2;addy,SCREEN_BOTTOM;playcommand,"D2"),
				Def.Quad{ OnCommand=cmd(x,math.random(0,20)-10;y,math.random(0,20)-10;zoomto,10,6;diffuse,0.72,0.11,0.65,1;),
				D2Command=cmd(linear,2;addx,math.random(0,400)-200;addy,math.random(0,400)-200;rotationx,1000;rotationy,1000;rotationz,1000;), },
				Def.Quad{ OnCommand=cmd(x,math.random(0,20)-10;y,math.random(0,20)-10;zoomto,10,6;diffuse,0.72,0.11,0.65,1;),
				D2Command=cmd(linear,2;addx,math.random(0,400)-200;addy,math.random(0,400)-200;rotationx,1000;rotationy,1000;rotationz,1000;), },
				Def.Quad{ OnCommand=cmd(x,math.random(0,20)-10;y,math.random(0,20)-10;zoomto,10,6;diffuse,0.72,0.11,0.65,1;),
				D2Command=cmd(linear,2;addx,math.random(0,400)-200;addy,math.random(0,400)-200;rotationx,1000;rotationy,1000;rotationz,1000;), },
				Def.Quad{ OnCommand=cmd(x,math.random(0,20)-10;y,math.random(0,20)-10;zoomto,10,6;diffuse,0.72,0.11,0.65,1;),
				D2Command=cmd(linear,2;addx,math.random(0,400)-200;addy,math.random(0,400)-200;rotationx,1000;rotationy,1000;rotationz,1000;), },
				Def.Quad{ OnCommand=cmd(x,math.random(0,20)-10;y,math.random(0,20)-10;zoomto,10,6;diffuse,0.72,0.11,0.65,1;),
				D2Command=cmd(linear,2;addx,math.random(0,400)-200;addy,math.random(0,400)-200;rotationx,1000;rotationy,1000;rotationz,1000;), },
				Def.Quad{ OnCommand=cmd(x,math.random(0,20)-10;y,math.random(0,20)-10;zoomto,10,6;diffuse,0.72,0.11,0.65,1;),
				D2Command=cmd(linear,2;addx,math.random(0,400)-200;addy,math.random(0,400)-200;rotationx,1000;rotationy,1000;rotationz,1000;), },
			},
		},
	},
	
	Def.Quad{
		OnCommand=cmd(x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;zoomto,SCREEN_WIDTH,SCREEN_HEIGHT;diffuse,0,0,0,0),
		ButNobodyCameMessageCommand=cmd(diffusealpha,1);
	},
	LoadActor('nobody')..{
		OnCommand=cmd(cropright,1;x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y),
		ButNobodyCameMessageCommand=cmd(linear,0.5;cropright,0),
	},
}